#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


int semid;

union semun
{
    int val;
    struct semid_ds *buff;
    ushort *array;
};

int main()
{
    srand(time(NULL));
    key_t kljuc;
    kljuc = ftok("./Igrac.c", 20);
    union semun arg;
    struct sembuf P1, V1, P2, V2, P3, V3, P4, V4, P5, V5, P6, V6;
    int *shm1, shm2, shm3, i, n, ind, sut, pogodak;
    int *stalak, **kosevi, *maxBr;
    key_t k1, k2, k3;

    k1 = ftok("./Igrac.c", 10);
    k2 = ftok("./Igrac.c", 11);
    k3 = ftok("./Igrac.c", 12);

    semid = semget(kljuc, 6, 0666 | IPC_CREAT | IPC_EXCL);
    
    shm1 = (int*)calloc(4, sizeof(int));
    shm2 = shmget(k2, sizeof(int), 0666 | IPC_CREAT);   //stalak
    shm3 = shmget(k3, sizeof(int), 0666 | IPC_CREAT);   //max broj lopti u stalku

    kosevi = (int**)malloc(4*sizeof(int*));
    stalak = shmat(shm2, NULL, 0);
    maxBr = shmat(shm3, NULL, 0);

    if(semid != -1)
    {
        arg.val = 1;
        semctl(semid, 0, SETVAL, arg);  //stalak
        semctl(semid, 1, SETVAL, arg);  //kos1
        semctl(semid, 2, SETVAL, arg);  //kos2
        semctl(semid, 3, SETVAL, arg);  //kos3
        semctl(semid, 4, SETVAL, arg);  //kos4
        semctl(semid, 5, SETVAL, arg);  //pom
    }
    else if(errno == EEXIST)
    {
        semid = semget(kljuc, 2, 0);
    }
    else
    {
        printf("Greska.\n");
        exit(0);
    }

    for(i = 0; i < 4; i++)
    {
        k1 = ftok("./Igrac.c", i+1);
        shm1[i] = shmget(k1, sizeof(int), 0666 | IPC_CREAT);
        kosevi[i] = shmat(shm1[i], NULL, 0);
    }

    P1.sem_num = 0; P1.sem_op = -1; P1.sem_flg = 0; //stalak
    V1.sem_num = 0; V1.sem_op = 1; V1.sem_flg = 0; //stalak

    P6.sem_num = 5; P6.sem_op = -1; P6.sem_flg = 0; 
    V6.sem_num = 5; V6.sem_op = 1; V6.sem_flg = 0; 

    

    ind = semop(semid, &P1, 1);
    if(ind == -1) return 0;

    *stalak = n;

    ind = semop(semid, &V1, 1);
    if(ind == -1) return 0;

    ind = semop(semid, &P6, 1);
    if(ind == -1) return 0;

    *maxBr = n;

    ind = semop(semid, &V6, 1);
    if(ind == -1) return 0;


    while(1)
    {
        ind = semop(semid, &P1, 1);
        if(ind == -1) return 0;

        
        ind = semop(semid, &P6, 1);
        if(ind == -1) return 0;

        if(*stalak < *maxBr)
        {
            (*stalak)++;
            printf("Vracam loptu na stalak.\n");
            sleep(2);
        }
        
        ind = semop(semid, &V6, 1);
        if(ind == -1) return 0;

        ind = semop(semid, &V1, 1);
        if(ind == -1) return 0;
    }

    return 0;
}