#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid,shmid,shmid1,shmid2,shmid3,shmid4;
int *stalak;
int *kos1,*kos2,*kos3,*kos4;
union semun {
int val;
/* used for SETVAL only */
struct semid_ds *buf; /* used for IPC_STAT and IPC_SET */
ushort *array;
/* used for GETALL and SETALL */
};

void signal_handler(int sig)
{
	printf("Kraj...\n");
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	shmdt(stalak);
	shmdt(kos1);
	shmdt(kos2);
	shmdt(kos3);
	shmdt(kos4);
	shmctl(shmid,IPC_RMID,NULL);
	shmctl(shmid1,IPC_RMID,NULL);
	shmctl(shmid2,IPC_RMID,NULL);
	shmctl(shmid3,IPC_RMID,NULL);
	shmctl(shmid4,IPC_RMID,NULL);
	exit(0);
}

int main()
{
	srand(time(NULL));
	int ind;
	
	signal(SIGINT,signal_handler);
	union semun operacija_nad_sem;
	struct sembuf opr_p,opr_s;
	key_t kljuc,kljuc1,kljuc2,kljuc3,kljuc4;
	kljuc=ftok("./kos.c",9);
	kljuc1=ftok("./kos1.c",1);
	kljuc2=ftok("./kos2.c",2);
	kljuc3=ftok("./kos3.c",3);
	kljuc4=ftok("./kos4.c",4);
	
	semid=semget(kljuc,3,0644|IPC_CREAT|IPC_EXCL);
	
	shmid=shmget(kljuc,1024,0644|IPC_CREAT);
	stalak=shmat(shmid,NULL,0);
	
	shmid1=shmget(kljuc1,1024,0644|IPC_CREAT);
	kos1=shmat(shmid1,NULL,0);
	
	shmid2=shmget(kljuc2,1024,0644|IPC_CREAT);
	kos2=shmat(shmid2,NULL,0);
	
	shmid3=shmget(kljuc3,1024,0644|IPC_CREAT);
	kos3=shmat(shmid3,NULL,0);
	
	shmid4=shmget(kljuc4,1024,0644|IPC_CREAT);
	kos4=shmat(shmid4,NULL,0);
	
	if(semid!=-1)
	{
		operacija_nad_sem.val=1;
		semctl(semid,0,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,1,SETVAL,operacija_nad_sem);
		semctl(semid,2,SETVAL,operacija_nad_sem);
	}
	else if(errno==EEXIST)
	{
		semid=semget(kljuc,3,0);
	}
	else
	{
		printf("Greska\n");
		exit(0);
	}
	
	
	opr_s.sem_num=2;
	opr_s.sem_op=-1;
	opr_s.sem_flg=0;
	
	opr_p.sem_num=1;
	opr_p.sem_op=1;
	opr_p.sem_flg=0;
	
	while(1)
	{
		ind=semop(semid,&opr_s,1);
		if(ind==-1) break;
		
		(*stalak)=(*stalak)+1;
		sleep(2);
		printf("Redar je pokupio loptu\n");
		
		ind=semop(semid,&opr_p,1);
		if(ind==-1) break;
		
		
		
		
	}
	
	
	
	
	

	return 0;
}
