#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void handler(int sig)
{
	
}

int main()
{
	key_t kljuc;
	int semid, *data,shmid, broj_kosa;
	union semun arg;
	struct sembuf smanji1, smanji2, povecaj;
	int br_koseva=0, kos, ind=0,n;
	
	printf("Ucitajte broj kosa na koji igrac sutira\n");
	scanf("%d",&broj_kosa);
	
	kljuc=ftok("./Igrac1.c", 24);
	shmid = shmget(kljuc, sizeof(int), 0644 | IPC_CREAT);
	data = shmat(shmid, NULL, 0);
	
	kljuc=ftok("./Igrac1.c", 27);
	semid=semget(kljuc, 2, 0666|IPC_CREAT|IPC_EXCL);
	
	if(semid!=-1)
	{
		scanf("%d",&n);
		*data=n;
		arg.val=1;
		semctl(semid, 0, SETVAL, arg);
		
		arg.val=*data;
		semctl(semid, 1, SETVAL, arg);
	}
	else if(errno==EEXIST)
	{
		semid=semget(kljuc, 2, 0);
	}
	else
	{
		printf("Doslo je do greske\n");
		exit(0);
	}
	
	smanji1.sem_num = 0;
	smanji1.sem_op = -1;
	smanji1.sem_flg = 0;
	
	smanji2.sem_num = 1;
	smanji2.sem_op = -1;
	smanji2.sem_flg = 0;
	
	povecaj.sem_num = 0;
	povecaj.sem_op = 1;
	povecaj.sem_flg = 0;
	
	int forka=fork();
	
	if(forka)//proces roditelj
	{
		while(1)
		{
			printf("Smanjujem semafor 0 iz skupa %d za vrednost -1\n", semid);
			sleep(3);
			semop(semid, &smanji1, 1);
			printf("Smanjujem semafor 1 iz skupa %d za vrednost -1\n", semid);
			sleep(3);
			semop(semid, &smanji2, 1);
			sleep(1);//uzeo sam loptu
			printf("Povecavam semafor 0 iz skupa %d za vrednost 1\n", semid);
			sleep(3);
			semop(semid, &povecaj, 1);
			
			sleep(3);//sutiram na kos
			kos=rand()%2;// nula-omasio, jedinica-dao
			if(kos)
			{
				br_koseva++;
			}
			else
			{
				ind=1;
			}
				
			printf("Smanjujem semafor 0 iz skupa %d za vrednost -1\n", semid);
			sleep(3);
			semop(semid, &smanji1, 1);
			printf("Smanjujem semafor 1 iz skupa %d za vrednost -1\n", semid);
			sleep(3);
			semop(semid, &smanji2, 1);
			sleep(1);//uzeo sam loptu
			printf("Povecavam semafor 0 iz skupa %d za vrednost 1\n", semid);
			sleep(3);
			semop(semid, &povecaj, 1);
			
			sleep(3);//sutiram na kos
			kos=rand()%2;// nula-omasio, jedinica-dao
			if(kos)
			{
				br_koseva++;
			}
			else if(!kos && ind)
			{
				kill(forka, SIGINT);
			}
				
			ind=0;
			
		}
	}
	else//proces dete
	{
		signal(SIGINT, handler);
		
		while(1)
		{
			sleep(10);
			printf("%d puta je lopta prosla kroz moj kos\n", br_koseva);
		}
	}
	
	
	return 0;
}
	
