#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pid;

void handler(int sig){
	if(pid == 0){
		printf("Prekinuo me je proces roditelj\n");
		exit(0);
	}
	else{
		printf("Prekinuo me je proces dete\n");
		exit(0);
	}
}

int main(){
	
	srand(time(NULL));
	
	int n,i;
	
	pid = fork();
	
	if(pid == -1){
		printf("fork greska\n");
		exit(1);
	}
	else if(pid == 0){		//dete
		signal(SIGINT,handler);
		n = rand()%20;
		n++;
		//n = 5;
		printf("DETE -----> N: %d\n",n);
		sleep(1);
		for(i=1;i<=n;i++){
			printf("DETE: %d\n",i);
			sleep(2);
		}
		kill(getppid(),SIGINT);
	}
	else{					//roditelj
		signal(SIGINT,handler);
		n = rand()%20;
		n++;
		//n = 7;
		printf("RODITELJ -> N: %d\n",n);
		sleep(1);
		for(i=1;i<=n;i++){
			printf("RODITELJ: %d\n",i);
			sleep(2);
		}
		kill(pid,SIGINT);
	}
	
	return 0;
}
