#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct porukica{
	long tip;
	long pid;
	int redniBroj;
	int brKlijenata;
	char tekst[100];
}porukica;

int main(){
	
	srand(time(NULL));
	
	key_t kljuc;
	int id_reda;
	porukica p;
	int n,i;
	int rnd;
	
	kljuc = ftok("./server.c",16);
	id_reda = msgget(kljuc,IPC_CREAT|0666);
	
	printf("Unesite n:\n");
	scanf("%d",&n);
	
	for(i=1;i<=n;i++){
		printf("CEKAM PORUKU: Tip: 100\n");
		msgrcv(id_reda,&p,sizeof(p),100,0);
		printf("PRIMLJENA PORUKA: Tip: %ld - Pid: %ld\n",p.tip,p.pid);
		p.redniBroj = i;
		p.tip = p.pid;
		printf("SALJEM PORUKU: Tip: %ld - Redni broj: %d\n",p.tip,p.redniBroj);
		msgsnd(id_reda,&p,sizeof(p),0);
		sleep(1);
	}
	
	for(i=1;i<=n;i++){
		p.tip = i + 50;
		p.brKlijenata = n;
		printf("SALJEM PORUKU: Tip: %ld - Broj klijenata: %d\n",p.tip,p.brKlijenata);
		msgsnd(id_reda,&p,sizeof(p),0);
		sleep(1);
	}
	
	rnd = rand()%n;
	rnd++;
	
	printf("\nSlucajno biram klijenta sa rednim brojem: %d\n",rnd);
	p.tip = rnd;
	p.redniBroj = 1000;
	printf("Unesite poruku:\n");
	scanf("%s",p.tekst);
	printf("SALJEM PORUKU: Tip: %ld - Redni broj: %d - Tekst: %s\n",p.tip,p.redniBroj,p.tekst);
	msgsnd(id_reda,&p,sizeof(p),0);
	sleep(1);

	return 0;
}
