#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct{
	long redni;
	
	int ukupno;

	char poruka[100];
   }mess;


int main()
{
	int red;
	long slucajno;
	char str[100];
	long mojredni;
	int N;
	key_t key;
	mess p1;
	
	key = ftok("server.c",65);
	red = msgget(key,IPC_CREAT|0666);
	
	printf("Cekam poruku (moj redni broj)\n");
	msgrcv(red,&p1,sizeof(p1.redni),0,0);
	
	mojredni = p1.redni;
	
	sleep(1); // ZBOG PREGLEDNOSTI
	
	printf("Cekam poruku (ukupan broj klijenata)\n");
	msgrcv(red,&p1,sizeof(p1.ukupno),mojredni,0); 
	printf("Moj redni broj: %ld.\n",mojredni);
	
	N = p1.ukupno;
	
	printf("\n\n");
	
	while(1)
	{
		printf("Cekam poruku\n");
		msgrcv(red,&p1,sizeof(p1.poruka),mojredni,0);
		printf("Primljeno: %s\n\n",p1.poruka);
		
		printf("Unesi poruku: \n");
		scanf("%s",str);
		
		strcpy(p1.poruka,str);
	
		slucajno = (long)(rand()%N);
		
		if(slucajno == mojredni)
		{
			while(slucajno == mojredni)
			{
				slucajno = (long)(rand()%N);
			}
		}
	
		p1.redni = slucajno;
	
		printf("Saljem poruku %s\n",p1.poruka);
		msgsnd(red,&p1,sizeof(p1.poruka),0);	
	
	}

}
