#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int pid;


void hendlerDete(int signal) {
	printf("prekinuo me je proces roditelj!\n");
	kill(SIGINT, signal);
	exit(0);
}

void hendlerRoditelj(int signal) {
	printf("prekinuo me je proces dete!\n");
	kill(SIGINT, signal);
	exit(0);
}


int main() {
	int i, n;	
	
	
	
	pid=fork();
	
	
	if(pid==-1) {
		printf("neuspelo kreiran proces dete!\n");
	}
	if(pid==0) {
		n = rand()%20+1;
		
		//printf("Dete proces generiso N: %d\n", n);
		
		for(i=1; i<=n; i++) {
			printf("dete %d, ", i);
			sleep(2);	
		}
		
		hendlerDete(SIGINT);	
	}
	else {
		n = rand()%20+1;
		
		//printf("Roditelj proces generisao N: %d\n", n);
		
		for(i=1; i<=n; i++) {
			printf("roditelj %d, ", i);
			sleep(2);
		}
		
		hendlerRoditelj(SIGINT);
	}
	
	return 0;
}

