#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct msgbuf {
	long mtype;
	char *mtext;
	int redni_broj;
	int ukupno;
};


int main() {
	int n, i;
	key_t kljuc;
	int id_reda;
	struct msgbuf poruka, poruka2;
	
	printf("Uneti N:");
	scanf("%d", &n);
	
	kljuc = ftok("./server.c", 1);
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
		
	poruka.mtype = 1;
	
	
	for(i=1; i<=n; i++) {
		printf("Cekam prijavu klijenta %d.\n", i);		
		sleep(1);
		
		msgrcv(id_reda, &poruka, sizeof(poruka), 2, 0);
		
		poruka.redni_broj=i;
		
		printf("Primljena prijava\n");
		
		printf("Dodeljujem redni broj klijentu %d\n", i);
		
		msgsnd(id_reda, &poruka, sizeof(poruka), 0);
		
		printf("Klijentu edodeljen %d redni broj\n\n", i);	
		
	}	

	poruka.ukupno = n;
	
	for(i=1; i<=n; i++) {
		poruka.mtext = "Ukupno je prijavljeno %d klijenata";
		msgsnd(id_reda, &poruka, sizeof(poruka), 0);
	}	
	
	
	
	
	return 0;
}
