#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<signal.h>
#include<sys/wait.h>
#include<time.h>

pid_t pid;

void signalHandlerD(int signal)
{
    printf("Dete : Prekinuo me je process roditelj.\n");
    exit(1);
}

void signalHandlerR(int signal)
{
    printf("Roditelj : Prekinuo me je process dete.\n");
    exit(1);
}

int main()
{
    int i, n, status;
    srand(time(NULL));

    pid = fork();


    if(pid == 0)
    {
        //dete
        signal(SIGINT, signalHandlerD);
        n = rand() % 20;
        //n = 3;
        printf("Dete: generisan broj je %d\n", n);
        
        for(i = 1; i <= n; i++)
        {
            printf("Dete: %d\n", i);
            sleep(2);
        }
        
        kill(getppid(), SIGINT);
        //sleep(10);
        //exit(0);
    }
    else
    {
        //roditelj
        signal(SIGINT, signalHandlerR);
        n = rand() % 20;
        //n = 5;
        printf("Roditelj: generisan broj je %d\n", n);
        
        for(i = 1; i <= n; i++)
        {
            printf("Roditelj: %d\n", i);
            sleep(2);
        }
        
        kill(pid, SIGINT);
        //wait(&status);
    }
    
    return 0;
}
