#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


typedef struct poruka
{
    long tip;
    int N;
    int redniBroj;
    pid_t pid;
    char tekst[100];
}poruka;


int main()
{
    int i, ind;
    key_t kljuc;
    int redid;
    poruka mojaPoruka;

    kljuc = ftok("./server.c", 33);
    redid = msgget(kljuc, 0666 | IPC_CREAT);

    mojaPoruka.tip = 27;
    mojaPoruka.pid = getpid();

    ind = msgsnd(redid, &mojaPoruka, sizeof(mojaPoruka), 0);
    if(ind == -1) return 0;

    ind = msgrcv(redid, &mojaPoruka, sizeof(mojaPoruka), mojaPoruka.pid, 0);
    if(ind == -1) return 0;

    printf("%d\n", mojaPoruka.redniBroj);
    int rbr = mojaPoruka.redniBroj;

    ind = msgrcv(redid, &mojaPoruka, sizeof(mojaPoruka), rbr, 0);
    printf("Primio sam N: %d\n", mojaPoruka.N);
    int N = mojaPoruka.N;

    printf("Cekam poruku..\n");
    ind = msgrcv(redid, &mojaPoruka, sizeof(mojaPoruka), rbr, 0);
    printf("Primio sam poruku %ld %s\n", mojaPoruka.tip, mojaPoruka.tekst);

    
    int r = rand() % N;
    
    while(r == rbr)
    {
        r = rand() % N;
    }

    scanf("%s", mojaPoruka.tekst);
    mojaPoruka.tip = r;

    msgsnd(redid, &mojaPoruka, sizeof(mojaPoruka), 0);

    return 0;
}