#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct msgbuf
{
	long mtype;
	char mtext[20];
	int rbr;
	int br;
};

int main()
{
	srand(time(NULL));
	key_t key;
	key = ftok("server.c",'A');

	int msgid;
	msgid = msgget(key, 0666);

	struct msgbuf msg;
	char string[20];
	msg.mtype = 21;
	msgsnd(msgid, &msg, sizeof(msg), 0);

	msgrcv(msgid, &msg, sizeof(msg), 21, 0);
	printf("Moj rbr je %d\n", msg.rbr);

	int rbr = msg.rbr;
	int srb;
	int br = msg.br;

	while(1)
	{
		msgrcv(msgid, &msg, sizeof(msg), rbr, 0);
		printf("Cekam poruku: tip %ld, tekst: %s\n", msg.mtype, msg.mtext);

		do
		{
			srb = (rand())%br+1;
		}
		while(srb == rbr || srb == 0);
		msg.mtype = srb;
		
		printf("Unesi poruku za slanje: ");
		scanf("%s",string);
		strcpy(msg.mtext,string);
		printf("Saljem poruku: tip %d, tekst: %s\n", srb, string);
		msgsnd(msgid, &msg, sizeof(msg), 0);
	}
}
