#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka{
	long int tipPoruke;
	int tekstPoruke;
}Poruka;

int main(){
	
	key_t key;
	int idReda,ind;
	pid_t pid;
	int rbr,uSredini;
	
	key = ftok("./zad.c",'A');
	printf("Kljuc je %d\n",key);
	idReda = msgget(key,0666|IPC_CREAT);
	
	if((pid = fork())==0){
		rbr = 2;
		printf("Prvo dete %d %d\n",getppid(),rbr);
		Poruka mojaPoruka;
		uSredini = 1;
		sleep(2);
		while(1){
			if(uSredini == 1){
				mojaPoruka.tipPoruke = 3;
				mojaPoruka.tekstPoruke = uSredini;
				printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
				sleep(3);
				msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
				sleep(2);
				
				msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),rbr,0);
				if(mojaPoruka.tekstPoruke == uSredini)
					printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
				else{
				//	printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
					uSredini = mojaPoruka.tekstPoruke;
				//	printf("U sredini je %d\n",uSredini);
					sleep(2);
				}
			}
			else if(uSredini == 2){
				int pom = rand()%3+1;
				ind = msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),pom,IPC_NOWAIT);
				if(ind != -1){
					printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
					mojaPoruka.tipPoruke = 1;
					if(pom == 1)
						mojaPoruka.tekstPoruke = 3;
					else if(pom == 3)
						mojaPoruka.tekstPoruke = 1;
					uSredini = mojaPoruka.tekstPoruke;
			//		printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
					sleep(1);
					msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
					mojaPoruka.tipPoruke = 3;
					if(pom == 1)
						mojaPoruka.tekstPoruke = 3;
					else if(pom == 3)
						mojaPoruka.tekstPoruke = 1;
			//		printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
					sleep(1);
					msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
					sleep(5);
				}
			}
			else if(uSredini == 3){
				mojaPoruka.tipPoruke = 1;
				mojaPoruka.tekstPoruke = uSredini;
				printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
				sleep(3);
				msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
				sleep(2);
				
				msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),rbr,0);
				if(mojaPoruka.tekstPoruke == uSredini)
					printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
				
				uSredini = mojaPoruka.tekstPoruke;
			}
		}
		
	}
	else{
		if((pid = fork())==0){
			rbr = 3;
		printf("Drugo dete %d %d\n",getppid(),rbr);
		Poruka mojaPoruka;
		uSredini = 1;
		sleep(2);
		while(1){
			if(uSredini == 1){
				sleep(2);
				msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),3,0);
				
				if(mojaPoruka.tekstPoruke != uSredini){
					uSredini = mojaPoruka.tekstPoruke;
				}
				else{
					printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
					mojaPoruka.tipPoruke = 2;
					mojaPoruka.tekstPoruke = uSredini;
					printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
					sleep(3);
					msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
					sleep(2);
				}
			}
			else if(uSredini == 2){
				mojaPoruka.tipPoruke = 1;
				mojaPoruka.tekstPoruke = uSredini;
				printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
				sleep(3);
				msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
				sleep(2);
				
				msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),rbr,0);
				if(mojaPoruka.tekstPoruke == uSredini)
					printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
				
				uSredini = mojaPoruka.tekstPoruke;
			}
			else if(uSredini == 3){
				int pom = rand()%3+1;
				ind = msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),pom,IPC_NOWAIT);
				if(ind != -1){
					printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
					mojaPoruka.tipPoruke = 1;
					if(pom == 1)
						mojaPoruka.tekstPoruke = 2;
					else if(pom == 2)
						mojaPoruka.tekstPoruke = 1;
					uSredini = mojaPoruka.tekstPoruke;
		//			printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
					sleep(1);
					msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
					mojaPoruka.tipPoruke = 2;
					if(pom == 1)
						mojaPoruka.tekstPoruke = 2;
					else if(pom == 2)
						mojaPoruka.tekstPoruke = 1;
		//			printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
					sleep(1);
					msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
					sleep(5);
				}
			}
		}
	}
		else{
			rbr = 1;
			printf("Roditelj %d %d\n",getpid(),rbr);
			Poruka mojaPoruka;
			uSredini = 1;
			sleep(2);
			while(1){
				if(uSredini == 1){
					int pom = rand()%3+1;
				ind = msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),pom,IPC_NOWAIT);
					if(ind != -1){
						printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
						mojaPoruka.tipPoruke = 2;
						if(pom == 2)
							mojaPoruka.tekstPoruke = 3;
						else if(pom == 3)
							mojaPoruka.tekstPoruke = 2;
						uSredini = mojaPoruka.tekstPoruke;
					//	printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
						sleep(1);
						msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
						mojaPoruka.tipPoruke = 3;
						if(pom == 2)
							mojaPoruka.tekstPoruke = 3;
						else if(pom == 3)
							mojaPoruka.tekstPoruke = 2;
					//	printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
						sleep(1);
						msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
						sleep(5);
					}
				}
				else if(uSredini == 2){
					msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),1,0);
					
					if(mojaPoruka.tekstPoruke != uSredini){
						uSredini = mojaPoruka.tekstPoruke;
					}
					else{
						printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
						mojaPoruka.tipPoruke = 3;
						mojaPoruka.tekstPoruke = uSredini;
						printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
						sleep(3);
						msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
						sleep(2);
					}
				}
				else if(uSredini == 3){
					msgrcv(idReda,&mojaPoruka,sizeof(mojaPoruka),1,0);
				
					if(mojaPoruka.tekstPoruke != uSredini){
						uSredini = mojaPoruka.tekstPoruke;
					}
					else{
						printf("rbr %d Primio sam poruku tip %ld tekst %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
						mojaPoruka.tipPoruke = 2;
						mojaPoruka.tekstPoruke = uSredini;
						printf("rbr%d:Saljem poruku %ld %d\n",rbr,mojaPoruka.tipPoruke,mojaPoruka.tekstPoruke);
						sleep(3);
						msgsnd(idReda,&mojaPoruka,sizeof(mojaPoruka),0);
						sleep(2);
					}
				}
			}
		}
	}
	return 0;
}
