#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct _imi_poruka_
{
	long tip_poruke;
	long pid_poruke;
	int redni_broj_poruke;
	char tekst_poruke[50];
	long niz_klijenata[50];
}imi_poruka;

int main(int argc,char **argv)
{
	imi_poruka moja_poruka;
	key_t key = ftok("server.c",65);
	int msgid = msgget(key,IPC_CREAT|0666);
	int n,i,daj_rand_klijenta;
	int niz[50];
	
	printf("Koliko klijenata ocekujem?\n");
	scanf("%d",&n);
	
	for (i = 0; i < n; i++)
	{
		msgrcv(msgid,&moja_poruka,sizeof(moja_poruka),21,0);
		moja_poruka.niz_klijenata[i] = moja_poruka.pid_poruke;
		niz[i] = moja_poruka.niz_klijenata[i];
		moja_poruka.tip_poruke = moja_poruka.pid_poruke;
		moja_poruka.redni_broj_poruke = i+1;
		msgsnd(msgid,&moja_poruka,sizeof(moja_poruka),0);
		printf("Klijent %d prijavlen\n",i+1);
	}	
	
	for (i = 0; i < n; i++)
	{
		moja_poruka.niz_klijenata[i] = niz[i];
	}
	
	for (i = 0; i < n; i++)
	{
		moja_poruka.tip_poruke = niz[i];
		moja_poruka.redni_broj_poruke = n;
		//printf("%ld\n",moja_poruka.niz_klijenata[i]);
		msgsnd(msgid,&moja_poruka,sizeof(moja_poruka),0);
	}
	
	daj_rand_klijenta = rand() % n;
	printf("Ispod uneti poruku koju saljes random klijentu\n");
	scanf("%s",moja_poruka.tekst_poruke);
	moja_poruka.tip_poruke = moja_poruka.niz_klijenata[daj_rand_klijenta];
	printf("Saljem poruku: tip %ld ,tekst_poruke %s",moja_poruka.tip_poruke,moja_poruka.tekst_poruke);
	msgsnd(msgid,&moja_poruka,sizeof(moja_poruka),0);
	
	exit(0);
}
