#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int *prvi_kos;
int *drugi_kos;
int *treci_kos;
int *cetvrti_kos;

union semun 
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};


int main()
{
	srand(time(NULL));
	key_t kljuc;
	union semun arg;
	int id_sem,id_shm_kos1,id_shm_kos2,id_shm_kos3,id_shm_kos4,id_shm_stalak;
	int *broj_lopti;
	int pom;
	struct sembuf P,V,Q;
	
	kljuc = ftok("igrac.c",100);
	id_shm_kos1 = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	kljuc = ftok("igrac.c",101);
	id_shm_kos2 = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	kljuc = ftok("igrac.c",102);
	id_shm_kos3 = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	kljuc = ftok("igrac.c",103);
	id_shm_kos4 = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	kljuc = ftok("igrac.c",104);
	id_shm_stalak = shmget(kljuc,sizeof(int),IPC_CREAT|0666);
	
	prvi_kos = shmat(id_shm_kos1,NULL,0); //Povezan prvi kos;
	drugi_kos = shmat(id_shm_kos2,NULL,0); //Povezan drugi kos;
	treci_kos = shmat(id_shm_kos3,NULL,0); //Povezan treci kos;
	cetvrti_kos = shmat(id_shm_kos4,NULL,0); //Povezan cetvrti kos;
	
	broj_lopti = shmat(id_shm_stalak,NULL,0); //Povezan stalak;
	
	kljuc = ftok("igrac.c",105);
	id_sem = semget(kljuc,2,IPC_CREAT|0666);
	
	arg.val = 1;
	semctl(id_sem,0,SETVAL,arg);
	arg.val = 0;
	semctl(id_sem,1,SETVAL,arg);
	printf("Uneti broj lopti na stalku: ");
	scanf("%d\n",&pom);
	*prvi_kos = 0;
	*drugi_kos = 0;
	*treci_kos = 0;
	*cetvrti_kos = 0;
	*broj_lopti = pom;
	
	P.sem_num = 0;
	P.sem_op = 1;
	P.sem_flg = 0;
	
	V.sem_num = 1;
	V.sem_op = -1;
	V.sem_flg = 0;
	
	Q.sem_num = 0;
	Q.sem_op = -1;
	Q.sem_flg = 0;
	
	while(1)
	{
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n",0,id_sem,1);
		sleep(3);
		semop(id_sem,&Q,1);
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n",1,id_sem,1);
		sleep(3);
		semop(id_sem,&V,1);
		sleep(2);
		pom = *broj_lopti;
		pom = pom + 1;
		*broj_lopti = pom;
		printf("Povecavam semafor %d iz skupa %d za vrednost %d\n",0,id_sem,1);
		sleep(3);
		semop(id_sem,&P,1);
	}
	
	shmdt(prvi_kos);
	shmdt(drugi_kos);
	shmdt(treci_kos);
	shmdt(cetvrti_kos);
	shmdt(broj_lopti);
	
	
	return 0;
}
