#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>
pid_t pidr;
pid_t pidd;
//dete salje signal roditelju
void signal_handler1(int sig){
	printf("Roditelj: Prekinuo me je proces dete.\n");
	exit(0);
}
//roditelj salje signal detetu
void signal_handler2(int sig){
	printf("Dete: Prekinuo me je proces roditelj.\n");
	exit(0);
}
int main(){
	srand(time(NULL));
	int i, j;
	pid_t pid = fork();
	switch(pid){
		case -1:
			perror("Greska.\n");
			exit(1);
			
		case 0:
		
			signal(SIGINT, signal_handler1);
			int d = rand()%20;
			//int d = 5;
			printf("Random broj za dete: %d\n", d);
			for(i = 1; i<=d; i++){
				printf("Dete: %d\n", i);
				sleep(2);
			}
			printf("Dete: Zavrsio sam sa ispisom.\n");
			sleep(2);
			kill(getppid(), SIGINT);
			break;
		
		default:
			signal(SIGINT, signal_handler2);
			int r = rand()%20;
			//int r = 10;
			printf("Random broj za roditelja: %d\n", r);
			for(j = 1; j<=r; j++){
				printf("Roditelj: %d\n", j);
				sleep(2);
			}
			printf("Roditelj: Zavrsio sam sa ispisom.\n");
			sleep(2);
			kill(getpid(), SIGINT);
			break;
	
	}
	return 0;
}
