#include <stdio.h>
#include <stdlib.h>
#include <sys/msg.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <errno.h>
#include <unistd.h>
#include <time.h>
#include <signal.h>
#include <string.h>

typedef struct prijava{	
	long tip;
	pid_t pid;
	int rbr;
}prijava;

typedef struct potez{
	long tip;
	char tekst[30];
	int brojn;
	int rbr;
}potez;

void srand(unsigned int seed);
int main(){
	int n, i;
	srand(time(NULL));
	key_t kljuc = ftok("./server.c", 'a');
	int msgid=msgget(kljuc, 0);
	prijava prijave;
	potez potezi;
	prijave.tip=21;
	prijave.pid=getpid();
	msgsnd(msgid, &prijave, sizeof(prijave), 0);
	msgrcv(msgid, &prijave, sizeof(prijave), getpid(), 0);
	printf("prijavljen , redni broj : %d \n ", prijave.rbr);
	/*****/
	int mojredni=prijave.rbr;
	msgrcv(msgid, &potezi, sizeof(potezi), mojredni, 0);
	printf("[KLIJENT %d]: Ukupno klijenata: %d\n", mojredni, potezi.brojn);
	while(1){
		printf("Cekam poruku (mojrbr:%d) ...\n", mojredni);
		//
		msgrcv(msgid, &potezi, sizeof(potezi), mojredni, 0);
		printf("Poruka stigla, %s\n", potezi.tekst);
		//
		int randklijent=rand()%potezi.brojn+1;
		while(randklijent==mojredni)
			randklijent=rand()%potezi.brojn+1;
		printf("Unesi poruku: \n");
		fgets(potezi.tekst, 30, stdin);
		potezi.tekst[strlen(potezi.tekst)-1]=0;
		printf("Saljem poruku: tip %d, tekst_poruke %s\n", randklijent, potezi.tekst);
		potezi.tip=randklijent;
		msgsnd(msgid, &potezi, sizeof(potezi), 0);
	}
}




