#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct
{
	long tip;
	int rbr;
} poruka;

typedef struct
{
	long tip;
	int n;
} poruka2;

typedef struct
{
	long tip;
	char tekst[100];
} poruka3;

int id_reda;

int main()
{
	key_t kljuc;
	poruka por;
	
	kljuc = ftok("./server.c", 52);
	id_reda = msgget(kljuc, IPC_CREAT | 0660);
	
	int i, n;
	int mojID = getpid();
	
	por.tip = 21;
	por.rbr = mojID;
	
	msgsnd(id_reda, &por, sizeof(por), 0);
	msgrcv(id_reda, &por, sizeof(por), mojID, 0);

	int rbr;
	rbr = por.rbr;
	
	printf("Prijavljen, rbr %d\n", rbr);
	
	poruka2 por2;
	
	msgrcv(id_reda, &por2, sizeof(por2), rbr, 0);
	printf("Broj prijavljenih: %d\n", por2.n);	
	n = por2.n;

	poruka3 por3;
	
	long pomRbr;
	
	while(1)
	{
		printf("Cekam poruku tipa: %d", rbr);
		msgrcv(id_reda, &por3, sizeof(por3), rbr, 0);
		printf("\nPrimljena poruka: %s\n", por3.tekst);

		printf("Unesi poruku:\n");
		fgets(por3.tekst, sizeof(por3.tekst), stdin);
		por3.tekst[strlen(por3.tekst)-1] = '\0';
		srand(time(NULL));
		pomRbr = rand() % n + 1;
		while(pomRbr == rbr)
		{
			pomRbr = rand() % n + 1;
			sleep(1);
		}
		por3.tip = pomRbr;
		printf("Saljem poruku tipa: %ld, tekst: %s\n", por3.tip, por3.tekst);
		msgsnd(id_reda, &por3, sizeof(por3), 0);
		
	}
	return 0;
}




