#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pid;

void handlerRoditelj(int sig)
{
	printf("Roditelj: Prekinuo me je proces dete.\n");
	kill(SIGKILL, pid);
	exit(0);
}

void handlerDete(int sig)
{
	printf("Dete: Prekinuo me je proces roditelj.\n");
	kill(SIGKILL, pid);
	exit(0);
}

int main()
{
	time_t t1, t2;
	int i, n;
	pid = fork();


	switch(pid)
	{
		case 0:
			signal(SIGINT, handlerDete);
			srand(t1);
			n = rand() % 20 + 1;
			printf("DETE n: %d\n", n);
			for(i=1; i<=n; i++)
			{
				printf("DETE: %d\n", i);
				sleep(2);
			}
			kill(getppid(), SIGINT);
			break;
		case -1:
			printf("Greska\n");
			exit(0);
		default:
			signal(SIGINT, handlerRoditelj);
			srand(t2);
			n = rand() % 20 + 1;
			printf("RODITELJ n: %d\n", n);
			for(i=1; i<=n; i++)
			{
				printf("RODITELJ: %d\n", i);
				sleep(2);
			}
			kill(pid, SIGINT);
	}
	
	return 0;
}



