#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct poruka
{
	long tip;
	int rbr;
	long pid;
	int broj_klijenata;
	char tekst[100];
};

int main()
{
	srand(time(NULL));
	//int n, i;
	key_t kljuc;
	int id_reda;
	
	kljuc = ftok("./server.c", 65);
	id_reda = msgget(kljuc, IPC_CREAT | 0666);
	
	struct poruka moja_poruka;
	
	moja_poruka.tip = 34;
	moja_poruka.pid = getpid();
	
	printf("Prijavljujem se serveru...\n");
	msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
	printf("Prijava poslata.\n");
	printf("Cekam svoj redni broj.\n");
	sleep(2);
	msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), getpid(), 0);
	printf("Moj redni broj je: %d\n", moja_poruka.rbr);
	int rbr = moja_poruka.rbr;
	printf("Cekam ukupan broj klijenata...\n");
	msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 100, 0);
	printf("UKupan broj klijenata je: %d\n", moja_poruka.broj_klijenata);
	int ub = moja_poruka.broj_klijenata;
	int random = msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), rbr, 0);
	if(random != -1)
	{
		printf("Ja sam prihvatio poruku servera: %s\n", moja_poruka.tekst);
		int random = (rand() % ub) + 1;
		printf("Random je %d\n", random);
		if(random == rbr)
		{
			printf("Nije dozvoljeno slanje samom sebi!!!\n");
		}
		else
		{
			printf("Unesite poruku za %d. klijenta:\n", random);
			char s[100];
			scanf("%s", s);
			strcpy(moja_poruka.tekst, s);
			moja_poruka.tip = random;
			printf("Saljem poruku %d. klijentu\n", random);
			msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
		}
		
	}
	msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), rbr, 0);
	printf("Primljena poruka je %s\n", moja_poruka.tekst);
	//else printf("Meni server nije poslao poruku.");
	
	return 0;
}

