#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct poruka
{
	long tip;
	int rbr;
	long pid;
	int broj_klijenata;
	char tekst[100];
};

int main()
{
	srand(time(NULL));
	int n, i;
	key_t kljuc;
	int id_reda;
	//long niz[20];
	
	kljuc = ftok("./server.c", 65);
	id_reda = msgget(kljuc, IPC_CREAT | 0666);
	
	printf("Unesite N: ");
	scanf("%d", &n);
	struct poruka moja_poruka;
	
	if(n < 20)
	{
		for(i = 0; i < n; i++)
		{
			printf("Cekam prijavljivanje %d. klijenta....\n", i+1);
			msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 34, 0);
			printf("Klijent se prijavio.\n");
			printf("Saljem klijentu redni broj.\n");
			sleep(2);
			//niz[i+1] = moja_poruka.pid;
			moja_poruka.tip = moja_poruka.pid;
			moja_poruka.rbr = i + 1;
			msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
			printf("Poslata poruka klijentu %d\n", i+1);
		}
		
		printf("Saljem svim klijentima ukupan broj.\n");
		
		for(i = 0; i < n; i++)
		{
			moja_poruka.tip = 100;
			moja_poruka.broj_klijenata = n;
			msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
		}
		int r = (rand() % (n)) + 1;
		printf("Random je %d, unesite poruku za %d. klijenta\n", r, r);
		char s[100];
		scanf("%s", s);
		strcpy(moja_poruka.tekst, s);
		//fgets(moja_poruka.tekst, sizeof(moja_poruka.tekst), stdin);
		moja_poruka.tip = r;
		printf("Saljem poruku %d. klijentu\n", r);
		msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
	}
	else printf("N nije manji od 20!!!\n");	
	return 0;
}

