#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
pid_t pid;


void deteHandler(int sig){

	printf("Dete : Prekinuo me je process roditelj.\n");
	exit(0);
	
}

void roditeljHandler(int sig){
	printf("Roditelj: Prekinuo me je process dete.\n");
	exit(0);
}

main(){

	srand(time(NULL));
	pid=fork();
	
	if(pid==0){ //dete
		signal(SIGINT,deteHandler);
		
		int i,n;
		
		n=rand()%19+1;
		printf("Dete je generisalo N=%d\n",n);
		for(i=1;i<=n;i++){
			printf("Dete: %d\n",i);
			sleep(2);
		}

		kill(getppid(),SIGINT);
		
	}
	else if(pid!=-1){ //roditelj
		signal(SIGINT,roditeljHandler);
		int i,n;
		
		n=rand()%19+1;
		printf("Roditelj je generisao N=%d\n",n);
		for(i=1;i<=n;i++){
			printf("Roditelj: %d\n",i);
			sleep(2);
		}
		
		kill(pid,SIGINT);
	}
	else{
		printf("Greska pri fork-u...\n");
		exit(0);
	}

}
