#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct pomocna{
	char poruka[100];
	int pid;
	int rbr;
	int ukupno;
}pomocna;

struct poruka_red {
	long tip;
	pomocna pomocni[1];
};

int main()
{
	key_t kljuc;
	int id_reda,i;
	int pom=1,slucajni;
	kljuc=ftok("./kljient.c",67);
	id_reda = msgget(kljuc,IPC_CREAT|0666);
	
	int broj=0;
	struct poruka_red moja_poruka;
	while(pom!= -1)
	{
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka.pomocni),0,0);
		if(broj <= 20 && pom != -1)
		{
			broj++;
			pom = moja_poruka.pomocni[0].pid;
			moja_poruka.pomocni[0].rbr = broj;
			moja_poruka.tip = pom;
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.pomocni),0);
		}
	}
	//printf("IZASO broj %d\n",broj);
	if(broj > 0)
	{
		strcpy(moja_poruka.pomocni[0].poruka,"Broj prijavljenih Klijenata");
		moja_poruka.pomocni[0].ukupno = broj;
		for(i=1;i<=broj;i++)
		{
			moja_poruka.tip=i;
			msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.pomocni),0);
		}
		//fgets("%s",moja_poruka.pomocni[0].poruka,stdin());
		slucajni = rand()%broj;
		//slucajni klijent
		moja_poruka.tip=slucajni;
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.pomocni),0);
	}
	return 0;
}
