#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka
{
	long tip;
	int pid;
	int rbr;
	char tekst[100];
	int n;
}poruka;

int main()
{
	key_t kljuc = ftok("./server.c", 'a');
	int id_reda=msgget(kljuc, IPC_CREAT|0666);
	
	if(id_reda==-1)
	{
		printf("Greska\n");
		exit(0);
	}
	srand(getpid());
	int n, rbr;
	poruka moja_poruka;
	
	moja_poruka.tip = 55;
	moja_poruka.pid = getpid();
	
	printf("Prijavljujem se\n");
	msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
	
	msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), getpid(), 0);
	printf("Moj redni broj je %d. Ukupno prijavljenih klijenata %d\n", moja_poruka.rbr, moja_poruka.n);
	
	printf("Cekam poruku\n");

	msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), moja_poruka.rbr, 0);
	printf("Primljena poruka %s\n", moja_poruka.tekst);
	
	fgetc(stdin);
	char tekst[100];
	while(1)
	{
			
		n = moja_poruka.n;
		
		fgets(tekst, sizeof(tekst), stdin);
		strcpy(moja_poruka.tekst, tekst);
		
		rbr = rand()%n + 1;
		moja_poruka.tip = rbr;
		while(1)
		{
			if(rbr!=moja_poruka.rbr) break;
			rbr = rand()%n + 1;
			moja_poruka.tip = rbr;
		}
		
		
		printf("Saljem poruku: %d, tekst poruke %s\n", rbr, moja_poruka.tekst);
		msgsnd(id_reda, &moja_poruka,sizeof(moja_poruka), 0);
			
		printf("Cekam poruku: tekst poruke %s\n", moja_poruka.tekst);
		msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), moja_poruka.rbr, 0);
		printf("Primljena poruka %s\n", moja_poruka.tekst);
		
	}

	
	return 0;
}

