#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pidRoditelja;
pid_t pidDeteta;

void signal_handler1(int sig)
{
	printf("Prekinuo me je process dete\n");
	sleep(2);
	kill(pidRoditelja, SIGKILL);
}

void signal_handler2(int sig)
{
	printf("Prekinuo me je process roditelj\n");
	sleep(2);
	kill(pidDeteta, SIGKILL);
}
int main()
{
	pid_t pid;
	int i;
	pid=fork();	
	srand(getpid());
	
	int n;	
	switch(pid)
	{
		case -1:
			printf("Greska");
			exit(0);
		case 0:
			signal(SIGINT, signal_handler2);
			n = (rand()%20)+1;
			printf("Dete ide do %d\n", n);
			sleep(2);
			for(i=1; i<=n; i++)
			{
				printf("Dete: %d\n", i);
				sleep(2);
			}
			pidRoditelja=getppid();
			kill(getppid(), SIGINT);
		
		default:
			signal(SIGINT, signal_handler1);
			n = (rand()%20) + 1;
			printf("Roditelj ide do %d\n", n);
			sleep(2);
			for(i=1; i<=n; i++)
			{
				printf("Roditelj: %d\n", i);
				sleep(2);
			}
			pidDeteta=pid;
			kill(pid, SIGINT);
	}
	return 0;
}
