#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka
{
	long tip;
	int pid;
	int rbr;
	char tekst[100];
	int n;
}poruka;

int main()
{
	int n, i;
	scanf("%d", &n);
	key_t kljuc = ftok("./server.c", 'a');
	int id_reda=msgget(kljuc, IPC_CREAT|0666);	
	if(id_reda==-1)
	{
		printf("Greska\n");
		exit(0);
	}
	char tekst[100];
	poruka moja_poruka;
	srand(getpid());

	for(i=1; i<=n; i++)
	{
		msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka),55, 0);
		printf("Prijavio se klijent %d\n", i);
		
		
		printf("Saljem redni broj\n");
		moja_poruka.n = n;
		moja_poruka.tip = moja_poruka.pid;
		moja_poruka.rbr = i;
		msgsnd(id_reda, &moja_poruka,sizeof(moja_poruka), 0);	
		
	}
	fgetc(stdin);
	printf("Unesi poruku:\n");
	
	fgets(tekst, sizeof(tekst), stdin);
	strcpy(moja_poruka.tekst, tekst);
	
	int rbr = rand()%n + 1;
	printf("Saljem poruku: %d, tekst poruke %s\n", rbr, moja_poruka.tekst);
	
	moja_poruka.tip = rbr;
	msgsnd(id_reda, &moja_poruka,sizeof(moja_poruka), 0);
	
	return 0;
}
