#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka {
	long tip;
	int pid;
	int redni_broj;
	char tekst[50];
}poruka;

int main() {
	key_t kljuc;
	int id_reda;
	//int klijent;
	//int redni_broj;
	poruka pk;

	kljuc = ftok("./server.c", 65);
	id_reda = msgget(kljuc, IPC_CREAT | 0666);

	pk.tip = 1;
	pk.pid = getpid();
	printf("Pid procesa je %d\n", pk.pid);

	fgets(pk.tekst, sizeof(pk.tekst), stdin);
	printf("Saljem poruku : tip - %ld, tekst - %s\n", pk.tip, pk.tekst);
	msgsnd(id_reda, &pk, sizeof(pk), 0);

	pk.tip = getpid();
	printf("Cekam poruku : tip - %ld\n", pk.tip);
	msgrcv(id_reda, &pk, sizeof(pk), pk.tip, 0);
	printf("Primio sam poruku : tip - %ld, tekst - %s, redni broj - %d\n", pk.tip, pk.tekst, pk.redni_broj);
	
	msgrcv(id_reda, &pk, sizeof(pk), 1, IPC_NOWAIT);
	//printf("Saljem poruku : tip - %ld, tekst - %s\n", pk.tip, pk.tekst);
}
