#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

void signalHandlerDete() {
	printf("Prekinuo me je proces roditelj\n");
	exit(0);
}

void signalHandlerRoditelj() {
	printf("Prekinuo me je proces dete\n");
	exit(0);
}

int main() {
	srand(time(NULL));
	int pid;
	int nR, nD;
	int i;
	pid = fork();

	if(pid) {
		// proces roditelj
		signal(SIGINT, signalHandlerRoditelj);
		nR = rand() % 20;
		printf("Proces roditelj ide do broja %d\n\n", nR);
		for(i = 1; i <= nR; i++) {
			printf("Proces roditelj %d\n", i);
			sleep(2);
		}
		kill(pid, SIGINT);
	}
	else {
		// proces dete
		signal(SIGINT, signalHandlerDete);
		nD = rand() % 20;
		printf("Proces dete ide do broja %d\n\n", nD);
		for(i = 1; i <= nD; i++) {
			printf("Proces dete %d\n", i);
			sleep(2);
		}
		kill(getppid(), SIGINT);
	}
}
