#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define MEM 1024

typedef union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
}semun;

int semid, shmid, *br, BrLopti;

void handler(int sig)
{
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	shmctl(shmid, IPC_RMID, NULL);
	shmctl(BrLopti, IPC_RMID, NULL);
	exit(0);
}

int main()
{
	signal(SIGINT, handler);
	key_t shmkey = ftok("igrac.c", 71);
	shmid = shmget(shmkey, MEM, 0644 | IPC_CREAT);
	key_t keyL = ftok("igrac.c", 72);
	BrLopti = shmget(keyL, MEM, 0644 | IPC_CREAT);
	
	key_t key = ftok("igrac.c", 70);
	semid = semget(key, 3, 0666 | IPC_CREAT | IPC_EXCL);
	semun op;
	int *data;
	
	if(semid != -1)
	{
		op.val = 0;
		semctl(semid, 0, SETVAL, op);
		semctl(semid, 1, SETVAL, op);
		op.val = 1;
		semctl(semid, 2, SETVAL, op);
	}
	else if(errno == EEXIST)
		semid = semget(key, 3, 0);
	else
		exit(0);
	
	printf("Redar\n");
	int n;
	scanf("%d", &n);
	
	data = shmat(shmid, NULL, 0);
	*data = n;
	shmdt(data);
	br = shmat(BrLopti, NULL, 0);
	*br = 0;
	shmdt(br);
	
	
	struct sembuf Szak = {0,-1,0}, Sotk = {0,1,0}, used = {1,-1,0};
	int temp;
	
	semop(semid, &Sotk, 1);
	
	while(1)
	{
		printf("Smanjujem semafor 1 iz %d za vrednost 1\n", semid);
		semop(semid, &used, 1);
		
		printf("Smanjujem semafor 0 iz %d za vrednost 1\n", semid);
		semop(semid, &Szak, 1);
		data = shmat(shmid, NULL, 0);
		
		temp = *data;
		if(temp < n)
		{
			temp += 1;
			sleep(2);
		}
		
		shmdt(data);
		printf("Povecavam semafor 0 iz %d za vrednost 1\n", semid);
		semop(semid, &Sotk, 1);
	}
	


	return 0;
}
