#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>



int shmid;
int *kos;


void signalHandler(int sig)
{
	printf("Ubaceno na kos %d\n",*kos);
	exit(0);
}

union semun 
{
	int val;

	struct semid_ds *buf;
	ushort *array;

};


int main()
{
	key_t kljuc=ftok("init.c",1);
	shmid=shmget(kljuc,sizeof(int),0);
	kos=shmat(shmid,NULL,0);

	struct sembuf p,v,stalak_oslobadjam,stalak_zauzimam;
	key_t kljuc1=ftok("init.c",2);
	int semid=semget(kljuc1,3,0);

	signal(SIGINT,signalHandler);

	srand(time(NULL));
	
	p.sem_num=0;
	p.sem_op=-1;
	p.sem_flg=0;

	v.sem_num=1;
	v.sem_op=1;
	v.sem_flg=0;
	

	stalak_zauzimam.sem_num=2;
	stalak_zauzimam.sem_op=-1;
	stalak_zauzimam.sem_flg=0;

	stalak_oslobadjam.sem_num=2;
	stalak_oslobadjam.sem_op=1;
	stalak_oslobadjam.sem_flg=0;
	

	while(1)
	{
		
		if(semop(semid,&p,1)==-1)	
			break;
		//uzimanje sa stalka
		if(semop(semid,&stalak_zauzimam,1)==-1)	
			break;
		sleep(1);
		printf("Uzimam sa stalka\n");
		if(semop(semid,&stalak_oslobadjam,1)==-1)	
			break;
		//bacanje
		printf("Sutiram\n");
		sleep(3);
		if(rand()%2)
		{
			*kos=*kos+1;
			printf("Ubacio sam\n");
		}
		else
			printf("Omasio sam\n");

		if(semop(semid,&v,1)==-1)	
			break;
	}	

}





