#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main()
{

	int n;
	printf("Unesi broj lopti:\n");
	scanf("%d",&n);
	struct sembuf P,V;
	union semun operacija;
	
	key_t key;
	int shmid;
	
	key=ftok("./igrac.c",'V');
	shmid=shmget(key,sizeof(int),0644|IPC_CREAT);
	
	int *br_lopti;
	br_lopti=shmat(shmid,NULL,0);
	*br_lopti=n;
	
	key=ftok("./igrac.c",'P');
	
	int semid;
	semid=semget(key,5,0644|IPC_CREAT|IPC_EXCL);
	
	if(semid!=-1)
	{
		operacija.val=1;
		semctl(semid,0,SETVAL,operacija);
		semctl(semid,1,SETVAL,operacija);
		semctl(semid,2,SETVAL,operacija);
		semctl(semid,3,SETVAL,operacija);
		
		operacija.val=1;
		semctl(semid,4,SETVAL,operacija);
	}
	else if(errno==EEXIST)
	{
		printf("Semafor je kreiran i inicijalizovan, ja se samo povezujem\n");
		semid=semget(key,5,0);
	}
	else
	{
		printf("Neka druga greska\n");
		exit(1);
	}
	
	P.sem_num=4;
	P.sem_op=-1;
	P.sem_flg=0;
	
	V.sem_num=4;
	V.sem_op=1;
	V.sem_flg=0;
	
	semop(semid,&P,1);
	if(*br_lopti<n)
		(*br_lopti)++;
	sleep(2);
	
	semop(semid,&V,1);
	
	
	
	shmdt(br_lopti);
	return 0;
}
