#include <stdio.h>
#include <stdlib.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>

int semid;

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void signal_handler(int signal)
{
	printf("Prihvacen SIGINT. Brisem semafore.\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	printf("Izlaz.\n");
	exit(EXIT_SUCCESS);
}

int main(void)
{
	int start;
	key_t key;
	union semun arg;
	struct sembuf p, v;
	
	key = ftok("./prvi.c", 'S');
	semid = semget(key, 3, 0644 | IPC_CREAT | IPC_EXCL);
	
	signal(SIGINT, signal_handler);
	
	if(semid != -1) {
		printf("Ja sam kreirao semafor.\n");
		arg.val = 1;
		semctl(semid, 0, SETVAL, arg);
		semctl(semid, 1, SETVAL, arg);
		semctl(semid, 2, SETVAL, arg);
		
	} else if(errno == EEXIST) {
		printf("Semafor je vec kreiran.\n");
		
	} else {
		printf("Greska pri kreiranju semafora.\n");
		return EXIT_FAILURE;
	}
	
	start = 1;
	
	p.sem_num = 2;
	p.sem_op = 1;
	p.sem_flg = 0;

	v.sem_num = 1;
	v.sem_op = -1;
	v.sem_flg = 0;
	
	for(;;) {
		
	}
	return EXIT_SUCCESS;
}
