#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>

void srand(unsigned int seed);

union semun{
	
	int val;
	struct semid_ds *buf;
	ushort *array;
	
};
typedef struct kos{
		
	int kos1;
	int kos2;
	int kos3;
	int kos4;
	int stalak;
	
}kos;
kos *data;
void sighe(int s){
	
	printf("kroz kos 1 je proslo %d lopti\n",data->kos1);
	printf("kroz kos 2 je proslo %d lopti\n",data->kos2);
	printf("kroz kos 3 je proslo %d lopti\n",data->kos3);
	printf("kroz kos 4 je proslo %d lopti\n",data->kos4);
	exit(0);
	
}

int main(){
	
	srand(time(NULL));
	
	signal(SIGINT,sighe);
	key_t kljuc;
	kljuc=ftok("./redar.c",65);
	
	int shmid=shmget(kljuc,sizeof(kos),0666|IPC_CREAT);
	data=shmat(shmid,NULL,0);
	
	int semid=semget(kljuc,2,0644|IPC_CREAT|IPC_EXCL);
	union semun arg;
	struct sembuf povecajr,smanji;
	
	if(semid!=-1){
		
		arg.val=0;
		semctl(semid,0,SETVAL,arg);
		arg.val=0;
		semctl(semid,1,SETVAL,arg);

		
	}
	else if (errno==EEXIST){
		
		semid=semget(kljuc,2,0);
		
	}
	else{
		printf("greska\n");
		exit(0);
	}
	
	
	smanji.sem_num=0;
	smanji.sem_op=-1;
	smanji.sem_flg=0;
	
	povecajr.sem_num=1;
	povecajr.sem_op=1;
	povecajr.sem_flg=0;
	
	int sluc;
	int sluc2;
	
	while (1){
		
		printf("smanjujem semafor 0 iz skupa %d za vrednost -1\n",semid);
		sleep(3);
		semop(semid,&smanji,1);
		printf("uzimam loptu sa stalka\n");
		sleep(1);
		
		printf("bacam loptu u kos\n");
		sluc=(rand()%4)+1;
		sleep(3);
		
		sluc2=rand()%2;		//1 usla,0 nije
								
		if(sluc2==1){
			printf("lopta usla u kos %d\n",sluc);
			if(sluc==1)
				data->kos1++;
			else if(sluc==2)
				data->kos2++;
			else if(sluc==3)
				data->kos3++;
			else 
				data->kos4++;
			
		}
		else printf("lopta nije usla\n");
		data->stalak--;
		printf("povecavam semafor 1 iz skupa %d za vrednost 1\n",semid);
		sleep(3);
		semop(semid,&povecajr,1);
		
		
	}
	
	
		
	
	
	
	return 0;
	
}
