#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct Message
{
	long type;
	char text[100];
}Message;

int id;
pid_t d1, d2;

void handler(int sig)
{
	kill(d1, SIGKILL);
	kill(d2, SIGKILL);
	msgctl(id, IPC_RMID, NULL);
	exit(0);
}

int main()
{
	signal(SIGINT, handler);
	srand(time(0));
	key_t key = ftok("./Sredinica.c", 70);
	id = msgget(key, 0666 | IPC_CREAT);
	Message msg;
	int rbr = 1;
	int sredina = rbr;
	int flg, cekam, temp;
	
	sprintf(msg.text, "%s", "Zdravo");
	
	if(d1 = fork())
	{
		rbr = 2;
		cekam = 0;
		
		while(1)
		{
			if(!cekam)
			{
				//sprintf(msg.text, "%s", "Zdravo");
				printf("rbr %d: Saljem poruku: tip %d, %s\n", rbr, rbr, msg.text);
				msg.type = rbr;
				sleep(3);
				msgsnd(id, &msg, sizeof(msg.text), 0);
				cekam = 1;
			}
			
			if(sredina != rbr)
			{
				printf("rbr %d: Cekam poruku: ", rbr);
				
				if(sredina == 1)
					flg = msgrcv(id, &msg, sizeof(msg.text), 3, IPC_NOWAIT);
				else if(sredina == 3)
					flg = msgrcv(id, &msg, sizeof(msg.text), 1, IPC_NOWAIT);
				
				if(flg != -1)
				{
					printf("tip %ld, %s\n", msg.type, msg.text);
					cekam = 0;
				}
				else if(flg == -1)
				{
					temp = msgrcv(id, &msg, sizeof(msg.text), 12, IPC_NOWAIT);
					
					if(temp != -1)
						sredina = rbr;
					
					printf("\n");
					cekam = 1;
				}
					
			}
			else
			{
				msg.type = (rand() % 3) + 1;
				
				if(msg.type == rbr)
					msg.type = (rand() % 3) + 1;
				
				printf("rbr %d: Cekam poruku: ", rbr);
				flg = msgrcv(id, &msg, sizeof(msg.text), msg.type, IPC_NOWAIT);
				
				if(flg != -1)
				{
					printf("tip %ld, %s\n", msg.type, msg.text);
					sredina = msg.type;
					msg.type += 10;
					msgsnd(id, &msg, sizeof(msg.text), 0);
					cekam = 0;
				}
				else if(flg == 1)
				{
					printf("\n");
					sleep(2);
				}
					
				
			}
		}
	}
	
	if(d2 = fork())
	{
		rbr = 3;
		cekam = 1;
		msg.type = rbr;
		
		while(1)
		{	
			if(!cekam)
			{
				//sprintf(msg.text, "%s", "Zdravo");
				printf("rbr %d: Saljem poruku: tip %d, %s\n", rbr, rbr, msg.text);
				msg.type = rbr;
				sleep(3);
				msgsnd(id, &msg, sizeof(msg.text), 0);
			}
			
			if(sredina != rbr)
			{
				printf("rbr %d: Cekam poruku: ", rbr);
				
				if(sredina == 1)	
					msgrcv(id, &msg, sizeof(msg.text), 2, IPC_NOWAIT);
				else if(sredina == 2)
					msgrcv(id, &msg, sizeof(msg.text), 1, IPC_NOWAIT);
					
				if(flg != -1)
				{
					printf("tip %ld, %s\n", msg.type, msg.text);
					cekam = 0;
				}
				else if(flg == -1)
				{
					temp = msgrcv(id, &msg, sizeof(msg.text), 13, IPC_NOWAIT);
					
					if(temp != -1)
						sredina = rbr;
					
					printf("\n");
					cekam = 1;
				}
			}
			else
			{
				msg.type = (rand() % 3) + 1;
				
				if(msg.type == rbr)
					msg.type = (rand() % 3) + 1;
				
				printf("rbr %d: Cekam poruku: ", rbr);
				flg = msgrcv(id, &msg, sizeof(msg.text), msg.type, IPC_NOWAIT);
				
				if(flg != -1)
				{
					printf("tip %ld, %s\n", msg.type, msg.text);
					sredina = msg.type;
					msg.type += 10;
					msgsnd(id, &msg, sizeof(msg.text), 0);
					cekam = 0;
				}
				else if(flg == 1)
				{
					printf("\n");
					sleep(2);
				}
				
			}
			
			printf("rbr %d: Saljem poruku: tip %d, %s\n", rbr, rbr, msg.text);
			msg.type = rbr;
			sleep(3);
			msgsnd(id, &msg, sizeof(msg.text), 0);
		}
	}
	
	rbr = 1;
	cekam = 1;
	msg.type = rbr;
	
	while(1)
	{
		if(!cekam)
		{
			//sprintf(msg.text, "%s", "Zdravo");
			printf("rbr %d: Saljem poruku: tip %d, %s\n", rbr, rbr, msg.text);
			msg.type = rbr;
			sleep(3);
			msgsnd(id, &msg, sizeof(msg.text), 0);
			cekam = 1;
		}
		
		if(sredina != rbr)
		{
			printf("rbr %d: Cekam poruku: ", rbr);
				
			if(sredina == 2)	
				msgrcv(id, &msg, sizeof(msg.text), 3, IPC_NOWAIT);
			else if(sredina == 3)
				msgrcv(id, &msg, sizeof(msg.text), 2, IPC_NOWAIT);
				
			if(flg != -1)
			{
				printf("tip %ld, %s\n", msg.type, msg.text);
				cekam = 0;
			}
			else if(flg == -1)
			{
				temp = msgrcv(id, &msg, sizeof(msg.text), 11, IPC_NOWAIT);
				
				if(temp != -1)
					sredina = rbr;
				
				printf("\n");
				cekam = 1;
			}
		}
		else
		{
			msg.type = (rand() % 3) + 1;
			
			if(msg.type == rbr)
				msg.type = (rand() % 3) + 1;
			
			printf("rbr %d: Cekam poruku: ", rbr);
			flg = msgrcv(id, &msg, sizeof(msg.text), msg.type, IPC_NOWAIT);
			
			if(flg != -1)
			{
				printf("tip %ld, %s\n", msg.type, msg.text);
				sredina = msg.type;
				msg.type += 10;
				msgsnd(id, &msg, sizeof(msg.text), 0);
				cekam = 0;
			}
			else if(flg == -1)
			{
				printf("\n");
				sleep(2);
			}
			
		}
	}
	
}
