#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int idReda;
	
void signalHandler(int sig){
	msgctl(idReda, IPC_RMID, NULL);
	exit(0);
}

struct prijava
{
	long mtype; // tip poruke
	pid_t pid; // tekst poruke
};

int main()
{
	int n, redniBroj;
	key_t kljuc;
	int idReda;
	
	signal(SIGINT, signalHandler);
	
	kljuc = ftok("./server.c", 0666);
	idReda = msgget(kljuc, IPC_CREAT|0666);
	
	struct prijava prijavaPoruka;
	struct prijava primiRedniBroj;
	
	prijavaPoruka.mtype = 5;
	prijavaPoruka.pid = getpid();
	printf("Saljem poruku: %d (moj pid)\n", prijavaPoruka.pid);
	msgsnd(idReda, &prijavaPoruka, sizeof(prijavaPoruka), 5);	
	
	printf("Cekam poruku (moj redni broj)\n");
	msgrcv(idReda, &primiRedniBroj, sizeof(primiRedniBroj), getpid(), 0);
	
	printf("Moj redni broj je: %d", primiRedniBroj.pid);
}
	
	
