#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

void signalHandlerDete(int sig){
	printf("Dete: Prekinuo me je proces roditelj.\n");
	exit(0);
}

void signalHandlerRoditelj(int sig){
	printf("Roditelj: Prekinuo me je proces dete.\n");
	exit(0);
}

int main()
{
	pid_t pid;
	int n;
	
	pid = fork();
	
	if(pid == -1){
		perror("Doslo je do greske!\n");
	}
	else {
		if(pid == 0){
			signal(SIGINT, signalHandlerDete);
			//printf("Dete\n");
			srand(getpid());
			n = rand()%20 + 1;
			printf("Dete: Ispisujem brojeve do %d\n", n);
			for(int i = 1; i <= n; i++){
				printf("Dete: %d\n", i);
				sleep(2);
			}
			//printf("Dete: Zavrsio sam, saljem signal!\n");
			kill(getppid(), SIGINT);
		}
		else {
			signal(SIGINT, signalHandlerRoditelj);
			//printf("Roditelj\n");
			srand(getpid());
			n = rand()%20 + 1;
			printf("Roditelj: Ispisujem brojeve do %d\n", n);
			for(int i = 1; i <= n; i++){
				printf("Roditelj: %d\n", i);
				sleep(2);
			}
			//printf("Roditelj: Zavrsio sam, saljem signal!\n");
			kill(pid, SIGINT);
		}
	}
	
	kill(getpid(), SIGKILL);
	return 0;
}
