#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


struct poruka
{
	long tip;
	int pid;
	int redni_broj;
	int ukupno;
	char tekst[100];
};

int main()
{
	char tekst[100];
	srand(time(NULL));
	
	key_t kljuc;
	int id_reda;
	
	kljuc=ftok("./server.c",65);
	id_reda=msgget(kljuc,IPC_CREAT|0666);
	
	struct poruka porukak;
	
	porukak.tip=23;
	porukak.pid=getpid();
	
	msgsnd(id_reda,&porukak,sizeof(porukak),0);
	
	msgrcv(id_reda,&porukak,sizeof(porukak),getpid(),0);
	
	printf("Klijent: Redni broj je %d, a ukupno klijenata je %d\n",porukak.redni_broj,porukak.ukupno);
	
	int pidd=porukak.redni_broj;
	int ukupno=porukak.ukupno;
	
	while(1)
	{
		porukak.tip=pidd;
		printf("Cekam poruku tipa: %ld\n",pidd);
		msgrcv(id_reda,&porukak,sizeof(porukak),pidd,0);
		printf("Primljena poruka: %s\n",porukak.tekst);
	
		printf("Unesi tekst poruke:\n");
		scanf("%s",tekst);
		strcpy(porukak.tekst,tekst);
		//fgets(porukak.tekst,sizeof(porukak.tekst),stdin);
		
		porukak.tip=rand()%ukupno+1;
		while(porukak.tip==pidd)
			porukak.tip=rand()%ukupno+1;
		
		printf("Saljem poruku: tip %ld tekst %s\n",porukak.tip,porukak.tekst);
		msgsnd(id_reda,&porukak,sizeof(porukak),0);
		
		
	}
	return 0;
}
