#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int prvi=0;


void signal_handler(int sig)
{
	if(prvi==1) //dete je prvo zavrsilo
	{
		printf("RODITELJ: Prekinuo me je proces dete\n");
		exit(0);
	}
	if(prvi==2) //roditelj je prvi zavrsio
	{
		printf("DETE: Prekinuo me je proces roditelj\n");
		exit(0);
	}
}

int main()
{
	srand(time(NULL));
	int i,nd,nr;
	pid_t pid;
	
	pid=fork();
	switch(pid)
	{
		case -1:
			printf("Fork greska\n");
			exit(1);
		case 0: //dete
			signal(SIGINT,signal_handler);
			nd=rand()%20;
			//nd=10;
			printf("DETE: Stampam brojeve do %d\n",nd);
			for(i=1;i<=nd;i++){
				printf("DETE: %d\n",i);
				sleep(2);
				if(i==nd)
				{
					if(prvi==0)
						{
							prvi=1;
							kill(getppid(),SIGINT);
						}
				}}

		default: //roditelj
			signal(SIGINT,signal_handler);
			nr=rand()%20;
			printf("RODITELJ: Stampam brojeve do %d\n",nr);
			for(i=1;i<=nr;i++)
			{
				printf("RODITELJ: %d\n",i);
				sleep(2);
				
				if(i==nr)
				{
					if(prvi==0)
						{
							prvi=2;
							kill(pid,SIGINT);
						} 
				}

			
			}
	}
	return 0;
}
