#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <ctype.h>
#include <errno.h>
#include <time.h>
#include <sys/ipc.h>
#include <sys/wait.h>
#include <sys/msg.h>
#include <sys/types.h>

struct message
{
	long type;
	long number;
	char text[100];
};

int main()
{
	int n,id;
	key_t key;
	struct message msg;
	long pid, i;
	
	key = ftok("./server.c", 1);
	id = msgget(key, IPC_CREAT|0666);	
	

	printf("Unesite N: ");	
	scanf("%d", &n);
	getchar();
	while(n >= 20)
	{
		printf("N mora biti manje od 20! Unesite novo N: ");
		scanf("%d", &n);	
	}

	for(i = 1; i <= n; i++)
	{
		printf("Cekam prijavu %ld\n", i);
		msgrcv(id, &msg, sizeof(msg), 999, 0);
		pid = msg.number;
		msg.type = pid;
		msg.number = i;
		strcpy(msg.text, "Uspesno ste se prijavili");
		msgsnd(id, &msg, sizeof(msg), 0);
	}
	
	
	for(i = 1; i <= n; i++)
	{
		msg.type = i;
		msg.number = n;
		strcpy(msg.text, "Ukupan broj prijavljenih klijenata");
		msgsnd(id, &msg, sizeof(msg), 0);
	}
	
	printf("SERVER PRIMA PORUKE ZA KLIJENTE, PREKINITE GA SA CTRL + C\n");
	while(1)
	{
		printf("Unesite poruku za klijente: ");
		fgets(msg.text, sizeof(msg.text), stdin);
		//scanf("%s", msg.text);
		i = rand() % n + 1;
		msg.type = i;
		msg.number = 0;
		msgsnd(id, &msg, sizeof(msg), 0);
		printf("Poruka poslata klijentu %ld\n", i);
	}

	msgctl(id, IPC_RMID, NULL);

	
}
