#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

void handlerRoditelj(int sig)
{
	printf("Roditelj: prekinuo me je proces dete\n");
	//signal(SIGINT,SIG_DFL);
	//kill(getpid(),SIGINT);
	exit(0);
}

void handlerDete(int sig)
{
	printf("Dete: prekinuo me je proces roditelj\n");
	//signal(SIGINT,SIG_DFL);
	//kill(getpid(),SIGINT);
	exit(0);
}

int main()
{
	//srand(time(NULL));
	
	int pid=fork();
	
	if(pid==0)//dete
	{
		signal(SIGINT,handlerDete);
		srand(getpid());
		//int broj=5;
		int broj=rand()%20+1;
		
		printf("Proces dete je generisao broj %d\n",broj);
		for(int i=1;i<=broj;i++)
		{
			printf("Proces dete %d\n",i);
			sleep(2);
		}
		
		kill(getppid(),SIGINT);
		exit(0);
	}
	else if(pid==-1)
	{
		printf("Greska pri forkovanju\n");
	}
	else //roditelj
	{
		signal(SIGINT,handlerRoditelj);
		srand(getpid());
		
		int broj=rand()%20+1;
		//int broj=5;
		printf("Proces roditelj je generisao broj %d\n",broj);
		for(int i=1;i<=broj;i++)
		{
			printf("Proces roditelj %d\n",i);
			sleep(2);
		}
		
		kill(pid,SIGINT);
		exit(0);
	}
}
