#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int Gpid;

void signal_handler(int sig)
{
	if(Gpid == 0)
	{
		printf("Dete : Prekinuo me je process roditelj\n");
		exit(0);
	}
	else
	{
		printf("Roditelj: Prekinuo me je process dete\n");
		exit(0);
	}
	
}

int main()
{
	int pid = fork();
	Gpid = pid;
	int i;
	srand(getpid());
	int n = rand()%10;
	signal(SIGINT,signal_handler);
	
		if(pid == -1)
		{
			printf("Fork greska.\n");
			exit(-1);
		}
		else if(pid == 0)
		{
			printf("DETE meni je n: %d\n",n);
			for(i=1;i<=n;i++)
			{
				printf("DETE: %d\n",i);
				sleep(2);
			}
			kill(getppid(),SIGINT);
		}
		else
		{
			printf("RODITELJ meni je n: %d\n",n);
			for(i=1;i<=n;i++)
			{
				printf("RODITELJ: %d\n",i);
				sleep(2);
			}
			kill(pid,SIGINT);
		}
	
	exit(0);
}
