#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <time.h>

void srand(unsigned int seed);

pid_t rod;
int d;

void sighe(int s){
	
	if(getpid()==rod){
		
		printf("Roditelj:Prekinuo me je process dete, ja gasim procese\n");
		kill(d,SIGKILL);
		exit(0);
		
	}
	else {
		
		printf("Dete:Prekinuo me je process roditelj, ja gasim procese\n");
		kill(getppid(),SIGKILL);
		exit(0);
	}
	
}

int main(){
	
	
	srand(time(NULL));
	
	signal(SIGINT,sighe);
	rod=getpid();
	int n,i;
	
	d=fork();
	
	switch (d){
		
		case -1:
			printf("greska\n");
			exit(0);
		case 0:
			n=rand();
			//printf("DETE: n mi je %d\n",n);
			//n=6;
			for (i=1;i<=n;i++){
				printf("DETE: %d\n",i);
				sleep(2);
			}
			kill(getppid(),SIGINT);
		default:
			n=rand();
			//printf("RODITELJ: n mi je %d\n",n);
			//n=3;
			for (i=1;i<=n;i++){
				printf("RODITELJ: %d\n",i);
				sleep(2);
			}
			kill(d,SIGINT);
		}
	
	
	
	
	return 0;
}
