#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pidD, pidR;

void handlerD(int sig)
{
	printf("Roditelj: Prekinuo me je process dete.\n");
	kill(pidR, SIGKILL);
}
void handlerR(int sig)
{
	printf("Dete: Prekinuo me je process roditelj.\n");
	kill(pidD, SIGKILL);
}


int main()
{
	pid_t pid;
	int n1,n2;
	int i1,i2;
	pid=fork(); //forkujemo
	switch(pid)
	{
		case -1:					//error
			printf("NEMA DETETA!\n");
			
		case 0:						//dete
			signal(SIGINT, handlerD);
			srand(time(NULL));
			rand();
			pidD=getpid();
			n1=rand()%20;
			printf("Dete: PID %d,  N = %d\n",pidD, n1);
			for(i1=1;i1<=n1;i1++)
			{
				printf("Dete: %d\n", i1);
				sleep(2);
			}
			kill(pidR, SIGINT);  	//ako zavrsi salje roditelju SIGINT
			kill(pidD, SIGKILL);
		default:					//roditelj
			signal(SIGINT, handlerR);
			srand(time(NULL));
			rand();
			pidR=getpid();
			n2=rand()%20;
			printf("Roditelj: PID %d , N = %d\n", pidR, n2);
			for(i2=1;i2<=n2;i2++)
			{
				printf("Roditelj: %d\n", i2);
				sleep(3);
			}
			kill(pidD, SIGINT);		//ako zavrsi salje detetu SIGINT
			kill(pidR, SIGKILL);
	}
	return 0;
}
