#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct poruka
{
	long tip_poruke;
	char tekst_poruke[5];
	pid_t moj_pid;
	int redni_br;
	int br_klijenata;
};

int main()
{
	int n,i,id_reda, pom = rand(),pom1;
	key_t kljuc;
	struct poruka moja_poruka;
	printf("Unesi broj klijenata: ");
	scanf("%d",&n);
	
	//povezi se na red za poruke
	kljuc = ftok("./server.c",1);
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
	//priprema za slanje
	moja_poruka.tip_poruke = 1;
	strcpy(&moja_poruka.tekst_poruke,'poy');
	moja_poruka.moj_pid = getpid();
	
	//slanje poruke
	printf("Saljem poruku: tip %d, tekst_poruke %s\n",moja_poruka.tip_poruke,moja_poruka.tekst_poruke);
	msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
	
	//priprema za primanje poruke od strane servera
	moja_poruka.tip_poruke = moja_poruka.moj_pid;
	
	//primanje poruke od strane servera
	printf("Cekam poruku: tip %d",moja_poruka.tip_poruke);
	msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),moja_poruka.tip_poruke,0);
	printf("Klijent %d primio poruku!\n",moja_poruka.redni_br);
	
	//priprema za primanje slucajne poruke
	moja_poruka.tip_poruke = moja_poruka.redni_br;
	
	//primanje slucajne poruke od strane servera
	pom = msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), moja_poruka.tip_poruke, IPC_NOWAIT);
	
	if(pom != -1)
	{
		//ovaj klijent je primio slucajnu poruku od servera i poslace je drugom klijentu
		pom1 = rand() % moja_poruka.br_klijenata;
		while(pom1 != moja_poruka.redni_br)
			pom1 = rand() % moja_poruka.br_klijenata;
		fgets(moja_poruka.tekst_poruke,sizeof(moja_poruka.tekst_poruke),stdin);
		moja_poruka.tekst_poruke[strlen(moja_poruka.tekst_poruke) - 1] = "\0";
		
		printf("Saljem poruku: tip %d, tekst_poruke %s\n",moja_poruka.tip_poruke,moja_poruka.tekst_poruke);
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
	}
	else
	{
		if(pom1 = moja_poruka.redni_br)
		{
			printf("Cekam poruku: tip %d",moja_poruka.redni_br);
			msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), moja_poruka.tip_poruke, 0);
		}	
	}
}
