#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct Poruka
{
	long tip_poruke;
	char tekst_poruke[100];
	int rbr;
	int ukupanBroj;
};

int main()
{
	key_t key;
	int id,red,n,i,br;
	struct Poruka klijent;
	
	key = ftok("./server.c",33);
	id = msgget(key, IPC_CREAT | 0666);
	
	klijent.tip_poruke = 45;
	msgsnd(id, &klijent, sizeof(klijent), 0);
	msgrcv(id, &klijent, sizeof(klijent), 46, 0);
	red = klijent.rbr;
	
	msgrcv(id, &klijent, sizeof(klijent), red, 0);
	n = klijent.ukupanBroj;
	
	srand(time(NULL));
	br = rand()%n;
	
	printf("Cekam poruku tipa %d\n",red);
	msgrcv(id, &klijent, sizeof(klijent), red, 0);
	printf("Primio sam poruku tipa: %ld, tekst: %s\n",klijent.tip_poruke,klijent.tekst_poruke);
	
	if((br+1) != red)
	{
		fgets(klijent.tekst_poruke, sizeof(klijent.tekst_poruke), stdin);
		printf("Saljem poruku: %d, tekst_poruke %s\n",br+1,klijent.tekst_poruke);
		klijent.tip_poruke = br+1;
		msgsnd(id, &klijent, sizeof(klijent), 0);
	}
	
	return 0;
}
