#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


struct msg{
	long tip;
	long ukupanBr,redniBr,pid;
	char tekst[100];
};

int main()
{
	//int i;
	key_t key;
	int idReda1,idReda2,idReda3;
	struct msg primljena1,primljena2,primljena3,poslata,poslata1;
	
	key=ftok("./server.c",'A');
	if((idReda1=msgget(key,0))==-1)
	{
			printf("Greska prilikom povezivanja na red\n");
			exit(0);
	}
	key=ftok("./server.c",'C');
	if((idReda2=msgget(key,0))==-1)
	{
			printf("Greska prilikom povezivanja na red\n");
			exit(0);
	}
	key=ftok("./server.c",'G');
	if((idReda3=msgget(key,0))==-1)
	{
			printf("Greska prilikom povezivanja na red\n");
			exit(0);
	}
	
	
	
	long mojpid=getpid();
	
	
	poslata.tip=1;
	poslata.pid=mojpid;
	printf("Saljem poruku serveru za prijavu, tipa 1 i u njoj svoj pid %ld\n",poslata.pid);
	msgsnd(idReda1,&poslata,sizeof(poslata),0);
	sleep(2);
	
	printf("Cekam poruku od servera da bih saznao svoj redni broj, tip poruke %ld\n",mojpid);
	msgrcv(idReda1,&primljena1,sizeof(primljena1),mojpid,0);
	printf("Moj redni broj:%ld\n",primljena1.redniBr);
	
	long mojRedniBr=primljena1.redniBr;
	sleep(2);
	printf("Cekam poruku od servera da bih saznao ukupan broj klijenata\n");
	msgrcv(idReda2,&primljena2,sizeof(primljena2),mojRedniBr,0);
	printf("Saznao sam da je ukupan broj klijenata %ld\n",primljena2.ukupanBr);
	
	int n=primljena2.ukupanBr; //dobio je ukupan broj od servera
	
	while(1)
	{
	printf("Cekam tekstualnu poruku, da bih se ukljucio u komunikaciju\n");
	msgrcv(idReda3,&primljena3,sizeof(primljena3),mojRedniBr,0);
	printf("Primljena poruka %s\n\n", primljena3.tekst);
	sleep(2);
	
	printf("Unesite tekst poruke za slanje\n");	
	fgets(poslata1.tekst,sizeof(poslata1.tekst),stdin);
	poslata1.tip=rand()%n + 1; // da ne ide od 0, vec od 1
	if(poslata1.tip == mojRedniBr && mojRedniBr!=n) poslata1.tip +=1;
	else if(poslata1.tip==mojRedniBr && mojRedniBr==n) poslata1.tip -= 1; //da osiguramo da ne salje sebi, prebacimo npr na sledeci ili prethodni
	printf("Saljem poruku %ld klijentu, tip: %ld, tekst poruke %s\n", poslata1.tip,poslata1.tip,poslata1.tekst);
	msgsnd(idReda3,&poslata1,sizeof(poslata1),0);		
		}
	
	
	}


