#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


struct msg{
	long tip;
	long ukupanBr,redniBr,pid;
	char tekst[100];
};

int main()
{
	int i,n;
	key_t key;
	int idReda1,idReda2,idReda3;
	struct msg odKlijenta,kaKlijentu,poslata,poslata1;
	
	key=ftok("./server.c",'A');
	if((idReda1=msgget(key,0666|IPC_CREAT))==-1)
	{
			printf("Greska prilikom kreiranja reda\n");
			exit(0);
	}
	
	key=ftok("./server.c",'C');
	if((idReda2=msgget(key,0666|IPC_CREAT))==-1)
	{
			printf("Greska prilikom kreiranja reda\n");
			exit(0);
	}
	
	key=ftok("./server.c",'G');
	if((idReda3=msgget(key,0666|IPC_CREAT))==-1)
	{
			printf("Greska prilikom kreiranja reda\n");
			exit(0);
	}
	
	
	
	printf("Unesite broj klijenata ( N ) : ");
	scanf("%d",&n);
	
	for(i=1;i<=n;i++)
	{
		printf("Cekam poruku tipa 1\n");
		msgrcv(idReda1,&odKlijenta,sizeof(odKlijenta),1,0);
		printf("Primio sam poruku od klijenta ciji je pid %ld\n",odKlijenta.pid);
		kaKlijentu.tip=odKlijenta.pid;
		kaKlijentu.redniBr=i;
		//poslata.ukupanBr=n;
		printf("Saljem poruku tipa %ld\n",kaKlijentu.tip);
		msgsnd(idReda1,&kaKlijentu,sizeof(kaKlijentu),0);
		sleep(2);
	}
	
	
	
	for(i=1;i<=n;i++)
	{
		poslata.ukupanBr=n;
		poslata.tip=i; //sad svaki klijent zna svoji redni broj, pa moze da ocekuje poruku tog tipa
		msgsnd(idReda2,&poslata,sizeof(poslata),0);
	}
	sleep(5);
	printf("Unesite tekst poruke\n");	
	//fgets(poslata1.tekst,sizeof(poslata1.tekst),stdin);
	scanf("%s",poslata1.tekst);
	getchar();
	poslata1.tip=rand()%n + 1; // da ne ide od 0, vec od 1
	printf("Saljem poruku %ld klijentu, tip: %ld, tekst poruke %s\n", poslata1.tip,poslata1.tip,poslata1.tekst);
	msgsnd(idReda3,&poslata1,sizeof(poslata1),0);
		
	return 0;
	}

