#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <errno.h>

typedef struct poruka
{
	long tip;
	int redni_broj;
	int br_klijenta;
	char tekst[100];
}poruka;

int main()
{
	int n, id_reda;
	key_t kljuc;
	kljuc=ftok("./server.c", 65);
	id_reda=msgget(kljuc, IPC_CREAT | 0666);

	poruka moja_poruka;
	moja_poruka.tip=2;
	//prijavljivanje serveru
	msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
	msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 1, 0);
	
	//primanje poruke
	moja_poruka.tip=(long)moja_poruka.redni_broj;
	printf("Cekam poruku: tip %ld\n", moja_poruka.tip);
	msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), moja_poruka.redni_broj, 0);
	printf("Primio sam poruku: tip %ld, tekst_poruke %s\n", moja_poruka.tip, moja_poruka.tekst);
	
	//slanje poruke
	n=rand()%moja_poruka.br_klijenta;
	while(n==moja_poruka.redni_broj) //klijent ne sme da posalje sam sebi poruku
	{
		n=rand()%moja_poruka.br_klijenta;
	}
	moja_poruka.tip=(long)n;
	printf("Unesi poruku za slanje\n");
	fgets(moja_poruka.tekst, sizeof(moja_poruka.tekst), stdin);
	printf("Saljem poruku: tip %d tekst_poruke %s\n", n, moja_poruka.tekst);
	msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
	moja_poruka.tip=(long)moja_poruka.redni_broj; //vrati klijentu njegov tip
	return 0;
}
