#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/msg.h>
#include <sys/ipc.h>
#include <errno.h>
#include <signal.h>

void signal_handler_dete(int sig)
{
	printf("Prekinuo me je proces roditelj\n");
}

void signal_handler_roditelj(int sig)
{
	printf("Prekinuo me je proces dete\n");
}


int main()
{
	int n, i;
	
	if(!fork())
	{
		printf("Proces roditelj\n");
		n=rand()%20;
		printf("%d\n", n);
		for(i=1; i<=n; i++)
		{
			printf("%d\n", i);
			sleep(2);
		}
		printf("\n");
		
		signal(SIGINT, signal_handler_dete);
	}
	else
	{
		printf("Proces dete\n");
		n=rand()%20;
		printf("%d\n", n);
		for(i=1; i<=n; i++)
		{
			printf("%d\n", i);
			sleep(2);
		}
		printf("\n");
		
		signal(SIGINT, signal_handler_roditelj);
	}
	return 0;
}
