#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <signal.h>
#include <time.h>
#include <errno.h>

typedef struct poruka
{
	long tip;
	int redni_broj;
	int br_klijenta;
	char tekst[100];
}poruka;

int main()
{
	int i, n, id_reda;
	key_t kljuc;
	kljuc=ftok("./server.c", 65);
	id_reda=msgget(kljuc, IPC_CREAT | 0666);
	scanf("%d", &n);
	poruka moja_poruka;
	
	//prijavljivanje klijenata
	moja_poruka.br_klijenta=n;
	for(i=0; i<n; i++)
	{
		msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 2, 0);
		moja_poruka.redni_broj=i;
		moja_poruka.tip=1;
		msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka),0);
	}
	
	//unosenje poruke za slanje
	printf("Unesi poruku za slanje\n");
	fgets(moja_poruka.tekst, sizeof(moja_poruka.tekst), stdin);
	n=rand()%moja_poruka.br_klijenta; //kome se salje poruka
	printf("Saljem poruku: tip %d, tekst_poruke %s\n", n, moja_poruka.tekst);
	moja_poruka.tip=(long)n;
	msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0); //slanje poruke
	return 0;
}
