#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<errno.h>
#include<unistd.h>
#include<sys/types.h>
#include<signal.h>
#include<sys/ipc.h>
#include<sys/msg.h>
#include<time.h>

struct sadrzaj_poruke
{
	pid_t pid;
	char tekst[100];
	int broj;
	int ukupno;
};

struct poruka
{
	long tip_poruke;
	struct sadrzaj_poruke sadrzaj;
};

int main()
{
	srand(time(NULL));
	key_t key = ftok("./klijent.c",'A');
	int id_reda=msgget(key,0666|IPC_CREAT);
	struct poruka moja_poruka;
	char s[100];
	int br,uk,brooj;
	int nasumicno;
	
	pid_t pidd;
	pidd=getpid();
	
	
	moja_poruka.tip_poruke=25;
	moja_poruka.sadrzaj.pid=getpid();
	moja_poruka.sadrzaj.broj=0;
	strcpy(moja_poruka.sadrzaj.tekst,"");
	
	msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.sadrzaj),0);
	
	
	msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka.sadrzaj),pidd,0);
	
	pidd=moja_poruka.sadrzaj.pid;
	strcpy(s,moja_poruka.sadrzaj.tekst);
	br=moja_poruka.sadrzaj.broj;
	brooj=moja_poruka.sadrzaj.broj;
	uk=moja_poruka.sadrzaj.ukupno;
	
	msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka.sadrzaj),brooj,0);
	
	
	pidd=moja_poruka.sadrzaj.pid;
	strcpy(s,moja_poruka.sadrzaj.tekst);
	br=moja_poruka.sadrzaj.broj;
	uk=moja_poruka.sadrzaj.ukupno;
	
	while(1)
	{
		printf("Cekam poruku: %d\n",brooj);
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka.sadrzaj),brooj,0);
		
		br=moja_poruka.sadrzaj.broj;
		uk=moja_poruka.sadrzaj.ukupno;
		strcpy(s,moja_poruka.sadrzaj.tekst);
		pidd=moja_poruka.sadrzaj.pid;	
		printf("\nUnesi poruku:");
		fgets(s,sizeof(s),stdin);
		nasumicno=(rand()%uk)+1;
		if(nasumicno==brooj)
		{
			while(nasumicno==brooj)
			{
				nasumicno=(rand()%uk)+1;
			}			
		}
		
		moja_poruka.tip_poruke=nasumicno;
		moja_poruka.sadrzaj.broj=br;
		strcpy(moja_poruka.sadrzaj.tekst,s);
		moja_poruka.sadrzaj.pid=0;
		moja_poruka.sadrzaj.ukupno=uk;
		
		printf("Saljem poruku: tip:%ld, tekst_poruke: %s\n",moja_poruka.tip_poruke,moja_poruka.sadrzaj.tekst);
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.sadrzaj),0);
		
	}
}
