#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};
int semid;
void fun(int sig)
{
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	exit(0);
}
int main()
{
	signal(SIGINT, fun);
	key_t kljuc;
	int i;
	struct sembuf semop_p,semop_v;
	union semun operacija_sa_sem;
	kljuc=ftok("prvi.c",65);
	semid = semget(kljuc,3,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid!=-1)
	{
		operacija_sa_sem.val=1;
		semctl(semid,0,SETVAL,operacija_sa_sem);
		operacija_sa_sem.val=0;
		semctl(semid,1,SETVAL,operacija_sa_sem);
		operacija_sa_sem.val=0;
		semctl(semid,2,SETVAL,operacija_sa_sem);
	}else if(errno==EEXIST)
	{
		semid=semctl(kljuc,3,0);
	}else
	{
		printf("Neka druga greska je u pitanju\n");
		exit(0);
	}
	semop_p.sem_num=2;
	semop_p.sem_op=-2;
	semop_p.sem_flg=0;
	
	semop_v.sem_num=0;
	semop_v.sem_op=+1;
	semop_v.sem_flg=0;
	
	i=1;
	while(1)
	{
		if(i%3==2)
		{
			printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n",2,semid,-2);
			sleep(3);
			semop(semid,&semop_p,1);
			printf("Treci: %d\n",i);
			sleep(1);
			printf("Povecavam semafor %d iz skupa %d za vrednost %d\n",0,semid,1);
			sleep(3);
			semop(semid,&semop_v,1);
		}
		i++;
	}
	return 0;
}
