#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

 union semun {
	int val;
    struct semid_ds *buf; 
	ushort *array;

 };

int main(){

	key_t key = ftok("./prvi.c", 'A');
	int semid = semget(key, 3, 0644 | IPC_CREAT | IPC_EXCL);
	union semun arg;
	struct sembuf prvi, drugi;
	if(semid!=-1){
		
		//inicijalizuj semafore na 0
		arg.val = 0;
		semctl(semid, 0, SETVAL, arg);
		semctl(semid, 1, SETVAL, arg);
		semctl(semid, 2, SETVAL, arg);
		}
		else if(errno==EEXIST){
			semid = semget(key, 3,0);
			}
		else{
			
			printf("Greska");
			exit(0);
			}
	
	// inicijalizacija semafora
	prvi.sem_num = 0;
	prvi.sem_op = 1;
	prvi.sem_flg = 0;
	
	drugi.sem_num = 1;
	drugi.sem_op = 1;
	drugi.sem_flg = 0;
	
	
	
	

	printf("Povecavam vrednost semafora 0 iz skupa %d za vrednost 1\n", semid);
	sleep(3);
	semop(semid, &prvi, 1);
	
prvi.sem_num = 0;
	prvi.sem_op = -1;
	prvi.sem_flg = 0;
	
	
	int i =1; 	
	int ispisao=0;	
	while (1){	
		
		if(i%3==0) //ako je deljiv sa 3 
		
		{
			
			printf("Smanjujem vrednost semafora 0 iz skupa %d za vrednost 1\n", semid);
			sleep(3);			
			semop(semid, &prvi, 1);
			
			printf("Ispisao do sada %d puta \n", ispisao);
			printf("Broj %d\n", i);
			ispisao++;
			
		
			//povecaj 2 za 2
printf("Povecavam vrednost semafora 1 iz skupa %d za vrednost 2\n", semid);
sleep(3);
			semop(semid, &drugi, 1);
			
			semop(semid, &drugi, 1);
			
			}
			i++;
	sleep(2);
		}	
	
}
