#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int idSem;

void sigHandler(int sig)
{
		printf("Primljen SIGINT, brisem semafore..\n");
		semctl(idSem,0,IPC_RMID);
		semctl(idSem,1,IPC_RMID);
		semctl(idSem,2,IPC_RMID);
		printf("Obrisani semafori,zavrsavam sa radom\n");
		exit(0);
}


union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main()
{
	key_t key;
	
	union semun arg;
	struct sembuf p,v;
	signal(SIGINT,sigHandler);
	
	key=ftok("./prvi.c", 'L');
	idSem=semget(key,3,0666|IPC_CREAT|IPC_EXCL);
	
	printf("ID skupa semafora :%d\n",idSem);
	if(idSem!=-1)
	{
			arg.val=1;
			semctl(idSem,0,SETVAL,arg);
			arg.val=0;
			semctl(idSem,1,SETVAL,arg);
			arg.val=0;
			semctl(idSem,2,SETVAL,arg);
	}
	else if(errno==EEXIST)
	{
		printf("Neko drugi je napravio semafor,ja se samo povezujem\n");
		idSem=semget(key,3,0);
	}
	else
	{
			printf("Neka druga greska,izlazim..\n");
			exit(0);
	}
	
	int brojac=0;
	int br=3;
	
	p.sem_num=0;
	p.sem_op=-1;
	p.sem_flg=0;
	
	v.sem_num=1;
	v.sem_op=+2;
	v.sem_flg=0;
	
	int ind;
	
	while(1)
	{
		printf("\nSmanjujem semafor 0 iz skupa semafora %d za 1\n",idSem);
		sleep(3);
		ind=semop(idSem,&p,1); //prvi krece, stampa pa se blokira dok ga treci ne pokrene
		if(ind==-1) break;
		if(br%3==0)
		{
				printf("%d\n",br);
				brojac++;
				printf("Broj stampanja: %d\n",brojac);
				br+=3;
		}
		printf("Povecavam semafor 1 iz skupa semafora %d za vrednost 2\n",idSem);
		sleep(3);	
		ind=semop(idSem,&v,1); //pokrece drugi
		if(ind==-1) break;
	}
	return 0;
}


