#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union unija
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid, *stalak,*kos1, *kos2, *kos3, *kos4;
void handler(int sig)
{
	printf("Kroz prvi kos je proslo %d\n", *kos1);
	printf("Kroz drugi kos je proslo %d\n", *kos2);
	printf("Kroz treci kos je proslo %d\n", *kos3);
	printf("Kroz cetvrti kos je proslo %d\n", *kos4);
	exit(1);
	
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);

}

int main()
{
	srand(time(NULL));
	int id1, id2, id3,id4, shmid;
	signal(SIGINT, handler);
	key_t kljuc, kljucs,kljuc1,kljuc2,kljuc3,kljuc4;;
	kljuc=ftok("./igrac.c",15);
	kljucs=ftok("./igrac.c",12);
	
	shmid=shmget(kljucs,4*sizeof(int),0644|IPC_CREAT);
	stalak=(int *)shmat(shmid,NULL,0);
	*stalak=10;
	
	kljuc1=ftok("./igrac.c",13);
	kljuc2=ftok("./igrac.c",14);
	kljuc3=ftok("./igrac.c",16);
	kljuc4=ftok("./igrac.c",17);
	
	id1=shmget(kljuc1,sizeof(int),0644|IPC_CREAT);
	id2=shmget(kljuc2,sizeof(int),0644|IPC_CREAT);
	id3=shmget(kljuc3,sizeof(int),0644|IPC_CREAT);
	id4=shmget(kljuc4,sizeof(int),0644|IPC_CREAT);
	
	kos1=(int *)shmat(id1,NULL,0);
	kos2=(int *)shmat(id2,NULL,0);
	kos3=(int *)shmat(id3,NULL,0);
	kos4=(int *)shmat(id4,NULL,0);
	
	*kos1=0; 
	*kos2=0;
	*kos3=0;
	*kos4=0;
	
	semid=semget(kljuc,2,0666|IPC_CREAT|IPC_EXCL);
	union unija sem;
	struct sembuf Predar,Suzmi,Puzmi;
	
	if(semid!=-1)
	{
		printf("Ja sam kreirao semafor\n");
		printf("ID skupa semafora je %d\n", semid);
		sem.val=1;
		semctl(semid,0,SETVAL,sem);
		sem.val=0;
		semctl(semid,1,SETVAL,sem);
	
		
		
	}
	else if(errno==EEXIST)
	{
		printf("Semafor je napravio neko drugi\n");
		semid=semget(kljuc,2,0);
		printf("ID skupa semafora je %d\n", semid);
	}
	else
	{
		printf("Greska\n");
	}
	
	int br,p;
	
	Suzmi.sem_num=0;
	Suzmi.sem_op=-1;
	Suzmi.sem_flg=0;

	Predar.sem_num=1;
	Predar.sem_op=1;
	Predar.sem_flg=0;
	
	/*Puzmi.sem_num=0;
	Puzmi.sem_op=1;
	Puzmi.sem_flg=0;*/
	
	printf("Ukoliko na stalku ima lopti, uzmi jednu. Smanjujem semafor 0 iz skupa %d za vrednost 1\n",semid);
	if((*stalak)>0)
	{
		semop(semid,&Suzmi,1);
		*stalak=(*stalak)-1;
		printf("Lopta je uzeta. Na stalku je sada %d lopti\n", *stalak);
		sleep(1);
	//	printf("Ako je igrac uzeo loptu, moze bacati. Povecavam semafor 2 iz skupa semafora %d za 1\n");
	
		
		printf("Redar moze poceti da skuplja lopte, jer je uzimanje zavrseno. Povecavam semafor 1 iz skupa semafora %d za vrednost 1\n",semid);
		
		semop(semid,&Predar,1);
		
		br=rand()%4+1;
		
		if(br==1)
		{
			printf("Ubacuje se u prvi kos\n");
			
		
			p=rand()%2;
			if(p==1)
			{
				*kos1=(*kos1)+1;
				sleep(3);
				printf("U prvom kosu je sada %d lopti\n", *kos1);
			}
			else
			{
				printf("Lopta nije usla u kos\n");
			}
		}
		
		if(br==2)
		{
			printf("Ubacuje se u drugi kos\n");
			
	
			p=rand()%2;
			if(p==1)
			{
				*kos2=(*kos2)+1;
				sleep(3);
				printf("U drugom kosu je sada %d lopti\n", *kos2);
			}
			else
			{
				printf("Lopta nije usla u kos\n");
			}
		}
		
		if(br==3)
		{
			printf("Ubacuje se u treci kos\n");
	
			p=rand()%2;
			if(p==1)
			{
				*kos3=(*kos3)+1;
				sleep(3);
				printf("U trecem kosu je sada %d lopti\n", *kos3);
			}
			else
			{
				printf("Lopta nije usla u kos\n");
			}
		}
		
		if(br==4)
		{
			printf("Ubacuje se u cetvrti kos\n");
		
			p=rand()%2;
			if(p==1)
			{
				*kos4=(*kos4)+1;
				sleep(3);
				printf("U cetvrtom kosu je sada %d lopti\n", *kos4);
			}
			else
			{
				printf("Lopta nije usla u kos\n");
			}
		}
		
		
		
	}
	
	
	shmdt(kos1);
	shmdt(kos2);
	shmdt(kos3);
	shmdt(kos4);
	shmdt(stalak);
	
	
	return 0;
}
