#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun{
    int val;
    ushort *array;
    struct semid_ds *buf;
};

int main(){
    key_t key_s;
    int semid;
    union semun arg[3];
    struct sembuf p2, s1;
    int br=0, i=3;

    key_s = ftok("./prvi.c", 'R');
    semid = semget(key_s, 3, 0644 | IPC_CREAT);

    arg[0].val = 1; //prvi.c
    arg[1].val = 2; //drugi.c
    arg[2].val = 3; //treci.c

    semctl(semid, 0, SETVAL, arg[0]);
    semctl(semid, 0, SETVAL, arg[1]);
    semctl(semid, 0, SETVAL, arg[2]);

    p2.sem_num = 2;
    p2.sem_op = 1;
    p2.sem_flg = 0;

    s1.sem_num = 1;
    s1.sem_op = -1;
    s1.sem_flg = 0;

    while(1){
        printf("PRVI brojac: %d\n", br);
        printf("Smanjujem semafor %d iz skupa %d za vrednost %d.\n",s1.sem_num, semid, s1.sem_op);
        sleep(5);
        semop(semid, &s1, 1);
                printf("Prvi: %d\n", i);
                i += 3;
                br++;
        printf("Povecavam semafor %d iz skupa %d za vrednost %d.\n",p2.sem_num, semid, p2.sem_op);
        sleep(5);
        semop(semid, &p2, 1);
    }
}