#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;
int *br1, *br2, *br3;

void sig_hand(int sig)
{
	printf("Kroz prvi kos proslo je %d lopti\n",*br1);
	printf("Kroz drugi kos proslo je %d lopti\n",*br2);
	printf("Kroz treci kos proslo je %d lopti\n",*br3);
}

int main()
{

	key_t kljuc;
	int shmid,ind;
	int  *n;
	int kos,jeste;
	struct sembuf opr_v, opr_p;
	union semun operacija;
	
	signal(SIGINT, sig_hand);	

	kljuc = ftok("zadatak2.c",'A');
	semid = semget(kljuc,4,0666|IPC_CREAT);
	shmid = shmget(kljuc,sizeof(int),0666|IPC_CREAT|IPC_EXCL);

	if(semid != -1)
	{	
		operacija.val = 1;
		semctl(semid,0,SETVAL,operacija);
		operacija.val = 0;
		semctl(semid,1,SETVAL,operacija);
		operacija.val = 1;
		semctl(semid,2,SETVAL,operacija);
		operacija.val = 0;
		semctl(semid,3,SETVAL,operacija);
	}
	else if(errno == EEXIST)
	{
		semid = semget(kljuc,5,0);
	}
	else
	{
		printf("Greska!\n");
	}	exit(0);


	br = (int*)shmat(shmid,(void*),0);
	br1 = (int*)shmat(shmid,(void*),0);
	br2 = (int*)shmat(shmid,(void*),0);
	br3 = (int*)shmat(shmid,(void*),0);
	n = (int*)shmat(shmid,(void*),0);

	*br = 0;
	

	op_p.sem_num = 1;
	op_p.sem_op = -1;
	op_p.sem_flg = 0;

	op_v.sem_num = 0;
	op_v.sem_op = 1;
	op_v.sem_flg = 0;

	while(1)
	{
		printf("Smanjujem semafor 1 iz skupa semafora %d za vrednost 1\n",semid);
		ind = semop(semid, &op_p, 1);
			if(ind == -1) break;
		*n = *n - 1;
		sleep(1);
		printf("Povecavam semafor 0 iz skupa semafora %d za vrednost 1\n",semid);
		ind = semop(semid, &op_p, 1);
			if(ind == -1) break;
	}

	srand(time(NULL));
	kos = rand() % 3;
	kos++;

	op_p.sem_num = 2;
	op_p.sem_op = -1;
	op_p.sem_flg = 0;

	op_v.sem_num = 3;
	op_v.sem_op = 1;
	op_v.sem_flg = 0;

	while(1)
	{
		printf("Smanjujem semafor 2 iz skupa semafora %d za vrednost 1\n",semid);
		ind = semop(semid, &op_p, 1);
			if(ind == -1) break;
	
		if(kos == 1)
		{
			sleep(3);
			jeste = rand() % 2;
			if(jeste)
			*br1 = *br1 + 1;
		}
		else if(kos == 2)
		{
			sleep(3);
			jeste = rand() % 2;
			if(jeste)
			*br2 = *br2 + 1;

		}
		else
		{ 
			sleep(3);
			jeste = rand() % 2;
			if(jeste)
			*br3 = *br3 + 1;
		}	
		printf("Povecavam semafor 3 iz skupa semafora %d za vrednost 1\n",semid);
		ind = semop(semid, &op_p, 1);
			if(ind == -1) break;
	}


	op_p.sem_num = 3;
	op_p.sem_op = -1;
	op_p.sem_flg = 0;

	op_v.sem_num = 2;
	op_v.sem_op = 1;
	op_v.sem_flg = 0;

}
