#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1024
int idSem, idMem, *brLopti;

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main(){
	srand(time(0));
	key_t kljuc;
	union semun operacija;
	struct sembuf povecaj, smanji, stalakP, stalakS;
	
	kljuc = ftok("igrac1.c", 42);
	
	idMem = shmget(kljuc, SHM_SIZE * sizeof(int), 0666|IPC_CREAT|IPC_EXCL);
	if(idMem != -1)
	{
		brLopti = shmat(idMem, NULL, 0);
		brLopti[0] = 50;
		brLopti[1] = 0;
		brLopti[2] = 0;
		brLopti[3] = 0;
		brLopti[4] = 0;
	}
	else
	{
		brLopti = shmat(idMem, NULL, 0);
	}
	
	idSem = semget(kljuc, 5, 0666|IPC_CREAT|IPC_EXCL);
	if(idSem != -1)
	{
		operacija.val = 1;
		semctl(idSem, 0, SETVAL, operacija); //stalak
		semctl(idSem, 1, SETVAL, operacija); //kos1
		semctl(idSem, 2, SETVAL, operacija); //kos2
		semctl(idSem, 3, SETVAL, operacija); //kos3
		semctl(idSem, 4, SETVAL, operacija); //kos4
	}
	else if (errno == EEXIST)
	{
		idSem = semget(kljuc, 5, 0);
	}
	else
	{
		printf("neka druga greska\n");
		exit(0);
	}

	stalakP.sem_num = 0;
	stalakP.sem_op = 1;
	stalakP.sem_flg = 0;
	
	stalakS.sem_num = 0;
	stalakS.sem_op = -1;
	stalakS.sem_flg = 0;	
	
	while(1)
	{
		semop(idSem, &stalakS, 1);
		brLopti[0]++;
		printf("ukupan broj lopti: %d\n", brLopti[0]);
		sleep(2);
		semop(idSem, &stalakP, 1);					
	}

	return 0;
}
