#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

/*
Napisati programe
a. prvi.c – ispisuje u beskonačnoj petljii sve brojeve deljive sa 3 počevši od 1.
b. drugi.c - ispisuje u beskonačnoj petljii sve brojeve koji pri deljenju sa 3 daju ostatak 1
počevši od 1.
c. treci.c - ispisuje u beskonačnoj petljii sve brojeve koji pri deljenju sa 3 daju ostatak 2 počevši
od 1.
Korišćenjem mehanizama semafora, omogućiti da proces prvi ispiše jedan broj, zatim proces drugi ispiše
dva broja, potom proces treci ispiše jedan broj i tako u krug. Pre svakog ispisa, u svakom procesu,
odštampati vrednost brojača koji broji koliko je do tada bilo ispisa u tom procesu.
*/
union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main()
{
	int ind;
	int n=0,i=0;
	key_t kljuc;
	int semid;

	union semun dodeli;
	
	kljuc=ftok("prvi.c",65);
	semid=semget(kljuc,3,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid !=-1)
	{
		dodeli.val=1;
		semctl(semid,0,SETVAL,dodeli);
		dodeli.val=0;
		semctl(semid,1,SETVAL,dodeli);
		semctl(semid,2,SETVAL,dodeli);
	}
	else if(errno==EEXIST)
	{
		semid=semget(kljuc,3,0);
	}
	else
	{
		printf("Greska\n");
		exit(0);
	}
	
	
	struct sembuf prvi,drugi;
	prvi.sem_num=0;
	prvi.sem_op=-1;
	prvi.sem_flg=0;
	
	drugi.sem_num=1;
	drugi.sem_op=2;
	drugi.sem_flg=0;
	
	
	while(1)
	{

		printf("Smanjujem semafor 1 iz skupa %d za vrednost 1\n",semid);
		sleep(3);
		ind=semop(semid,&prvi,1);
		if(ind==-1) break;
		printf("Vrednost brojaca: %d\n",i++);
		printf("prvi.c %d\n",n+3);
		n=n+3;
		sleep(3);
		printf("Povecavam semafor 2 iz skupa %d za vrednost 2\n",semid);
		printf("\n");
		sleep(3);
		ind=semop(semid,&drugi,1);
		if(ind==-1) break;
	}
}
