#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid;
int shmid;

union semun {
    int val;
    struct semid_ds *buf;
    ushort *array;
};

int main() {
    // 0 - stala, 1 - stalak zauzet, 2 - pod
    int BROJ_LOPTI = 10;
    key_t key = ftok("redar.c", 1);
    semid = semget(key, 7, 0644 | IPC_CREAT);
    shmid = shmget(key,4*sizeof(int), 0644 | IPC_CREAT);

    int kosevi[] = shmat(shmid, NULL, 0);
    kosevi[0] = 0;
    kosevi[1] = 0;
    kosevi[2] = 0;
    kosevi[3] = 0;

    if(shmid == -1) {
        printf("Error: Shared memory not created! Trying to create queue!\n");
        exit(1);
    }

    if(semid == -1) {
        printf("Error: Queue not create! Trying to create queue!\n");
        exit(1);
    }

    union semun arg;
    arg.val = BROJ_LOPTI;
    semctl(semid, 0, SETVAL, arg);
    arg.val = 0;
    semctl(semid, 1, SETVAL, arg);
    arg.val = 0;
    semctl(semid, 2, SETVAL, arg);
    arg.val = 1;
    semctl(semid, 3, SETVAL, arg);
    semctl(semid, 4, SETVAL, arg);
    semctl(semid, 5, SETVAL, arg);
    semctl(semid, 6, SETVAL, arg);

    struct sembuf P-stalak;
    P.sem_num = 0;
    P.sem_op = -1;
    P.sem_flg = 0;
    struct sembuf P-zauzet;
    P.sem_num = 1;
    P.sem_op = -1;
    P.sem_flg = 0;
    struct sembuf P-pod;
    P.sem_num = 2;
    P.sem_op = -1;
    P.sem_flg = 0;
    struct sembuf V-stalak;
    V.sem_num = 0;
    V.sem_op = 1;
    V.sem_flg = 0;
    struct sembuf V-zauzet;
    V.sem_num = 1;
    V.sem_op = 1;
    V.sem_flg = 0;

    
    while(1) {0
        printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", P-pod.sem_num, semid, P-pod.sem_op);
        sleep(3);
        semop(semid, &P-pod, 1);
        printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", P-zauzet.sem_num, semid, P-zauzet.sem_op);
        sleep(3);
        semop(semid, &P-zauzet, 1);
        printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", V-stalak.sem_num, semid, V-stalak.sem_op);
        sleep(3);
        printf("Vracam loptu na stalak!\n");
        sleep(2);
        semop(semid, &V-stalak, 1);
        printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", V-zauzet.sem_num, semid, V-zauzet.sem_op);
        sleep(3);Smanjujem
        semop(semid, &V-zauzet, 1);
    }
}