#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHMSIZE 24

union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};


int main(){
	
	int i;
	int *stalak;
	int *kos[4];
	
	srand(time(NULL));
	key_t key = ftok("./kosarka.c", 1);
	
	int shmid = shmget(key, SHMSIZE, 0666|IPC_CREAT);
	printf("shmid: %d\n", shmid);
	
	stalak = shmat(shmid, NULL, 0); //br lopti na stalku
	for (i=0; i<4; i++) kos[i] = shmat(shmid, NULL, 0);
	
	
	int n;
	
	printf("Ucitaj br lopti: ");
	scanf("%d", &n);
	*stalak = n;
	
	int semid = semget(key, 6, 0666|IPC_CREAT|IPC_EXCL);
	
	union semun arg;
	
	if (semid != -1){ //ja kreiram i inicijalizujem
		printf("ja kreiram i inicijalizujem\n");
		arg.val = n;
		semctl(semid, 0, SETVAL, arg); //da li ima lopti
		arg.val = 1;
		for (i=1; i<=4; i++) semctl(semid, i, SETVAL, arg); //da li je kos slobodan
		semctl(semid, 5, SETVAL, arg); //da li je zauzet stalak
	}
	else if (errno == EEXIST){ //neko je vec kreirao, ja se samo povezujem
		printf("neko je vec kreirao, ja se samo povezujem\n");
		semid = semget(key, 6, 0);
	}
	else printf("\n\n\n\nneka druga greska\n");
	
	
	
	
	
	struct sembuf vratiLoptu;
	vratiLoptu.sem_num = 0;
	vratiLoptu.sem_op = 1;
	vratiLoptu.sem_flg = 0;
	
	struct sembuf zauzmiStalak;
	zauzmiStalak.sem_num = 5;
	zauzmiStalak.sem_op = -1;
	zauzmiStalak.sem_flg = 0;
	
	struct sembuf oslobodiStalak;
	oslobodiStalak.sem_num = 5;
	oslobodiStalak.sem_op = 1;
	oslobodiStalak.sem_flg = 0;
	
	
	while (1){
		
		
		//////
		//printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", zauzmiStalak.sem_num, semid, zauzmiStalak.sem_op);
		//printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", zauzmiStalak.sem_num, semid, zauzmiStalak.sem_op);
		/////
		
		if (*stalak == n) continue;
		
		printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", zauzmiStalak.sem_num, semid, zauzmiStalak.sem_op);
		semop(semid, &zauzmiStalak, 1); //cekam da se stalak oslobodi
		printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", vratiLoptu.sem_num, semid, vratiLoptu.sem_op);
		semop(semid, &vratiLoptu, 1);
		*stalak += 1;
		sleep(2);
		printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", oslobodiStalak.sem_num, semid, oslobodiStalak.sem_op);
		semop(semid, &oslobodiStalak, 1);
		
	}
	
	return 0;
}
