#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>



int semid;
union semun
{
	int val;
	struct sem_ds *buf;
	ushort *array;
};



void izbrisiSemafor(int sig)
{
	printf("Prekinut sam sa CTRL+C,brisem semafor....\n");
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);

	printf("Zavrsavam...\n");
	sleep(2);
	exit(0);
}

int main()
{
	key_t key;
	int shmid;
	union semun operacije_nad_sem;
	struct sembuf P,V;
	struct podatak *data;
	int i;
	int n = 1000;
	int ind;
	signal(SIGINT,izbrisiSemafor);
	int br=0;

	key = ftok("./proba.txt",65);
	semid = semget(key,4,0666|IPC_CREAT|IPC_EXCL);

	if(semid != -1)
	{
		printf("Semafor nije bio kreiran, ja sam ga kreirao!\n");

		operacije_nad_sem.val = 1;
		semctl(semid,0,SETVAL,operacije_nad_sem);


		operacije_nad_sem.val = 0;
		semctl(semid,1,SETVAL,operacije_nad_sem);

		operacije_nad_sem.val = 0;
		semctl(semid,2,SETVAL,operacije_nad_sem);



	}
	else if(errno == EEXIST)
	{
		printf("Neko drugi je kreirao semafor, ja se samo kacim\n");
		semid = semget(key,4,0);
	}
	else
	{
		printf("Neka druga greska\n");
		exit(0);
	}


	P.sem_num = 0;
	P.sem_op = -1;
	P.sem_flg = 0;

	V.sem_num = 1;
	V.sem_op = 2;
	V.sem_flg = 0;


	while(1)
	{
		for(i=1; i<n;i++)
		{
			if(i % 3 == 0)
			{

				printf("brojac: %d\n",br );
				br++;
				printf("smanjujem semafor 0 iz skupa %d za vrednost 1\n",semid );
				ind = semop(semid,&P,1);
				if(ind == -1) exit(0);
	
				printf("%d\n",i );
				printf("povecavam semafor 1 iz skupa %d za vrednost 2\n",semid);
				sleep(3);
				ind = semop(semid,&V,1);
				if(ind == -1) exit(0);
				
			}
		}	
	}


}