#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int *kos1, *kos2, *kos3, *kos4;

void handler(int s){
	printf("Kos1: %d\n Kos2: %d\n Kos3: %d\n Kos4: %d\n", *kos1, *kos2, *kos3, *kos4);
	exit(0);
}

int main(){
	key_t kljuc;
	int shmid1, shmid2, shmid3, shmid4, shmid5;
	int semid;
	int *stalak;
	//           1-4   0-1
	int brLopti, kos, pogodak, t;
	struct sembuf P, V;
	
	srand(time(NULL));
	signal(SIGINT, handler);
	
	
	kljuc = ftok("./init.c", 'A');
	shmid1 = shmget(kljuc, sizeof(int), 0666|IPC_CREAT);
	kos1 = (int*)shmat(shmid1, NULL, 0);
	
	kljuc = ftok("./init.c", 'B');
	shmid2 = shmget(kljuc, sizeof(int), 0666|IPC_CREAT);
	kos2 = (int*)shmat(shmid2, NULL, 0);
	
	kljuc = ftok("./init.c", 'C');
	shmid3 = shmget(kljuc, sizeof(int), 0666|IPC_CREAT);
	kos3 = (int*)shmat(shmid3, NULL, 0);
	
	kljuc = ftok("./init.c", 'D');
	shmid4 = shmget(kljuc, sizeof(int), 0666|IPC_CREAT);
	kos4 = (int*)shmat(shmid4, NULL, 0);
	
	kljuc = ftok("./init.c", 'E');
	shmid5 = shmget(kljuc, sizeof(int), 0666|IPC_CREAT);
	stalak = (int*)shmat(shmid5, NULL, 0);
	
	kljuc = ftok("./init.c", 'F');
	semid = semget(kljuc, 1, 0);

	
	P.sem_num = 0;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	V.sem_num = 0;
	V.sem_op = 1;
	V.sem_flg = 0;
	
	
	while(1){
		semop(semid, &P, 1);
		printf("Smanjujem semafor 0 iz skupa %d za 1\n", semid);
		sleep(3);
		brLopti = (*stalak);
		if(brLopti >= 1){
			printf("Uzimam loptu...\n");
			sleep(1);
			brLopti--;
			(*stalak) = brLopti;
			
			kos = rand()%4;
			kos++;
			sleep(3);
			if(kos == 1){
				pogodak = rand()%2;
				if(pogodak == 1){
					printf("Pogodak u kos 1\n");
					t = (*kos1);
					t++;
					(*kos1) = t;
				}else{
					printf("Promasaj\n");
				}
			}else if(kos == 2){
				pogodak = rand()%2;
				if(pogodak == 1){
					printf("Pogodak u kos 2\n");
					t = (*kos2);
					t++;
					(*kos2) = t;
				}else{
					printf("Promasaj\n");
				}
			}else if(kos == 3){
				pogodak = rand()%2;
				if(pogodak == 1){
					printf("Pogodak u kos 3\n");
					t = (*kos3);
					t++;
					(*kos3) = t;
				}else{
					printf("Promasaj\n");
				}
			}else{
				pogodak = rand()%2;
				if(pogodak == 1){
					printf("Pogodak u kos 4\n");
					t = (*kos4);
					t++;
					(*kos4) = t;
				}else{
					printf("Promasaj\n");
				}
			}
		}
		
		printf("Povecavam semafor 0 iz skupa %d za 1\n", semid);
		sleep(3);
		semop(semid, &V, 1);
	}
	
	
	return 0;
}
