#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

void sig_r(int sig){
    printf("Roditelj: prekinuo me je process dete.\n");
    signal(SIGINT, SIG_DFL);
}

void sig_d(int sig){
    printf("Dete: Prekinuo me je process roditelj.\n");
    signal(SIGINT, SIG_DFL);
}

int main(){
    srand(time(NULL));

    int pid, n_d, n_r;
    int i_r=0, i_d=0, ubiti;

    pid = fork();

    switch(pid){
        case -1:
            printf("Greska\n");
        case 0: //roditelj
            n_r = rand()%10;
            for(i_r=1; i_r<=n_r; i_r++){
                 printf("RODITELJ: %d\n", i_r);
                 sleep(2);
            }
            ubiti = getpid();
            if(i_r==n_r) kill(ubiti, SIGINT);
            else sig_r(SIGINT);
               
        case 1: //dete
            n_d = rand()%10;
            for(i_d=1; i_d<=n_d; i_d++){
                printf("DETE: %d\n", i_d);
                sleep(2);
            }
            ubiti = getppid();
            if(i_d==n_d) kill(ubiti, SIGINT);
            else sig_d(SIGINT);
    }
}