#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct{
    long tip;
    int rbr, uk;
    char text[100];
    pid_t pid;
}PORUKA;

int main(){
    srand(time(NULL));

    key_t key;
    int red, n;
    PORUKA *poruka;
    char uneta_poruka[100];

    key = ftok("./server.c", 65);
    red = msgget(key, IPC_CREAT | 0666);

    //posalji prijavu
    poruka->pid = getpid();
    poruka->tip = getpid();
    msgsnd(red, &poruka, sizeof(poruka), 0);
    //primi potvrdu da su se svi prijavili
    msgrcv(red, &poruka, sizeof(poruka), poruka->tip, 0);

    while(1){
        poruka->tip = poruka->rbr;
        //cekam da mi neko posalje poruku
        printf("Cekam poruku %ld, proces: %d.\n", poruka->tip, poruka->pid);
        msgrcv(red, &poruka, sizeof(poruka), poruka->rbr, 0); 
        printf("Primljena poruka: '%s'.\n", poruka->text);
        
        //kome sad ja saljem (ne smem sebi)
        n = (rand()%poruka->uk)+1;
        while(n==poruka->tip) n = (rand()%poruka->uk)+1;

        //posalji poruku
        printf("Uneti poruku: ");
        scanf("%s", uneta_poruka);
        strcpy(poruka->text, uneta_poruka);
        poruka->tip = n;
        printf("Saljem poruku: %ld '%s'.\n", poruka->tip, poruka->text);
        msgsnd(red, &poruka, sizeof(poruka), 0);
    }
    
}