#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct klijent_poruka
{
	long tip;
	char tekst[100];
	int redni_br;
	int ukupan_br;
};

int main()
{
	key_t kljuc;
	int id_reda;
	int i,n,m,br,k,h;
	struct klijent_poruka primljena, poslata;

	kljuc = ftok("./server.c",65);
	id_reda = msgget(kljuc,IPC_CREAT|0666);

	poslata.tip = 100;
	poslata.redni_br = getpid();

	fgets(poslata.tekst, sizeof(poslata.tekst),stdin);
	printf("Saljem poruku %s\n", poslata.tekst);
	msgsnd(id_reda, &poslata, sizeof(poslata),0);
	printf("Cekam poruku: redni broj\n");
	msgrcv(id_reda, &primljena, sizeof(primljena), getpid(),0);
	printf("Primljena poruka: %d\n", primljena.redni_br);

	
	
	
	printf("Cekam poruku: ukupan br klijenata\n");
	msgrcv(id_reda, &primljena, sizeof(primljena),50,0);
	printf("Primljena poruka: %d", primljena.ukupan_br);
	n = primljena.ukupan_br;



	primljena.tip = primljena.redni_br;
	k = primljena.tip;
	
	printf("Cekam poruku: nasumicno odabran klijent\n");
	m = msgrcv(id_reda, &primljena, sizeof(primljena),k,IPC_NOWAIT);

	if(m != -1)
	{
		printf("Primljena poruka: %s\n", primljena.tekst);
		srand(time(0));
		br = rand() % n;
		br++;
		poslata.tip = br;
		fgets(poslata.tekst,sizeof(poslata.tekst), stdin);
		printf("Saljem poruku: %s\n", poslata.tekst);

	}
	else
	{
		printf("Cekam poruku: poruka poslata od drugog klijenta\n");
		h = msgrcv(id_reda, &primljena, sizeof(primljena),k,IPC_NOWAIT);
		if(h != -1)
		{
			printf("Primljena poruka: %s\n", primljena.tekst);
		}
	}


}
	
	
