#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


void sig_hand1(int sig)
{
	printf("Prekinuo me je process roditelj.\n");
	exit(0);
}

void sig_hand2(int sig)
{
	printf("Prekinuo me je process dete.\n");
	exit(0);
}


int main()
{
	pid_t pid;
	int n, k, i, p;

	scanf("%d", &n);

	pid = fork();

	srand(time(0));
	
	if(pid == -1)
	{
 		printf("Greska!\n");
		exit(0);
	}
	else if(pid == 0)
	{
		srand(time(0));
		p = getppid();
		signal(SIGINT,sig_hand1);
		k = rand() % n;
		k++;
		for(i=1; i<=k; i++)
		{
			printf("Proces dete: %d\n", i);
			if(i == k)
			kill(p,SIGINT);
			sleep(2);
		}		
	}
	else
	{
		srand(time(0));
		signal(SIGINT,sig_hand2);
		k = rand() % n;
		k++;
		for(i=1; i<=k; i++)
		{
			printf("Proces roditelj: %d\n", i);
			if(i == k)
			kill(pid,SIGINT);
			sleep(2);
		}		
	
	}


}


//Hristina Markovic 98/2018
			
