#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t dete1, dete2;
int idReda;

void sighandler(int sig){
	printf("uhvacen signal\n");
	kill(dete1, SIGKILL);
	kill(dete2, SIGKILL);
	msgctl(idReda, IPC_RMID, NULL);
	exit(0);
}

struct poruka{
	long tip;
	int rbPosiljaoca;
	int sred;
	char str[50];
};

int main(){
	struct poruka p;
	int sred = 1, sagovornik, rb, provera, ind;
	key_t kljuc;
	signal(SIGINT, sighandler);
	kljuc = ftok("sredinica.c", 42);
	idReda = msgget(kljuc, IPC_CREAT|0666);
	pid_t roditelj;
	roditelj = getpid();
	srand(time(0));
	p.sred = 1;
	dete1 = fork(); 
	dete2 = fork();
	
	while(1)
	{
		if(getpid() == roditelj) //roditelj
		{
			rb = 1;
			if(p.sred == 1) //presrece
			{
				provera = rand()%2;
				if( provera == 0)
					provera = 2;
				else
					provera = 3;
				ind = msgrcv(idReda, &p, sizeof(p), provera, IPC_NOWAIT);
				printf("RODITELJ: hvatam na tip: %d\n", provera);
				if(ind == -1)
				{
					//printf("RODITELJ: greska. pokusavam opet za 2 sekunde\n");
					sleep(2);
				}
				else
				{
					printf("RODITELJ: uhvacen\n");
					p.sred = p.rbPosiljaoca;
					msgsnd(idReda, &p, sizeof(p), 0);
				}
			}
			else //komunicira
			{
			
				if(p.sred == 2)
					p.tip = 3;
				else
					p.tip = 2;
				p.rbPosiljaoca = 1;
				printf("RODITELJ: unesi poruku: ");
				scanf("%s", p.str);
				msgsnd(idReda, &p, sizeof(p), 0);
				printf("RODITELJ: Cekam poruku: tip %d\n", rb);
				msgrcv(idReda, &p, sizeof(p), rb, 0);
				printf("RODITELJ: primljena poruka: %s\n", p.str);			
			
			}
		}
		else if(dete1 != 0 && getppid() == roditelj) //dete1
		{
			rb = 2;
			if(p.sred != 2) //komunicira
			{
				if(p.sred == 1)
					p.tip = 3;
				else
					p.tip = 1;
				p.rbPosiljaoca = rb;
				printf("DETE1: unesi poruku: ");
				scanf("%s", p.str);
				msgsnd(idReda, &p, sizeof(p), 0);
				printf("DETE1: Cekam poruku: tip %d\n", rb);
				sleep(5);
				msgrcv(idReda, &p, sizeof(p), rb, 0);
				printf("DETE1: primljena poruka: %s\n", p.str);
			}
			else //presrece
			{
				printf("DETE1: presrecem\n");
				provera = rand()%2;
				if( provera == 0)
					provera = 1;
				else
					provera = 3;
				ind = msgrcv(idReda, &p, sizeof(p), provera, IPC_NOWAIT);

				if(ind == -1)
				{
					printf("DETE1: greska. pokusavam opet za 2 sekunde\n");
					sleep(2);
				}
				else
				{
					printf("DETE1: uhvacen\n");
					sred = p.rbPosiljaoca;
					msgsnd(idReda, &p, sizeof(p), 0);
				}			
			
			}
		}
		else if (dete2 != 0 && getppid() == roditelj) //dete2
		{
			rb = 3;
			if(p.sred != 3) // komunicira
			{
				printf("DETE2: Cekam poruku: tip %d\n", rb);
				sleep(5);
				msgrcv(idReda, &p, sizeof(p), rb, 0);
				printf("DETE2: primljena poruka: %s\n", p.str);
				if(sred == 2)
					p.tip = 1;
				else
					p.tip = 2;
				p.rbPosiljaoca = rb;
				printf("DETE2: unesi poruku: ");
				scanf("%s", p.str);
				msgsnd(idReda, &p, sizeof(p), 0);
		
			
			}
			else //presrece
			{
				printf("DETE2: presrecem\n");
				provera = rand()%2;
				if( provera == 0)
					provera = 1;
				else
					provera = 2;
				ind = msgrcv(idReda, &p, sizeof(p), provera, IPC_NOWAIT);
				if(ind == -1)
				{
					printf("DETE2: greska. pokusavam opet za 2 sekunde\n");
					sleep(2);
				}
				else
				{
					printf("DETE2: uhvacen\n");
					sred = p.rbPosiljaoca;
					msgsnd(idReda, &p, sizeof(p), 0);
				}			
			
			}
		
		}	
	
	}
	return 0;
}
