#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct poruka
{
	long tip;
	char sadrzaj[20];
	int rbr;
	int ukupno;
};

int idreda;

void hend(int sig)
{
	printf("\nSignal\n");
	msgctl(idreda, IPC_RMID, NULL);
	exit(0);
}

int main()
{ 
	signal(SIGINT, hend);
	key_t kljuc=ftok("./server.c", 63);
	idreda=msgget(kljuc, IPC_CREAT|0666);
	long ind;
	struct poruka por;
	
	por.tip=21;
	
	printf("Saljem poruku da se prijavim tip: %ld\n", por.tip);
	msgsnd(idreda, &por, sizeof(por), 0);
	printf("Poslao poruku da se prijavim tip: %ld\n\n", por.tip);
	sleep(1);
	
	printf("Cekam poruku da sam se prijavio tip= 22\n");
	msgrcv(idreda, &por, sizeof(por), 22, 0);
	printf("Primio poruku da sam se prijavio tip= 22 sa rednim brojem %d\n\n", por.rbr);
	sleep(1);
	
	por.tip=por.rbr;
	
	printf("Cekam poruku koliko nas ima tip= %d\n", por.rbr);
	msgrcv(idreda, &por, sizeof(por), por.tip, 0);
	printf("Primio poruku o nasem broju %d tipa %d\n\n",por.ukupno, por.rbr);
	sleep(1);
	
	while(1){
	por.tip=por.rbr;
	printf("Cekam sadrzaj tip= %d\n", por.rbr);
	msgrcv(idreda, &por, sizeof(por), por.tip, 0);
	printf("Primio poruku %s tipa %d\n\n",por.sadrzaj, por.rbr);
	sleep(1);
	
	
	ind=rand()%por.ukupno+1;
	por.tip=ind;
	
	while(ind==por.rbr)
	{
		ind=rand()%por.ukupno+1;
		por.tip=ind;
	}
	
	printf("Unesi poruku: \n");
	fgets(por.sadrzaj, 1024, stdin);
	
	printf("Saljem sadrzaj %s tipu: %ld\n", por.sadrzaj, por.tip);
	msgsnd(idreda, &por, sizeof(por), 0);
	printf("Poslao poruku tipa: %ld\n\n", por.tip);
}
	
}
