#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pid;

void hand1(int sig)
{
	printf("\nRoditelj: Prekinuo me je process dete\n");
	kill(SIGINT, getpid());
	exit(0);
}

void hand2(int sig)
{
	printf("\nDete : Prekinuo me je process roditelj\n");
	kill(SIGINT, pid);
	exit(0);
}



int main()
{
	srand(time(NULL));
	int n,i;
	//printf("PID dete: %d\n", pid);
	//printf("PID rodi: %d\n", getpid());
	pid=fork();
	
	if(pid==0)
	{
		signal(SIGINT, hand2);
		//n=rand()%5+1;
		n=2;
		printf("N= %d\n", n);
		for(i=0; i<n; i++)
		{
			printf("Dete: %d \n", i);
			sleep(2);
		}
		//printf("PID rodi: %d\n", getppid());
		kill(getppid(), SIGINT);
	}
	else
	if(pid!=-1)
	{
		signal(SIGINT, hand1);
		n=rand()%5+1;
		printf("N= %d\n", n);
		for(i=0; i<n; i++)
		{
			printf("Roditelj: %d \n", i);
			sleep(2);
		}
		//printf("PID dete: %d\n", pid);
		kill(pid, SIGINT);
		
	}
}
