#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int queueID;

struct msgbuf
{
    long mtype; // tip poruke
    pid_t pid;
    int numberOfClients;
    int rednibroj;
    char mtext[100];
};

void my_handler(int sig) {
    msgctl(queueID, IPC_RMID, NULL);
    exit(0);
}


int main() {
    printf("Poceo");
    srand(time(NULL));

    int n = rand() % 20 + 1;
    int numberOfClients = 0;
    char mtext[100];
    struct msgbuf my_message;
    my_message.mtype = 0;
    my_message.numberOfClients = n;
    key_t key = ftok("server.c", 1);
    queueID = msgget(key, IPC_CREAT|0666);

    if(queueID == -1) {
        printf("Server: Error with queue! Exit!\n");
    }

    while(1) {
        if(numberOfClients < n) {
            printf("Cekam poruku: mtype = 0, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
            msgrcv(queueID, &my_message, sizeof(my_message), 1, 0);
            printf("Primio poruku: mtype = %ld, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", my_message.mtype, my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
            my_message.rednibroj = numberOfClients + 1;
            my_message.mtype = my_message.pid;
            msgsnd(queueID, &my_message, sizeof(my_message), 0);
            printf("Poslao poruku: mtype = %ld, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", my_message.mtype, my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
            numberOfClients++;
        }
        else {
            int sendTo= rand() % numberOfClients + 1;
            my_message.mtype = sendTo;
            scanf("%s", my_message.mtext);
            msgsnd(queueID, &my_message, sizeof(my_message), 0);
            printf("Poslao poruku: mtype = %ld, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", my_message.mtype, my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
            while(1) {

            }
        }
    }
 
    msgctl(queueID, IPC_RMID, NULL);
}

