#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int pid;
void my_handler(int sig) {
    if(pid == 0) {
        printf("Dete: Prekinuo me je process roditelj.\n");
        exit(0);
    }
    else {
        printf("Roditelj: Prekinuo me je process dete.\n");
        exit(0);
    }
}


int main() {

    signal(SIGINT, my_handler);
    pid = fork();

    
    int n1;
    int n2;
    srand(time(NULL));
    if(pid == 0) {
        n1 = rand() % 20 + 1;
        printf("Dete: Broj n = %d\n", n1);
    }
    else {
        n2 = rand() % 20 + 1;
        n2 = rand() % 20 + 1;
        printf("Roditelj: Broj n = %d\n", n2);
    }
    int i = 0;

    while(1) {
        if(pid == 0) {
            i++;
            printf("Dete: %d\n", i);
            if(i == n1) {
                kill(getppid(), SIGINT);
                exit(0);
            }
            sleep(2);
        }
        else {
            i++;
            printf("Roditelj: %d\n", i);
            if(i == n2) {
                kill(pid, SIGINT);
                exit(0);
            }
            sleep(2);
        }
    }
}

