#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <time.h>

void handlerDete(int sig){
    printf("    DETE: Prekinuo me je proces roditelj.\n");
    exit(0);
}

void handlerRoditelj(int sig){
    printf("RODITELJ: Prekinuo me je proces dete.\n");
    exit(0);
}


int main(){
    int pid;
    int nRoditelj;
    int nDete;
    int i;

    srand(time(0));
    nDete = rand()%20 + 1;
    nRoditelj = rand()%20 + 1;

    switch(pid = fork()){
        case -1:
            perror("Greska!\n");
            exit(0);
        case 0:
            signal(SIGINT, handlerDete);
            printf("    DETE ispisuje do: %d\n", nDete);
            for(i = 1; i <= nDete; i++){
                printf("    DETE: %d\n", i);
                sleep(2);
            }
            kill(getppid(), SIGINT);
            exit(0);
        default:
            signal(SIGINT, handlerRoditelj);
            printf("RODITELJ ispisuje do: %d\n", nRoditelj);
            for(i = 0; i <= nRoditelj; i++){
                printf("RODITELJ: %d\n", i);
                sleep(2);
            }
            kill(pid, SIGINT);
            exit(0);
    }
    return 0;
}
