#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <errno.h>
#include <signal.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

typedef struct _PORUKA{
    long tip;
    int rb;
    int brKlijenata;
    char tekst[100];
} _poruka;

int msgid;

void DeleteMSG(){
	msgctl(msgid, IPC_RMID, NULL);
}

void handler(int sig){
	DeleteMSG();
	exit(0);
}

int main(){
    key_t key;
    _poruka poruka;
    char tekst[100];
    long tip;
    int n;
    int i;
    srand(time(0));
	
	signal(SIGINT, handler);
	
    key = ftok("./server.c", 1);
    msgid = msgget(key, IPC_CREAT|0666);

    printf("Unesi broj klijenata: ");
    scanf("%d", &n);
    
    for(i = 1; i <= n; i++){
		printf("Ocekujem poruku sa bilo kojim tipom\n");
		msgrcv(msgid, &poruka, sizeof(poruka), 0, 0);
		poruka.rb = i;
		printf("Primio, tip %ld\n", poruka.tip);
		printf("Vracam poruku sa istim tipom i rednim brojem %d\n", i);
		msgsnd(msgid, &poruka, sizeof(poruka), 0);
		printf("------------------\n");
	}
	
	for(i = 1; i <= n; i++){
		printf("Saljem poruku sa tipom %d i brojem klijenata %d\n", i, n);
		poruka.tip = i;
		poruka.brKlijenata = n;
		msgsnd(msgid, &poruka, sizeof(poruka), 0);
	}
	
	printf("\n\n");
	
	printf("Program radi sa jednom recju.(scanf) -- info\n");
	printf("Unesite poruku za slanje: ");
	scanf("%s", poruka.tekst);
	//fgets(poruka.tekst, sizeof(poruka.tekst), stdin);
	

	
	int randomKlijent = rand() % n + 1;
	printf("Saljem poruku tipa %d, sadrzaj: %s\n", randomKlijent, poruka.tekst);
	
	msgsnd(msgid, &poruka, sizeof(poruka), 0);
	
	printf("Moja misija je ovde gotova...\n");
	
    return 0;
}
