#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
void signal_handler_dete(int sig){
	printf("DETE: Prekinuo me je proces roditelj.\n");
	kill(0,SIGKILL);
}
void signal_handler_roditelj(int sig){
	printf("RODITELJ: Prekinuo me je proces dete.\n");
	kill(getppid(),SIGKILL);
}
int main(){
	
	int n;
	int pid;
	pid=fork();
	
	srand(time(NULL));
	
	if(pid==0){
		//proces dete
		signal(SIGINT,signal_handler_roditelj);
		n=rand()%20;
		for(int i=1;i<=n;i++){
			printf("DETE: %d\n",i);
			sleep(2);
		}
		kill(getppid(),SIGINT);
	}
	else if(pid==-1){
		printf("Greska pri forkovanju!\n");
		exit(0);
	}
	else{
		//proces roditelj
		signal(SIGINT,signal_handler_dete);
		n=rand()%20;
		for(int i=1;i<=n;i++){
			printf("RODITELJ: %d\n",i);
			sleep(2);
		}
		kill(0,SIGINT);
	}
	
	return 0;
}
