#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct msg
{
	long tip;
	long pid;
	int broj;
	int ukupanBroj;
	int slucajanBr;
	char tekst[50];
};

int main()
{
	int idReda;
	int idReda2;
	key_t kljuc;
	struct msg zaServer,odServera,drugaServer,odMene,zaMene;
	
	kljuc = ftok("./server.c",'A');
	
	idReda = msgget(kljuc,IPC_CREAT | 0666);
	
	zaServer.tip = 1;
	zaServer.pid = getpid();
	printf("Prijavljujem se serveru.Moj pid je %d\n",getpid());
	msgsnd(idReda,&zaServer,sizeof(zaServer),0);
	
	msgrcv(idReda,&odServera,sizeof(odServera),getpid(),0);
	printf("Primio sam broj %d,a ukupan broj klijenata je %d\n",odServera.broj,odServera.ukupanBroj);
	
	sleep(5);
	
	int broj = odServera.broj;
	int slucajan = odServera.slucajanBr;
	
	if(broj == slucajan)
	{
		printf("Cekam poruku od servera tipa %d\n",broj);
		msgrcv(idReda,&drugaServer,sizeof(drugaServer),broj,0);
		sleep(2);
		printf("Primio sam poruku %s\n",drugaServer.tekst);
		
		int br2 = rand()%drugaServer.ukupanBroj + 1;
		
		idReda2 = msgget(kljuc,IPC_CREAT | 0666);
		printf("Uneti poruku za drugog klijenta\n");
		fgets(odMene.tekst,sizeof(odMene.tekst),stdin);
		printf("Saljem poruku klijentu broj %d\n",br2);
		printf("Poruka je %s\n",odMene.tekst);
		odMene.tip = br2;
		msgsnd(idReda2,&odMene,sizeof(odMene),0);
		
	}
	
	int tip = odMene.tip;
	
	if(broj == tip)
	{
		printf("Cekam poruku od klijenta tipa %d\n",tip);
		msgrcv(idReda,&zaMene,sizeof(zaMene),tip,0);
		sleep(2);
		printf("Primio sam poruku %s\n",zaMene.tekst);
	}

}
