#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

int pid;
int ind;

void handler(int sig)
{
	if(pid == 0)
	{
		printf("Dete:Prekinuo me je proces roditelj\n");
		kill(getpid(),SIGKILL);
		kill(pid,SIGKILL);
	}
	else
	{
		printf("Roditelj:Prekinuo me je proces dete\n");
		kill(pid,SIGKILL);
		kill(getpid(),SIGKILL);
	}
}

void handler2(int sig)
{
	if(ind == 1)
	{
		printf("Roditelj:Prekinuo me je proces dete\n");
		kill(pid,SIGKILL);
	}
	else
	{
		printf("Dete:Prekinuo me je proces roditelj\n");
		kill(getpid(),SIGKILL);
	}
}

int main()
{
	int n,i;
	srand(time(NULL));
	
	signal(SIGINT,handler);
	
	pid = fork();
	
	if(pid == -1)
	{
		printf("Greska\n");
		exit(0);
	}
	else if(pid == 0)
	{
		signal(SIGINT,handler2);
		n = rand()%20;
		printf("Dete:Slucajan broj:%d\n",n);
		for(i=1;i<=n;i++)
		{
			printf("Dete:%d\n",i);
			sleep(2);
		}
		ind = 1;
	}
	else
	{
		signal(SIGINT,handler2);
		n = rand()%30;
		printf("Roditelj:Slucajan broj:%d\n",n);
		for(i=1;i<=n;i++)
		{
			printf("Roditelj:%d\n",i);
			sleep(2);
		}
		ind = 2;
	}
}
