#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct msg
{
	long tip;
	long pid;
	int broj;
	int ukupanBroj;
	int slucajanBr;
	char tekst[50];
};

int main()
{
	int n,i;
	int idReda;
	key_t kljuc;
	struct msg poruka,poslata,zaKlijenta;
	
	kljuc = ftok("./server.c",'A');
	
	idReda = msgget(kljuc,IPC_CREAT | 0666);
	
	scanf("%d",&n);
	
	int br = rand()%n +1;
	
	for(i=1;i<=n;i++)
	{
		msgrcv(idReda,&poruka,sizeof(poruka),1,0);
		printf("Prijavio se klijent sa pid-om %ld\n",poruka.pid);
		poslata.tip = poruka.pid;
		poslata.broj = i;
		poslata.pid = getpid();
		poslata.ukupanBroj = n;
		poslata.slucajanBr = br;
		msgsnd(idReda,&poslata,sizeof(poslata),0);
	}
	
	printf("Uneti poruku za klijenta:\n");
	
	char s[50];
	scanf("%s",s);
	strcpy(zaKlijenta.tekst,s);
	printf("Saljem poruku klijentu broj %d\n",br);
	printf("Poruka je %s\n",zaKlijenta.tekst);
	zaKlijenta.tip = br;
	msgsnd(idReda,&zaKlijenta,sizeof(zaKlijenta),0);
}
