#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka{
	int tip;
	int redniBroj;
	char tekst[100];
	int ukupno;
}poruka;

int main()
{
	key_t kljuc;
	int id_reda;
	poruka poruka1;
	int brojKomeSalje;
	
	kljuc=ftok("klijent.txt",66);
	id_reda=msgget(kljuc,IPC_CREAT|0666);
	
	poruka1.tip=21;
	
	while(1)
	{
		printf("Saljem poruku(za prijavu) tip %d\n",poruka1.tip);
		msgsnd(id_reda,&poruka1,sizeof(poruka1),0);
		//poslao prijavu
	
		printf("Cekam poruku tip %d\n",poruka1.tip);
		msgrcv(id_reda,&poruka1,sizeof(poruka1),1,0);
		//primio
		printf("Primio sam poruku(prijava) tip %d\n",poruka1.tip);
	}
	msgrcv(id_reda,&poruka1,sizeof(poruka1),1,0);
	printf("Klijent: Ukupno je prijavljeno %d\n",poruka1.ukupno);
	
	while(1)
	{
		printf("Cekam poruku tip %d\n",poruka1.tip);
		msgrcv(id_reda,&poruka1,sizeof(poruka1),1,0);
		
		printf("Primio sam poruka: tip %d, tekst_poruke %s\n",poruka1.tip,poruka1.tekst);
		
		brojKomeSalje=rand()%20+1;
		
		if(brojKomeSalje<poruka1.ukupno) 
			poruka1.tip=brojKomeSalje;
		else {
			brojKomeSalje=rand()%20+1;
			while(brojKomeSalje>poruka1.ukupno)
			{
				brojKomeSalje=rand()%20+1;
			}
		}
		poruka1.tip=brojKomeSalje;
		
		printf("Unesite poruku za slanje: \n");
		fgets(poruka1.tekst,99,stdin);
		
		printf("Saljem poruku tip %d , tekst_poruke %s\n",poruka1.tip,poruka1.tekst);
		msgsnd(id_reda,&poruka1,sizeof(poruka1),0);
	}
	
}
