#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct imi_poruka
{
	long tip_poruke;
	char tekst_poruke[50];
	pid_t PID;
	int redni_broj;
	int ukupanBrojPrijavljenih;
};

int main()
{
	srand(time(NULL));
	key_t kljuc;
	int id_reda;
	struct imi_poruka moja_poruka;

	kljuc = ftok("./text.txt",65);
	id_reda = msgget(kljuc,IPC_CREAT|0666);

	moja_poruka.tip_poruke = 1;
	moja_poruka.PID = getpid();

	msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
	msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),moja_poruka.PID,0);
	printf("redni broj: %d\n",moja_poruka.redni_broj );
	int pom = moja_poruka.redni_broj;

	int slucajanRedniBroj;


	while(1)
	{
		moja_poruka.tip_poruke = pom;
		printf("moj redni broj: %d\n",moja_poruka.redni_broj );
		
		slucajanRedniBroj = rand() % moja_poruka.ukupanBrojPrijavljenih + 1;

		while(slucajanRedniBroj == moja_poruka.redni_broj)
		{
			slucajanRedniBroj = rand() % moja_poruka.ukupanBrojPrijavljenih + 1;
		}

		printf("Cekam poruku tipa: %d\n",slucajanRedniBroj );
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),slucajanRedniBroj,0);
		printf(" tip: %ld\n",moja_poruka.tip_poruke );
		printf("primljena poruka: %s\n",moja_poruka.tekst_poruke );

		

		slucajanRedniBroj = rand() % moja_poruka.ukupanBrojPrijavljenih + 1;

		while(slucajanRedniBroj == moja_poruka.redni_broj)
		{
			slucajanRedniBroj = rand() % moja_poruka.ukupanBrojPrijavljenih + 1;
		}

		printf("Unesite poruku:\n");
		fgets(moja_poruka.tekst_poruke,50,stdin);
		moja_poruka.tekst_poruke[strlen(moja_poruka.tekst_poruke) - 1] = '\0';
		pom = moja_poruka.tip_poruke;
		moja_poruka.tip_poruke = slucajanRedniBroj;

		printf("Saljem poruku: %d, %s\n",slucajanRedniBroj,moja_poruka.tekst_poruke );
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
		//moja_poruka.redni_broj = pom;
		//printf("moj redni broj: %d\n",moja_poruka.redni_broj );

	}
}