#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>

pid_t pid;

void singal_handler()
{
	if(pid == 0)
	{
		printf("Roditelj: prekinuo me je proces dete!\n" );
		kill(getpid(),SIGINT);
		//exit(0);
	}
	else
	{
		printf("Dete: Prekinuo me je proces roditelj!\n");
		kill(pid,SIGINT);
		//exit(0);
	}
}

int main()
{
	int i,n;
	
	srand(time(NULL));
	

	pid = fork();

	if(pid == 0)
	{
		signal(SIGINT,singal_handler);
		n = rand() % 20;
		for(i=0; i<n;i++)
		{
			printf("dete: %d\n",i );
			sleep(2);
		}

		kill(getppid(),SIGINT);

	}
	else
	{
		signal(SIGINT,singal_handler);
		n = rand() % 20;
		for(i=0; i< n;i++)
		{
			printf("roditelj: %d\n",i);
			sleep(2);
		}

		kill(getpid(),SIGINT);

	}
}
