#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct imi_poruka
{
	long tip_poruke;
	char tekst_poruke[50];
	pid_t PID;
	int redni_broj;
	int ukupanBrojPrijavljenih;
};

int main()
{
	key_t kljuc;
	int id_reda;
	struct imi_poruka moja_poruka;

	kljuc = ftok("./text.txt",65);
	id_reda = msgget(kljuc,IPC_CREAT|0666);

	int i,n;

	n = rand() % 20;
	n=2;

	for(i=0; i<n;i++)
	{
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),1,0);
		moja_poruka.tip_poruke = moja_poruka.PID;
		moja_poruka.redni_broj = i + 1;
		moja_poruka.ukupanBrojPrijavljenih = n;
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
	}

	int slucajanRedniBroj;

	slucajanRedniBroj = rand() % n + 1;
	moja_poruka.tip_poruke = slucajanRedniBroj;

	printf("Unesite poruku:\n");
	fgets(moja_poruka.tekst_poruke,50,stdin);
	moja_poruka.tekst_poruke[strlen(moja_poruka.tekst_poruke) - 1] = '\0';

	msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);


}