#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


int semid;

union semun
{
    int val;
    struct semid_ds *buff;
    ushort *array;
};

int **kosevi;

void signalHandler(int signal)
{
    int i;
    for(i = 0; i < 4; i++)
    {
        printf("Kos %d: %d\n", i, *(kosevi[i]));
    }
    
    exit(1);
}
int main()
{
    srand(time(NULL));
    signal(SIGINT, signalHandler);


    key_t kljuc;
    kljuc = ftok("./Igrac.c", 20);
    union semun arg;
    struct sembuf P1, V1, P2, V2, P3, V3, P4, V4, P5, V5, P6, V6;
    int *shm1, shm2, shm3, i, n, ind, sut, pogodak;
    int *stalak, *maxBr;
    key_t k1, k2, k3;

    k1 = ftok("./Igrac.c", 10);
    k2 = ftok("./Igrac.c", 11);
    k3 = ftok("./Igrac.c", 12);

    semid = semget(kljuc, 6, 0666 | IPC_CREAT | IPC_EXCL);
    
    shm1 = (int*)calloc(4, sizeof(int));
    shm2 = shmget(k2, sizeof(int), 0666 | IPC_CREAT);   //stalak
    shm3 = shmget(k3, sizeof(int), 0666 | IPC_CREAT);   //max broj lopti u stalku

    kosevi = (int**)malloc(4*sizeof(int*));
    stalak = shmat(shm2, NULL, 0);
    maxBr = shmat(shm3, NULL, 0);

    if(semid != -1)
    {
        arg.val = 1;
        semctl(semid, 0, SETVAL, arg);  //stalak
        semctl(semid, 1, SETVAL, arg);  //kos1
        semctl(semid, 2, SETVAL, arg);  //kos2
        semctl(semid, 3, SETVAL, arg);  //kos3
        semctl(semid, 4, SETVAL, arg);  //kos4
        semctl(semid, 5, SETVAL, arg);  //pom
    }
    else if(errno == EEXIST)
    {
        semid = semget(kljuc, 6, 0);
    }
    else
    {
        printf("Greska.\n");
        exit(0);
    }

    for(i = 0; i < 4; i++)
    {
        k1 = ftok("./Igrac.c", i+1);
        shm1[i] = shmget(k1, sizeof(int), 0666 | IPC_CREAT);
        kosevi[i] = shmat(shm1[i], NULL, 0);
    }

    P1.sem_num = 0; P1.sem_op = -1; P1.sem_flg = 0; //stalak
    V1.sem_num = 0; V1.sem_op = 1; V1.sem_flg = 0; //stalak
    
    P2.sem_num = 1; P2.sem_op = -1; P2.sem_flg = 0; //kos1
    V2.sem_num = 1; V2.sem_op = 1; V2.sem_flg = 0; //kos1

    P3.sem_num = 2; P3.sem_op = -1; P3.sem_flg = 0; //kos2
    V3.sem_num = 2; V3.sem_op = 1; V3.sem_flg = 0; //kos2

    P4.sem_num = 3; P4.sem_op = -1; P4.sem_flg = 0; //kos3
    V4.sem_num = 3; V4.sem_op = 1; V4.sem_flg = 0; //kos3

    P5.sem_num = 4; P5.sem_op = -1; P5.sem_flg = 0; //kos4
    V5.sem_num = 4; V5.sem_op = 1; V5.sem_flg = 0; //kos4

    P6.sem_num = 5; P6.sem_op = -1; P6.sem_flg = 0; //
    V6.sem_num = 5; V6.sem_op = 1; V6.sem_flg = 0; //

    scanf("%d", &n);

    
    ind = semop(semid, &P1, 1);
    if(ind == -1) { printf("a\n");return 0;} 
    

    *stalak = n;

    ind = semop(semid, &V1, 1);
    if(ind == -1) { printf("ad\n");return 0;}

    
    ind = semop(semid, &P6, 1);
    if(ind == -1) { printf("daa\n");return 0;}

    *maxBr = n;

    ind = semop(semid, &V6, 1);
    if(ind == -1) return 0;
    
    //printf("daa\n");
    //////////////////////////////////////////////////////

    ind = semop(semid, &P1, 1);
    if(ind == -1) return 0;

    (*stalak)--;
    printf("Uzimam loptu\n");
    sleep(1);

    sut = rand() % 4;
    printf("Sutiram na kos %d\n", sut);
    sleep(3);
    pogodak = rand() % 2;

    if(pogodak == 1)
    {
        printf("Pogodak!!!\n");
        switch(sut)
        {
            case 0:
                    ind = semop(semid, &P2, 1);
                    if(ind == -1) return 0;

                    *(kosevi[0])++;

                    ind = semop(semid, &V2, 1);
                    if(ind == -1) return 0;
                    break;
             
            case 1:
                    ind = semop(semid, &P3, 1);
                    if(ind == -1) return 0;

                    *(kosevi[1])++;

                    ind = semop(semid, &V3, 1);
                    if(ind == -1) return 0;

            case 2:
                    ind = semop(semid, &P4, 1);
                    if(ind == -1) return 0;

                    *(kosevi[2])++;

                    ind = semop(semid, &V4, 1);
                    if(ind == -1) return 0;

            case 3:
                    ind = semop(semid, &P5, 1);
                    if(ind == -1) return 0;

                    *(kosevi[3])++;

                    ind = semop(semid, &V5, 1);
                    if(ind == -1) return 0;
        }
    }
    else
    {
        printf("Promasaj...\n");
    }

    ind = semop(semid, &V1, 1);
    if(ind == -1) return 0;

    return 0;
}