#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid;

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void izbrisiSemafore()
{
	printf("Brisem semafore!!!\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	semctl(semid, 4, IPC_RMID);
	exit(0);
}

struct data
{
	int ukupno;
	int stalak;
	int kos1;
	int kos2;
	int kos3;
	int kos4;
};

int main()
{
	srand(time(NULL));
	int kos;
	signal(SIGINT, izbrisiSemafore);
	key_t kljuc;
	int shmid, ind;
	struct data *data;
	//union semun arg;
	struct sembuf P, V, PK, VK;
	//int n;
	
	kljuc = ftok("./igrac.c", 'A');
	printf("Kljuc je %d\n", kljuc);
	
	shmid = shmget(kljuc, sizeof(int), 0666 | IPC_CREAT);
	printf("Shmid je %d\n", shmid);
	
	data  = (struct data *)shmat(shmid, NULL, 0);
	
	semid = semget(kljuc, 5, 0); // samo se kacim
	
	P.sem_num = 0;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	V.sem_num = 0;
	V.sem_op = 1;
	V.sem_flg = 0;
	
	while(1)
	{
		printf("Smanjujem semafor 0 iz skupa %d za vrednost 1\n", semid);
		sleep(3);
		ind = semop(semid, &P, 1);
		if(ind == -1) break;
		int br;
		
		if(data->stalak > 0)
		{
			br = data->stalak;
			printf("Uzimam loptu...\n");
			sleep(1);
			data->stalak--;
			printf("Lopta je uzeta, stanje na stalku je %d\n", data->stalak);
		}
		
		printf("Povecavam semafor 0 iz skupa %d za vrednost 1\n", semid);
		sleep(3);
		ind = semop(semid, &V, 1);
		if(ind == -1) break;
		
			kos = (rand() % 4) + 1;
			
			PK.sem_num = kos;
			PK.sem_op = -1;
			PK.sem_flg = 0;
			
			VK.sem_num = kos;
			VK.sem_op = 1;
			VK.sem_flg = 0;
			
			if(br > 0)
			{
				printf("Smanjujem semafor %d iz skupa %d za vrednost 1\n", kos, semid);
				sleep(3);
				ind = semop(semid, &PK, 1);
				if(ind == -1) break;
				
					printf("Sutiram na kos broj %d\n", kos);
					sleep(3);
					int r = rand() % 2;
					if(r == 0)
						printf("Promasili ste!!!\n");
					else
					{
						printf("Lopta je usla u kos!!!\n");
						if(kos == 1)
						{
							data->kos1++;
							printf("Stanje u kosu broj %d je: %d\n", kos, data->kos1);
						}
						else if(kos == 2)
						{
							data->kos2++;
							printf("Stanje u kosu broj %d je: %d\n", kos, data->kos2);
						}
						else if(kos == 3)
						{
							data->kos3++;
							printf("Stanje u kosu broj %d je: %d\n", kos, data->kos3);
						}
						else if(kos == 4)
						{
							data->kos4++;
							printf("Stanje u kosu broj %d je: %d\n", kos, data->kos4);
						}
					}
				printf("Povecavam semafor %d iz skupa %d za vrednost 1\n", kos, semid);
				sleep(3);
				ind = semop(semid, &VK, 1);
				if(ind == -1) break;
			}
	}
	
	return 0;
}
