#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid;

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void izbrisiSemafore()
{
	printf("Brisem semafore!!!\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	semctl(semid, 4, IPC_RMID);
	exit(0);
}

struct data
{
	int ukupno;
	int stalak;
	int kos1;
	int kos2;
	int kos3;
	int kos4;
};

int main()
{
	signal(SIGINT, izbrisiSemafore);
	key_t kljuc;
	int shmid;
	struct data *data;
	union semun arg;
	//struct sembuf P, V;
	int n;
	
	kljuc = ftok("./igrac.c", 'A');
	printf("Kljuc je %d\n", kljuc);
	
	shmid = shmget(kljuc, sizeof(int), 0666 | IPC_CREAT);
	printf("Shmid je %d\n", shmid);
	
	semid = semget(kljuc, 5, 0666 | IPC_CREAT);
	printf("Semid je %d\n", shmid);
	
	data  = (struct data *)shmat(shmid, NULL, 0);
	printf("Unesite broj lopti:");
	scanf("%d", &n);
	data->ukupno = n;
	data->stalak = n;
	data->kos1 = 0;
	data->kos2 = 0;
	data->kos3 = 0;
	data->kos4 = 0;
	
	printf("Semafor kreiran.\n");
	
	// svi kosevi i stalak na pocetku imaju vrednost 1
	arg.val = 1;
	semctl(semid, 0, SETVAL, arg); // stalak je semafor 0
	semctl(semid, 1, SETVAL, arg);
	semctl(semid, 2, SETVAL, arg);
	semctl(semid, 3, SETVAL, arg);
	semctl(semid, 4, SETVAL, arg);
	
	while(1)
	
	return 0;
}

