#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid;

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void izbrisiSemafore()
{
	printf("Brisem semafore!!!\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	semctl(semid, 4, IPC_RMID);
	exit(0);
}

struct data
{
	int ukupno;
	int stalak;
	int kos1;
	int kos2;
	int kos3;
	int kos4;
};

int main()
{
	signal(SIGINT, izbrisiSemafore);
	key_t kljuc;
	int shmid, ind;
	struct data *data;
	//union semun arg;
	struct sembuf P, V;
	
	kljuc = ftok("./igrac.c", 'A');
	printf("Kljuc je %d\n", kljuc);
	
	shmid = shmget(kljuc, sizeof(int), 0666 | IPC_CREAT);
	printf("Shmid je %d\n", shmid);
	
	semid = semget(kljuc, 1, 0666 | IPC_CREAT | IPC_EXCL);
	printf("Semid je %d\n", shmid);
	
	data  = (struct data *)shmat(shmid, NULL, 0);
	
	semid = semget(kljuc, 5, 0); // samo se kacim
	
	P.sem_num = 0;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	V.sem_num = 0;
	V.sem_op = 1;
	V.sem_flg = 0;
	
	while(1)
	{
		printf("Smanjujem semafor 0 iz skupa %d za vrednost 1\n", semid);
		sleep(3);
		ind = semop(semid, &P, 1);
		if(ind == -1) break;
		
		if(data->stalak < data->ukupno)
		{
			printf("Vracam loptu.\n");
			sleep(2);
			data->stalak++;
			printf("Lopta vracena, stanje na stalku je %d\n", data->stalak);
		}
		
		printf("Povecavam semafor 0 iz skupa %d za vrednost 1\n", semid);
		sleep(3);
		ind = semop(semid, &V, 1);
		if(ind == -1) break;
	}
	
	
	
	return 0;
}

