#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <time.h>
#include <signal.h>

#define NE 0
#define DA 1
#define n 6
#define m 2

typedef struct igra{
	int kos[4];
	int brIgraca;
	int naRedu;
	int stalak;
}igra;

void signal_handler(int sig){
	//int j;
	//for(j=0; j<4; j++){
	//	printf("%d %d %d %d.\n", i->kos[j]);
	//}
	printf("Primio SIGINT.\n");
	exit(0);
}
typedef union sem_un{
	int val;
	struct semid_ds *buf;
	ushort *array;
}sem_un;

int main(){
	srand(time(NULL));
	signal(SIGINT, signal_handler);
	//kljuc za deljenu memoriju
	key_t key1 = ftok("Zadatak2.c", 'a');
	//kljuc za semafore
	key_t key2 = ftok("Zadatak2.c", 'b');
	
	int shmid = shmget(key1, sizeof(igra), 0644|IPC_CREAT|IPC_EXCL);
	int semid = semget(key2, 1, 0644|IPC_CREAT|IPC_EXCL);
	int j;
	igra *i;
	i = shmat(shmid, NULL, 0);
	sem_un sem_in;
	printf("Inicijalizacija semafora.\n");
	if(semid!=-1){
		sem_in.val = 1;
		i->brIgraca = 0;
		i->stalak = n;
		for(j=0; j<4; j++)
			i->kos[j] = 0;
		semctl(semid, 1, SETVAL, sem_in);
	}
	else
		semid = semget(key2, 1, 0644|IPC_CREAT|IPC_EXCL);
	
	//ENTER REGION KRITICNE SEKCIJE
	printf("Smanjujem semafor(semid:%d) iz unije(sem_un:%d) za vrednost 1.\n", semid, sem_in);
	struct sembuf sem;
	sem.sem_num = 0;
	sem.sem_op = -1;
	sem.sem_flg = 0;
	semop(semid, &(sem), 1);
	//postavljanje vrednosti
	
	if(i->brIgraca==0){
		i->naRedu = 1;
	}
	int igrac = i->brIgraca+1;
	i->brIgraca++;
	printf("izlazim");
	//LEAVE REGION KRITICNE SEKCIJE
	printf("Povecavam semafor(semid:%d) iz unije(sem_un:%d) za vrednost 1.\n", semid, sem_in);
	sem.sem_num = 0;
	sem.sem_op = 1;
	sem.sem_flg = 0;
	semop(semid, &(sem), 1);
	printf("Igrac %d.\n", i->brIgraca);
	//igraci moraju da se sacekaju, inace nece biti sinhronizivan proces
	while(i->brIgraca!=m);
	while(1){
		if(igrac == i->naRedu){
			int brkos = rand()%4;
			printf("Igrac sutira na kos sa rednim brojem %d.", brkos);
			sleep(1);
			int pogodak = rand()%2;
			
			if(pogodak==DA){
				printf("Pogodak igraca %d na kos %d.\n", i->brIgraca, brkos);
				i->kos[brkos]+=1;
			}
			else{
				printf("Igrac %d je promasio kos %d.\n", i->brIgraca, brkos);
			}
			i->stalak-=1;
			//ako se iskoriste sve lopte sa stalka
			if(i->stalak==0){
				i->stalak = n;
				sleep(2);
			}
			sleep(3);
			i->naRedu++;
		}
	}
	shmdt(i);
	return 0;
}
