#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct porukica{
	long tip;
	long pid;
	int redniBroj;
	int brKlijenata;
	char tekst[100];
}porukica;

int main(){
	
	srand(time(NULL));
	
	key_t kljuc;
	int id_reda;
	porukica p;
	int rbr,rnd,brk;
	
	kljuc = ftok("./server.c",16);
	id_reda = msgget(kljuc,IPC_CREAT|0666);
	
	p.tip = 100;
	p.pid = getpid();
	
	printf("SALJEM PORUKU: Tip: 100 - Pid: %ld\n",p.pid);
	msgsnd(id_reda,&p,sizeof(p),0);
	sleep(1);
	printf("CEKAM PORUKU: Tip: %d\n",getpid());
	msgrcv(id_reda,&p,sizeof(p),getpid(),0);
	printf("PRIMLJENA PORUKA: Tip: %ld - Redni broj: %d\n",p.tip,p.redniBroj);
	rbr = p.redniBroj;
	printf("CEKAM PORUKU: Tip: %d\n",rbr+50);
	msgrcv(id_reda,&p,sizeof(p),rbr+50,0);
	printf("PRIMLJENA PORUKA: Tip: %ld - Broj klijenata: %d\n",p.tip,p.brKlijenata);
	brk = p.brKlijenata;
	
	printf("CEKAM PORUKU: Tip: %d\n",rbr);
	msgrcv(id_reda,&p,sizeof(p),rbr,0);
	printf("\nPRIMLJENA PORUKA: Tip: %ld - Redni broj: %d - Tekst: %s\n",p.tip,p.redniBroj,p.tekst);
	
	rnd = rand()%brk;
	rnd++;
	
	while(1602){
		while(rnd != rbr){
			printf("\nSlucajno biram klijenta sa rednim brojem: %d\n",rnd);
			printf("Unesite poruku:\n");
			scanf("%s",p.tekst);
			p.tip = rnd;
			p.redniBroj = rbr;
			printf("SALJEM PORUKU: Tip: %ld - Redni broj: %d - Tekst: %s\n",p.tip,p.redniBroj,p.tekst);
			msgsnd(id_reda,&p,sizeof(p),0);
			sleep(1);
			printf("CEKAM PORUKU: Tip: %d\n",rbr);
			msgrcv(id_reda,&p,sizeof(p),rbr,0);
			printf("\nPRIMLJENA PORUKA: Tip: %ld - Redni broj: %d - Tekst: %s\n",p.tip,p.redniBroj,p.tekst);
			rnd = rand()%brk;
			rnd++;
		}
		rnd = rand()%brk;
		rnd++;
	}

	return 0;
}
