#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define MAX 20

void handle1(int sig)
{
	printf("Prekinuo me je proces roditelj.\n");
	
}

void handle2(int sig)
{
	printf("Prekinuo me je proces dete.\n");
	
}

int main()
{
	pid_t pid,pidd;
	
	pid = fork();
	
	if(pid == -1)
	{
		printf("Greska.");
		
		exit(1);
	}
	else if(pid == 0)
	{
		// dete
		int i;
	    int N;
		signal(SIGINT,handle1);
		
		N = rand() % MAX; 
		//N=9;
		
		for(i=1;i<N;i++)
		{
			printf("DETE: \n");
			printf("%d\n",i);
			
			sleep(2);
		}
		
		pidd = getppid();  
		
		kill(pidd,SIGINT);
		
		exit(0);
		
	}
	else
	{
		//roditelj
		int i;
		signal(SIGINT,handle2);
	    int N;
		
		N = rand() % MAX;
		
		//N=4;
		
		for(i=1;i<N;i++)
		{
			printf("RODITELJ: \n");
			printf("%d\n",i);
			
			sleep(2);
		}
		
		kill(pid,SIGINT);
		
		exit(0);
		
	}
	
	return 0;
	
	}
