#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka
{
    long tip;
    int N;
    int redniBroj;
    pid_t pid;
    char tekst[100];
}poruka;

int main()
{
    int i, N, ind;
    key_t kljuc;
    int redid, r;
    poruka mojaPoruka;

    kljuc = ftok("./server.c", 33);
    redid = msgget(kljuc, 0666 | IPC_CREAT);

    //printf("%d\n%d\n", kljuc, redid);

    scanf("%d", &N);

    for(i = 1; i <= N; i++)
    {
        ind = msgrcv(redid, &mojaPoruka, sizeof(mojaPoruka), 27, 0);
        if(ind == -1) break;

        mojaPoruka.tip = mojaPoruka.pid;
        mojaPoruka.redniBroj = i;

        ind = msgsnd(redid, &mojaPoruka, sizeof(mojaPoruka), 0);
        if(ind == -1) break;
    }

    for(i = 1; i <= N; i++)
    {
        poruka mojaPoruka;
        mojaPoruka.tip = i;
        mojaPoruka.N = N;

        ind = msgsnd(redid, &mojaPoruka,sizeof(mojaPoruka), 0);
        if(ind == -1) break;
        
    }

    scanf("%s", mojaPoruka.tekst);
    r = rand() % N;
    r++;

    mojaPoruka.tip = r;

    printf("Saljem poruku %ld %s\n", mojaPoruka.tip, mojaPoruka.tekst);

    msgsnd(redid, &mojaPoruka, sizeof(mojaPoruka), 0);

    return 0;
}