#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

void deteHandler(int sig)
{
	printf("Dete :Prekinuo me je proces roditelj\n");
	exit(0);
}

void roditeljHandler(int sig)
{
	printf("Roditelj :Prekinuo me je proces dete\n");
	exit(0);
}

int main()
{
	pid_t pid;
	int n,i;
	pid=fork();
	
	srand(time(NULL));
	if(pid == -1)
	{
		printf("Desila se greska\n");
		
	}
	else if(pid==0)
	{
		srand(time(NULL));
		n=rand()%20;
		printf("Dete ide do %d\n",n);
		
		for(i=1;i<=n;i++)
		{
			signal(SIGINT,deteHandler);
			printf("Dete: %d\n",i);
			sleep(2);
		}
		kill(getppid(),SIGINT);
		sleep(10);
	}
	else
	{
		srand(time(NULL));
		n=rand()%20;
		printf("Roditelj ide do %d\n",n);
		
		for(i=1;i<=n;i++)
		{
			signal(SIGINT,roditeljHandler);
			printf("Roditelj: %d\n",i);
			sleep(2);
		}
		kill(pid,SIGINT);
		sleep(10);
	}
}
