#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

void signal_handler1(int sig)
{
	printf("\nRoditelj: Prekinuo me je proces dete\n");
}

void signal_handler2(int sig)
{
	printf("\nDete: Prekinuo me je proces roditelj\n");

}

int main()
{
	srand(time(NULL));
	int n,i,rv;
	
	pid_t pid;
	pid=fork();
	
	switch(pid)
	{
		case -1:
			printf("Greska\n");
			exit(0);
		case 0:
		 
			signal(SIGINT,signal_handler2);
			n=rand()%20;
			printf("n=%d\n",n);
			for(i=1;i<=n;i++)
			{
				printf("DETE %d\n",i);
				sleep(2);
			}
			kill(getppid(),SIGINT);
			exit(0);
		
		default:

			signal(SIGINT,signal_handler1);
			n=rand()%20;
			printf("n=%d\n",n);
			for(i=1;i<=n;i++)
			{
				printf("RODITELJ %d\n",i);
				sleep(2);
			}
			kill(pid,SIGINT);
			wait(&rv);
			
		
	}
	return 0;
}
