#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct _imi_poruka_
{
	long tip_poruke;
	long pid_poruke;
	int redni_broj_poruke;
	char tekst_poruke[50];
	long niz_klijenata[50];
}imi_poruka;

int main(int argc,char **argv)
{
	srand(time(NULL));
	imi_poruka moja_poruka;
	key_t key = ftok("server.c",65);
	int msgid = msgget(key,IPC_CREAT|0666);
	int redni_broj,ukupno_prijavljenih,daj_random;
	
	moja_poruka.tip_poruke = 21;
	moja_poruka.pid_poruke = getpid();
	
	msgsnd(msgid,&moja_poruka,sizeof(moja_poruka),0);
	printf("Poslao zahtev za prijavljivanje\n");
	msgrcv(msgid,&moja_poruka,sizeof(moja_poruka),getpid(),0);
	redni_broj = moja_poruka.redni_broj_poruke;
	printf("Moj redni broj je %d\n",redni_broj);
	
	msgrcv(msgid,&moja_poruka,sizeof(moja_poruka),getpid(),0);
	ukupno_prijavljenih = moja_poruka.redni_broj_poruke;
	printf("Ukupno prijavljenih je %d\n",ukupno_prijavljenih);
	
	int niz[50],i;
	
	for (i = 0; i < ukupno_prijavljenih; i++)
	{
		niz[i] = moja_poruka.niz_klijenata[i];
		//printf("%d\n",niz[i]);
	}
	
	while(1)
	{
		printf("Cekam poruku X\n");
		msgrcv(msgid,&moja_poruka,sizeof(moja_poruka),getpid(),0);
		printf("Primljena poruka: tip %d ,tekst_poruke %s\n",getpid(),moja_poruka.tekst_poruke);
		
		daj_random = rand() % ukupno_prijavljenih;
		
		printf("Ispod uneti poruku koju saljes random klijentu\n");
		scanf("%s",moja_poruka.tekst_poruke);
		while(niz[daj_random] == getpid()) daj_random = rand() % ukupno_prijavljenih;
		moja_poruka.tip_poruke = moja_poruka.niz_klijenata[daj_random];
		printf("Saljem poruku: tip %d ,tekst_poruke %s\n",niz[daj_random],moja_poruka.tekst_poruke);
		msgsnd(msgid,&moja_poruka,sizeof(moja_poruka),0);
	}
	
	exit(0);
	
}
