#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka{
	long tip_poruke;
	int rbr;
	char tekst_poruke[100];
}Poruka;

int main()
{
	key_t kljuc;
	int id_reda;
	Poruka moja_poruka;
	int za_forkovanje, ko_igra=3, rbr, pom, provera;
	
	kljuc=ftok("./sredinica.c", 100);
	id_reda=msgget(kljuc, IPC_CREAT|0666);
	
	za_forkovanje=fork();
	
	if (za_forkovanje==-1)
	{
		printf("Doslo je do greske prilikom forkovanja\n");
	}
	else if(za_forkovanje==0)//ovde je prvo dete
	{
		rbr=2;
		while(1)
			{
				if(ko_igra==1)// igraju prvo dete i roditelj
				{
					//prvo primam poruku
					printf("rbr %d : Cekam poruku tipa 1, tekst_poruke\n", rbr);
					msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 1, 0);
					
					moja_poruka.tip_poruke=1;
					moja_poruka.rbr=rbr;
					printf("rbr %d : Saljem poruku : tip_poruke %ld, tekst_poruke\n",rbr, moja_poruka.tip_poruke);
					sleep(3);
					msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
				}
				else if(ko_igra==3)// igraju prvo i drugo dete
				{
					//prvo dete prvo salje, a drugo dete prvo prima
					moja_poruka.tip_poruke=3;
					moja_poruka.rbr=rbr;
					printf("rbr %d : Saljem poruku : tip_poruke 3, tekst_poruke\n",rbr);
					sleep(3);
					msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
					
					printf("rbr %d : Cekam poruku tipa 3, tekst_poruke\n", rbr);
					msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 3, 0);
				}
				else
				{
					printf("rbr %d : Cekam poruku, tekst_poruke\n", rbr);
					provera=msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), rand()%4, IPC_NOWAIT);
					
					sleep(2);
					if(provera!=-1)
					{
						
						pom=moja_poruka.rbr;
						
						if(pom==3)
						{
							ko_igra=1;//uhvacena poruka drugog deteta igraju roditelj i prvo
							
							moja_poruka.tip_poruke=1;
							printf("Obavestavam da sam uhvatio poruku\n");
							sleep(3);
							msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
							msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
						}
						else if(pom==1)
						{
							ko_igra=3;//posto je uhvacena poruka od roditelja igraju prvo i drugo dete
							
							moja_poruka.tip_poruke=3;
							printf("Obavestavam da sam uhvatio poruku\n");
							sleep(3);
							msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
						}
					}
					
					
				}
			}
		
	}
	else//ovde je roditelj i drugo dete
	{
		za_forkovanje=fork();
		
		if (za_forkovanje==-1)
		{
			printf("Doslo je do greske prilikom forkovanja\n");
		}
		else if(za_forkovanje==0)//ovde je drugo dete
		{
			rbr=3;
			while(1)
			{
				if(ko_igra==2)//igraju roditelj i drugo dete
				{
					moja_poruka.tip_poruke=2;
					moja_poruka.rbr=rbr;
					printf("rbr %d : Saljem poruku : tip_poruke %ld, tekst_poruke\n",rbr, moja_poruka.tip_poruke);
					sleep(3);
					msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
					
					printf("rbr %d : Cekam poruku tipa 1, tekst_poruke\n", rbr);
					msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 2, 0);
				}
				if(ko_igra==3)//igraju prvo i drugo dete
				{
					
					printf("rbr %d : Cekam poruku tipa 3, tekst_poruke\n", rbr);
					msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 3, 0);
					
					moja_poruka.tip_poruke=3;
					moja_poruka.rbr=rbr;
					printf("rbr %d : Saljem poruku : tip_poruke 3, tekst_poruke\n",rbr);
					sleep(3);
					msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
					
				}
				else 
				{
					printf("rbr %d : Cekam poruku tipa 2 ili 3, tekst_poruke\n", rbr);
					provera=msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), rand()%3, IPC_NOWAIT);
					sleep(2);
					
					if(provera!=-1)
					{
						
						pom=moja_poruka.rbr;
					
						if(pom==2)
						{
							ko_igra=2;
							
							moja_poruka.tip_poruke=1;
							printf("Obavestavam da sam uhvatio poruku\n");
							sleep(3);
							msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
						}
						else if(pom==1)
						{
							ko_igra=3;
							
							moja_poruka.tip_poruke=1;
							printf("Obavestavam da sam uhvatio poruku\n");
							sleep(3);
							msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
							msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
						}
					}
				}
			}
			
		}
		else//ovde je roditelj
		{
			rbr=1;
			while(1)
			{
				if(ko_igra==1)//Igraju roditelj i prvo dete
				{
					// Roditelj prvo salje pa prima
					moja_poruka.tip_poruke=1;
					moja_poruka.rbr=rbr;
					printf("rbr %d : Saljem poruku : tip_poruke %ld, tekst_poruke\n",rbr, moja_poruka.tip_poruke);
					sleep(3);
					msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
					
					printf("rbr %d : Cekam poruku tipa 1, tekst_poruke\n", rbr);
					msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 1, 0);
				}
				else if(ko_igra==2)//Igraju roditelj i drugo dete
				{
					//Roditelj prvo prima od drugog deteta pa salje
					printf("rbr %d : Cekam poruku tipa 2, tekst_poruke\n", rbr);
					msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), 2, 0);
					
					moja_poruka.tip_poruke=2;
					moja_poruka.rbr=rbr;
					printf("rbr %d : Saljem poruku : tip_poruke 2, tekst_poruke\n",rbr);
					sleep(3);
					msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
				}
				else
				{
					//roditelj pokusava da uhvati
					printf("rbr %d : Cekam poruku, tekst_poruke\n", rbr);
					provera=msgrcv(id_reda, &moja_poruka, sizeof(moja_poruka), rand()%4, IPC_NOWAIT);
					sleep(2);
					if(provera!=-1)
					{
						
						pom=moja_poruka.rbr;
						
						if(pom==2)
						{
							//zato sto je dvojka prva slala a kec primio ostaju blokirani i 2 i 3
							ko_igra=2;
							moja_poruka.tip_poruke=3;
							printf("Obavestavam da sam uhvatio poruku\n");
							sleep(3);
							msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
							msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
							
							
						}
						else if(pom==3)
						{
							ko_igra=1;
							//ovde treba da idblokiramo samo prvo dete
							moja_poruka.tip_poruke=3;
							printf("Obavestavam da sam uhvatio poruku, i u sredini je rbr: %d\n", pom);
							sleep(3);
							msgsnd(id_reda, &moja_poruka, sizeof(moja_poruka), 0);
						}
					}
					
					
				}
			}
		}
	}
		
	
	
	
	return 0;
}
