#include <stdio.h>
#include <stdlib.h>
#include <sys/msg.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <errno.h>
#include <unistd.h>
#include <time.h>
#include <signal.h>

pid_t ppid=-1;
pid_t pid=-1;

void sighandler(int sig){
	if(getpid()==ppid){
		//roditelj dobio sigint
		printf("Roditelj: Prekinuo me je proces dete\n");
		exit(0);
	}
	else{
		//dete dobio sigint
		printf("Dete: Prekinuo me je proces roditelj\n");
		exit(0);
	}
}

void srand(unsigned int seed);
int main(){
	int n, i;
	srand(time(NULL));
	ppid=getpid();
	signal(SIGINT, sighandler);
	pid=fork();
	switch(pid){
		case -1:
			printf("Greska\n");
		case 0:
			n=rand()%20;
			printf("Dete .. generisem %d\n", n);
			for(i=0; i<=n; i++){
				printf("Dete: %d\n", i);
				sleep(2);
			}
			kill(getppid(), SIGINT);
			printf("\n");
			break;
		default:
			n=rand()%20;
			printf("Roditelj .. generisem %d\n", n);
			for(i=0; i<=n; i++){
				printf("Roditelj: %d\n", i);
				sleep(2);
			}
			kill(pid, SIGINT);
			printf("\n");
	}
	return 0;
}
