#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct poruka {
	long tip;
	int sred;
	int rbr;
};

int main(){
	srand(time(NULL));
	int rbr=1,sred=1;

	key_t kljuc=ftok("sredinica.c",'A');
	int id_reda=msgget(kljuc,IPC_CREAT|0666);

	struct poruka msg;
	msg.tip=1;
	msg.rbr=1;
	msg.sred=1;

	int p1=fork(),p2;
	if(p1!=0){
		rbr=2;
		msg.rbr=2;
		msg.tip=3;
		printf("rbr %d: Saljem poruku (tip=%ld,sred=%d,rbr=%d)\n",rbr,msg.tip,msg.sred,msg.rbr);
		sleep(3);
		msgsnd(id_reda,&msg,sizeof(msg),0);
	}else{
		p2=fork();
		if(p2!=0){
			rbr=3;
			msg.rbr=3;
			msg.tip=2;
		}
	}

	while(1){
		if(sred==rbr){
			int guess=rbr;
			while(guess==rbr) guess=rand()%3+1;
			while(1){
				printf("rbr %d: Cekam poruku tipa %d\n",rbr,guess);
				int e=msgrcv(id_reda,&msg,sizeof(msg),guess,IPC_NOWAIT);
				if(e==-1){
					//printf("rbr %d: nisam pogodio (guess=%d).\n",rbr,guess);
					guess=rbr;
					while(guess==rbr) guess=rand()%3+1;
					sleep(2);
				}else {
					break;
				}
			}
			printf("rbr %d: pogodio sam (guess=%d).\n",rbr,guess);
			sred=msg.rbr;
			msg.rbr=rbr;
			msg.sred=sred;

			msg.tip=sred;
			printf("rbr %d: Saljem poruku (tip=%ld,sred=%d,rbr=%d)\n",rbr,msg.tip,msg.sred,msg.rbr);
			sleep(3);
			msgsnd(id_reda,&msg,sizeof(msg),0);

			msg.tip=guess;
			printf("rbr %d: Saljem poruku (tip=%ld,sred=%d,rbr=%d)\n",rbr,msg.tip,msg.sred,msg.rbr);
			sleep(3);
			msgsnd(id_reda,&msg,sizeof(msg),0);
		}else{
			sleep(10);

			printf("rbr %d: Cekam poruku tipa %d\n",rbr,rbr);
			msgrcv(id_reda,&msg,sizeof(msg),rbr,0);
			sred=msg.sred;
			if(sred!=rbr){
				msg.tip=msg.rbr;
				msg.rbr=rbr;
				printf("rbr %d: Saljem poruku (tip=%ld,sred=%d,rbr=%d)\n",rbr,msg.tip,msg.sred,msg.rbr);
				sleep(3);
				msgsnd(id_reda,&msg,sizeof(msg),0);
			}
		}
	}

}