#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <time.h>

typedef struct poruka{
	long tip;
	int sredina;
}poruka;

int main(){
	int rbr, g, sredina = 1;
	poruka p;
	
	key_t kljuc = ftok("sredinica.c", 'a');
	int id_reda = msgget(kljuc, IPC_CREAT | 0666);
	
	if(fork()){
		if(fork())
			rbr = 1;
		else{
			rbr = 3;
			
			p.tip = 2;
			p.sredina = 1;
			
			sleep(3);
			printf("rbr %d : Saljem poruku %ld,%d\n", rbr, p.tip, p.sredina);
			msgsnd(id_reda, &p, sizeof(p), 0);
		}
	}
	else
		rbr = 2;
	
	srand(time(0));
	while(1){
		if(rbr == sredina){
			// odredi nasumicno koji ce tip proveriti
			g = rand() % 2 + 1;
			if(rbr == 2 && g == 2) g = -1;
			if(rbr == 3) g *= -1;
			g = sredina + g;
			
			printf("rbr %d : Cekam poruku %d\n", rbr, g);
			if(msgrcv(id_reda, &p, sizeof(p), g, IPC_NOWAIT) == -1)
				sleep(2);
			else{
				sredina = p.tip;
				p.sredina = p.tip;
				
				sleep(3);
				printf("rbr %d : Saljem poruku %ld,%d\n", rbr, p.tip, p.sredina);
				msgsnd(id_reda, &p, sizeof(p), 0);
			}
		}
		else{
			printf("rbr %d : Cekam poruku %d\n", rbr, rbr);
			msgrcv(id_reda, &p, sizeof(p), rbr, 0);
			
			g = 6 - sredina - rbr;
			if(p.sredina != sredina){
				sredina = p.sredina;
				if(sredina != rbr)
					g = 6 - g - rbr;
			}
			
			p.tip = g;
			
			sleep(3);
			printf("rbr %d : Saljem poruku %d,%d\n", rbr, g, sredina);
			msgsnd(id_reda, &p, sizeof(p), 0);
			sleep(10);	// ostavio sam sleep kako bi povecao sansu da proces u sredini
						// dohvati poruku pre druga dva procesa
		}
	}
}
