#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct
{
	long tip;
	int rbr;
} poruka;

typedef struct
{
	long tip;
	int n;
} poruka2;

typedef struct
{
	long tip;
	char tekst[100];
} poruka3;

int id_reda;


int main()
{
	key_t kljuc;
	poruka por;
	
	kljuc = ftok("./server.c", 52);
	id_reda = msgget(kljuc, IPC_CREAT | 0660);
	
	int i, n;
	printf("Broj klijenata: ");
	scanf("%d", &n);
	
	for(i=1; i<=n; i++)
	{
		msgrcv(id_reda, &por, sizeof(por), 21, 0);
		printf("Prijavljen %d.takmicar \n", i);
		por.tip = por.rbr;
		por.rbr = i;
		msgsnd(id_reda, &por, sizeof(por), 0);
	}
	
	
	poruka2 por2;
	por2.n = n;
	
	for(i=1; i<=n; i++)
	{
		por2.tip = i;
		msgsnd(id_reda, &por2, sizeof(por2), 0); 
	}
	
	poruka3 por3;
	
	srand(time(NULL));
	por3.tip = rand() % n + 1;
	printf("Unesi poruku:\n");
	getchar();
	fgets(por3.tekst, sizeof(por3.tekst), stdin);
	por3.tekst[strlen(por3.tekst)-1] = '\0';
	printf("Saljem poruku: %ld, tekst: %s\n", por3.tip, por3.tekst);
	msgsnd(id_reda, &por3, sizeof(por3), 0);
	
	
	return 0;
}



