#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pid;

void sh1(int sig)
{
	kill(getppid(), SIGINT);
	printf("Roditelj: Prekinuo me je process dete.\n");
	exit(0);
}

void sh2(int sig)
{
	kill(pid, SIGINT);
	printf("Dete : Prekinuo me je process roditelj.\n");
	exit(0);
}

int main()
{
	srand(time(NULL));
	int i;
	pid = fork();
	if(pid == -1)
	{
		printf("Greska!!!\n");
		exit(1);
	}
	if(pid == 0)
	{
		signal(SIGINT, sh1);
		int n = rand() % 20;
		printf("Dete: broj n: %d\n", n);
		for(i = 1; i <= n; i++)
		{
			printf("Dete: %d\n", i);
			sleep(2);
		}
		//kill(getppid(), SIGINT);
	}
	else
	{
		signal(SIGINT, sh2);
		int n = rand() % 20;
		printf("Roditelj: broj n: %d\n", n);
		for(i = 1; i <= n; i++)
		{
			printf("Roditelj: %d\n", i);
			sleep(2);
		}
		//kill(getppid(), SIGINT);
	}
	
	
	return 0;
}
