#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct Poruka_s
{
	long tip;
	pid_t pid;
	char tekst[100];
	int redni_broj, uk;
}Poruka;

void main()
{
	key_t kljuc1, kljuc2;
	int n, i, red1, red2, rb, klijent, uk;
	Poruka primi, salji;

	kljuc1 = ftok("./server.c", 100);
	red1 = msgget(kljuc1, IPC_CREAT|0666);
	kljuc2 = ftok("./klijent.c", 110);
	red2 = msgget(kljuc2, IPC_CREAT|0666);

	salji.tip = 53;
	if(msgsnd(red1, &salji, sizeof(salji), 0) != -1)
		printf("Poslata je prijava serveru.\n");
	
	if(msgrcv(red1, &primi, sizeof(primi), 55, 0) != -1)
		printf("Primljen redni broj od servera.\nRedni broj: %d.\n", primi.redni_broj);

	rb = primi.redni_broj;

	if(msgrcv(red2, &primi, sizeof(primi), 60, 0) != -1)
		printf("Primljen ukupan broj prijavljenih klijenata: %d.\n", primi.uk);

	uk = primi.uk;

	while(1)
	{
		printf("\nCekam poruku... tip: %d\n", rb);
		if(msgrcv(red2, &primi, sizeof(primi), rb, 0) != -1)
			printf("Primljena poruka: %s\n", primi.tekst);

		printf("\nUneti poruku: ");
		fgets(salji.tekst, sizeof(salji.tekst), stdin);
		salji.tekst[strlen(salji.tekst)-1] = '\0';	//zbog '\n';


		klijent = (rand() % uk) + 1;
		while(klijent == rb)
			klijent = (rand() % uk) + 1;

		salji.tip = klijent;
		if(msgsnd(red2, &salji, sizeof(salji), 0) != -1)
				printf("Saljem poruku klijentu: %d\n", klijent);
	}
}
