#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pid;

void SH1(int sig)
{
	printf("DETE: Prekinuo me je proces roditelj.\n");
	//kill(pid, SIGKILL);	//ubija dete;
	exit(0);
}

void SH2(int sig)
{
	printf("RODITELJ: Prekinuo me je proces dete.\n");	
	exit(0);
}

void main()
{
	int i, n;

	pid = fork();
	srand(time(0));

	if(pid == 0)
	{
		signal(SIGINT, SH1);
		n = (rand() % 20) + 1;
		printf("DETE n: %d\n", n);

		for(i = 1; i <= n; i++)
		{
			printf("DETE: %d\n", i);
			sleep(2);
		}

		kill(getppid(), SIGINT);
		sleep(2);
	}
	else if(pid == -1)
	{
		printf("Greska!\n");
		exit(0);
	}
	else
	{	
		signal(SIGINT, SH2);	
		n = (rand() % 20) + 1;
		printf("RODITELJ n: %d\n", n);
		
		for(i = 1; i <= n; i++)
		{
			printf("RODITELJ: %d\n", i);
			sleep(2);
		}

		kill(pid, SIGINT);
		sleep(2);
	}
}
