#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct Poruka_s
{
	long tip;
	pid_t pid;
	char tekst[100];
	int redni_broj, uk;
}Poruka;

void main()
{
	key_t kljuc1, kljuc2;
	int n, i, red1, red2, klijent;
	Poruka primi, salji;

	printf("Uneti broj klijenata: ");
	scanf("%d", &n);

	kljuc1 = ftok("./server.c", 100);
	red1 = msgget(kljuc1, IPC_CREAT|0666);
	kljuc2 = ftok("./klijent.c", 110);
	red2 = msgget(kljuc2, IPC_CREAT|0666);

	for(i = 1; i <= n; i++)
	{
		if(msgrcv(red1, &primi, sizeof(primi), 53, 0) != -1);	//klijentov tip poruke je 53;
			printf("Primljena je prijava od klijenta.\n");
		
		salji.tip = 55;
		salji.redni_broj = i;
		if(msgsnd(red1, &salji, sizeof(salji), 0) != -1)
			printf("Klijentu je poslat redni broj : %d.\n", i);
		
		putchar('\n');
	}

	printf("Prijava je zavrsena.\n\n");

	for(i = 0; i < n; i++)
	{
		salji.tip = 60;	
		salji.uk = n;
		
		if(msgsnd(red2, &salji, sizeof(salji), 0) != -1)
			printf("Poslat ukupan broj klijenata(%d).\n", i+1);
	}


	printf("\nUneti poruku: ");
	getchar();
	fgets(salji.tekst, sizeof(salji.tekst), stdin);
	salji.tekst[strlen(salji.tekst)-1] = '\0';	//zbog '\n';

	klijent = (rand() % n) + 1;
	salji.tip = klijent;
	if(msgsnd(red2, &salji, sizeof(salji), 0) != -1)
			printf("Saljem poruku klijentu: %d\n", klijent);

}
