#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>



struct info
{
	long tip;
	int pid;
};

struct lopta
{
	long tip;
};


int main()
{
	srand(time(NULL));
	
	int redni_broj;
	int p,q;
	int sredina;
	int id_reda,id_reda_info;
	int hvatac;
	key_t kljuc,kljuc_info;
	struct lopta loptica;
	struct info poruka;
	
	kljuc = ftok("sredinica.c",100);
	kljuc_info = ftok("sredinica.c",150);
	
	id_reda = msgget(kljuc,IPC_CREAT|0666);
	id_reda_info = msgget(kljuc_info,IPC_CREAT|0666);
	
	p = fork();
	if (p == -1)
	{
		printf("Fork greska!\n");
		exit(0);
	}
	else if (p == 0)
	{
		sredina = 0;
		redni_broj = 2;
		while (1)
		{
			if (sredina != 0)   //Prvo dete nije u sredini
			{
				//Zanima ga ko je u sredini...ceka informaciju
				msgrcv(id_reda_info,&poruka,sizeof(poruka),redni_broj,0);
				hvatac = poruka.pid;
				
				while(1)
				{
					if (hvatac == 1) //Dobacuje se sa drugim detetom
					{
						loptica.tip = 3;
						printf("rbr %d: Saljem poruku %ld\n",redni_broj,loptica.tip);
						msgsnd(id_reda,&loptica,sizeof(loptica),0);   //Prvo dete je bacilo loptu drugom detetu
						
						printf("rbr %d: Cekam poruku %ld\n",redni_broj,loptica.tip);
						msgrcv(id_reda,&loptica,sizeof(loptica),2,0);
						
					}
					else if (hvatac == 3) //Dobacujes se sa roditeljem
					{
						printf("rbr %d: Cekam poruku %ld\n",redni_broj,loptica.tip);
						msgrcv(id_reda,&loptica,sizeof(loptica),2,0);  //Hvatam loptu od roditelja
						
						
						loptica.tip = 1;
						printf("rbr %d: Saljem poruku %ld\n",redni_broj,loptica.tip);
						msgsnd(id_reda,&loptica,sizeof(loptica),0);    //Prvo dete je bacilo loptu roditelju
					}
					 p = msgrcv(id_reda_info,&poruka,sizeof(poruka),redni_broj,IPC_NOWAIT);   //Proverava da li je neko uhvatio loptu
					 if (p != -1)
					 {
						if(poruka.pid == redni_broj) sredina = 1;
						break;
					}
				}	
			}
			else  //Prvo dete je u sredini...pokusava da presretne poruku;
			{
				//Obavestava ostale da je u sredini
				poruka.tip = 1;
				poruka.pid = redni_broj;
				msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
					
				poruka.tip = 3;
				msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
				
				//Pokusava da uhvati poruku:
					
				p = rand() % 3 + 1;
					
				q = msgrcv(id_reda,&loptica,sizeof(loptica),p,IPC_NOWAIT);
				if (q == -1) //Nije uspeo;
					sleep(2);
				else  //Uspeo je
				{
					
					poruka.tip = 2;
					poruka.pid = loptica.tip;
					msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
						
					poruka.tip = 3;
					msgsnd(id_reda_info,&poruka,sizeof(poruka),0);		
				}
			
		}
	}
}
	else   //Roditelj
	{
		q = fork();
		
		if (q == -1)
		{
			printf("Fork greska!\n");
			exit(0);
		}
		else if (q == 0) //Drugo dete
		{
			sredina = 0;
			redni_broj = 3;
			
			while(1)
			{
				if (sredina != 0) //Drugo dete nije u sredini
				{
					//Zanima ga ko je u sredini...ceka informaciju
					msgrcv(id_reda_info,&poruka,sizeof(poruka),redni_broj,0);
					hvatac = poruka.pid;
					while(1)
					{
						if (hvatac == 1) //Dobacujes se sa prvim detetom
						{
							printf("rbr %d: Cekam poruku %ld\n",redni_broj,loptica.tip);
							msgrcv(id_reda,&loptica,sizeof(loptica),3,0);
							
							loptica.tip = 2;
							printf("rbr %d: Saljem poruku %ld\n",redni_broj,loptica.tip);
							msgsnd(id_reda,&loptica,sizeof(loptica),0);
							
							
						}
						else if (hvatac == 2)  //Dobacuje se sa roditeljem
						{
							printf("rbr %d: Cekam poruku %ld\n",redni_broj,loptica.tip);
							msgrcv(id_reda,&loptica,sizeof(loptica),3,0);  //Hvatas loptu od rodirtelja;
							
							
							loptica.tip = 1;
							printf("rbr %d: Saljem poruku %ld\n",redni_broj,loptica.tip);
							msgsnd(id_reda,&loptica,sizeof(loptica),0);   //Bacas loptu roditelju;
						}
						msgrcv(id_reda_info,&poruka,sizeof(poruka),redni_broj,IPC_NOWAIT);   //Proverava da li je neko uhvatio loptu
						 if (p != -1)
						{
							if(poruka.pid == redni_broj) sredina = 1;
							break;
						}
					}
				}
				else //Drugo dete je u sredini;
				{
					//Obavestava ostale da je u sredini
					poruka.tip = 2;
					poruka.pid = redni_broj;
					msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
					
					poruka.tip = 1;
					msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
					
					//Pokusava da uhvati poruku:
					
					p = rand() % 3 + 1;
					
					q = msgrcv(id_reda,&loptica,sizeof(loptica),p,IPC_NOWAIT);
					if (q == -1) //Nije uspeo;
						sleep(2);
					else  //Uspeo je
					{
						poruka.tip = 2;
						poruka.pid = loptica.tip;
						msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
						
						poruka.tip = 1;
						msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
					}
				}
			}
		}
		else  //Roditelj 
		{
			sredina = 1;
			redni_broj = 1;
			while(1)
			{
				if (sredina != 0) //Roditelj nije u sredini
				{
					//Zanima ga ko je u sredini...ceka informaciju
					msgrcv(id_reda,&poruka,sizeof(poruka),redni_broj,0);
					hvatac = poruka.pid;
					while(1)
					{
						if (hvatac == 2) //Dobacuje se sa drugim detetom
						{
							loptica.tip = 3;
							printf("rbr %d: Saljem poruku %ld\n",redni_broj,loptica.tip);
							msgsnd(id_reda,&loptica,sizeof(loptica),0);
							
							printf("rbr %d: Cekam poruku %ld\n",redni_broj,loptica.tip);
							msgrcv(id_reda,&loptica,sizeof(loptica),1,0);
							
						}
						else if (hvatac == 3) //Dobacuje se sa prvim detetom
						{
							
							loptica.tip = 2;
							printf("rbr %d: Saljem poruku %ld\n",redni_broj,loptica.tip);
							msgsnd(id_reda,&loptica,sizeof(loptica),0);
							
							printf("rbr %d: Cekam poruku %ld\n",redni_broj,loptica.tip);
							msgrcv(id_reda,&loptica,sizeof(loptica),1,0);
						}
						msgrcv(id_reda_info,&poruka,sizeof(poruka),redni_broj,IPC_NOWAIT);   //Proverava da li je neko uhvatio loptu
						 if (p != -1)
						{
							if(poruka.pid == redni_broj) sredina = 1;
							break;
						}
					}
				}
				else  //Roditelj je u sredini
				{
					//Obavestava prvo dete da je u sredini!
					poruka.tip = 2;
					poruka.pid = redni_broj;
					msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
					
					poruka.tip = 3;
					msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
					
					//Obavestio je decu da je u sredini;
					
					//Pokusava da uhvati poruku:
					
					p = rand() % 3 + 1;
					
					q = msgrcv(id_reda,&loptica,sizeof(loptica),p,IPC_NOWAIT);
					if (q == -1) //Nije uspeo;
						sleep(2);
					else  //Uspeo je
					{
						poruka.tip = 2;
						poruka.pid = loptica.tip;
						msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
						
						poruka.tip = 3;
						msgsnd(id_reda_info,&poruka,sizeof(poruka),0);
					}
				}
			}
		}
	}
	
	return 0;
}

/* Ako je roditelj u sredini prvo dete baca, a drugo hvata loptu, pa obrnuto...
 * Ako je prvo dete u sredini roditelj baca, a drugo dete hvata loptu, pa obrnuto...
 * Ako je drugo dete u sredini roditelj baca loptu, a prvo dete hvata loptu, pa obrnuto...*/
