#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
#include <time.h>
//koji jos

struct Por{
    long tip;
    char tekst[20];
    int pid;
    int sredina;
};

int main(){
    srand(time(NULL));
    int pid1, pid2;
    int rbr;
    int msqid;
    struct Por poruka;
    key_t key;
    key = ftok("./Zadatak20.c",65);
    msqid = msgget(key, IPC_CREAT|0666);
    poruka.sredina = 1;
    if(pid1 = fork()){//DETE 1
        int poslato = 0;
        rbr = 2;
        while(1){
            if(poruka.sredina != rbr){//AKO JA NISAM U SREDINI
                if(poslato == 0){
                    if(poruka.sredina == 1){//ako je RODITELJ u sredini salji na tip 1
                        poruka.tip = 1;
                        strcpy(poruka.tekst, "DETE 1");
                    }
                    else if(poruka.sredina == 3){// ako je dete3 u sredini
                        poruka.tip = 3;
                        strcpy(poruka.tekst, "DETE 1");
                    }
                    printf("rbr %d: Saljem poruku tip:%ld, tekst: %s\n", rbr, poruka.tip, poruka.tekst);
                    msgsnd(msqid, &poruka, sizeof(poruka),0);
                    poslato = 1;
                }
                else{
                    sleep(1);
                    if(poruka.sredina == 1){
                        poruka.tip = 1;
                    }
                    else if(poruka.sredina == 3){
                        poruka.tip = 3;
                    }
                    msgrcv(msqid, &poruka, sizeof(poruka), poruka.tip, 0);
                    printf("rbr %d: Primio sam poruku tip:%ld, tekst(od): %s\n", rbr, poruka.tip, poruka.tekst);
                    poslato = 0;
                }
            }
            else if(poruka.sredina == rbr){//AKO SAM JA U SREDINI
                int tip = poruka.sredina;
                int pom;
                while(tip == poruka.sredina)
                    tip = rand()%5;
                printf("\t%d : Pokusavam da uhvatim na tipu %d\n",rbr, tip);
                pom = msgrcv(msqid, &poruka, sizeof(poruka), tip, IPC_NOWAIT);
                if(pom != -1){
                    printf("rbr %d: UHVATIO sam poruku tip:%ld, tekst(od): %s\n", rbr, poruka.tip, poruka.tekst);
                    if(strcmp(poruka.tekst,"DETE 2") == 0){

                        printf("\n\n\t\tSADA JE DETE 2 U SREDINI.\n\n");
                        poruka.sredina = 3;
                        //sluzi da promeni sredinu svima
                        msgsnd(msqid, &poruka, sizeof(poruka), 0);
                        msgsnd(msqid, &poruka, sizeof(poruka), 0);
                    }
                    else{

                        printf("\n\n\t\tSADA JE RODITELJ U SREDINI.\n\n");
                        poruka.sredina = 1;
                        //sluzi da promeni sredinu svima
                        msgsnd(msqid, &poruka, sizeof(poruka), 0);
                        msgsnd(msqid, &poruka, sizeof(poruka), 0);
                    }
                }
            }
        }   
    }
    else{
        if(pid2 = fork()){  //DETE 2;
            
            int sredina = 1;
            int poslato = 1;
            rbr = 3;
            while(1){
                if(poruka.sredina != rbr){//AKO JA NISAM U SREDINI
                    if(poslato == 0){
                        if(poruka.sredina == 1){//ako je RODITELJ u sredini salji na tip 1
                            poruka.tip = 1;
                            strcpy(poruka.tekst, "DETE 2");
                        }
                        else if(poruka.sredina == 2){// ako je dete1 u sredini
                            poruka.tip = 2;
                            strcpy(poruka.tekst, "DETE 2");
                        }
                        printf("rbr %d: Saljem poruku tip:%ld, tekst: %s\n", rbr, poruka.tip, poruka.tekst);
                        msgsnd(msqid, &poruka, sizeof(poruka), 0);
                        poslato = 1;
                    }
                    else{
                        sleep(1);
                        if(poruka.sredina == 1){
                            poruka.tip = 1;
                        }
                        else if(poruka.sredina == 2){
                            poruka.tip = 2;
                        }
                        msgrcv(msqid, &poruka, sizeof(poruka), poruka.tip, 0);
                        printf("rbr %d: Primio sam poruku tip:%ld, tekst(od): %s\n", rbr, poruka.tip, poruka.tekst);
                        poslato = 0;
                    }
                }
                else if(poruka.sredina == rbr){//AKO SAM JA U SREDINI
                    int tip = poruka.sredina;
                    int pom;
                    while(tip == poruka.sredina)
                        tip = rand()%5;
                    printf("\t%d : Pokusavam da uhvatim na tipu %d\n",rbr, tip);
                    pom = msgrcv(msqid, &poruka, sizeof(poruka), tip, IPC_NOWAIT);
                    if(pom != -1){
                        printf("rbr %d: UHVATIO sam poruku tip:%ld, tekst(od): %s\n", rbr, poruka.tip, poruka.tekst);
                        if(strcmp(poruka.tekst,"DETE 1") == 0){

                            printf("\n\n\t\tSADA JE DETE 1 U SREDINI.\n\n");
                            poruka.sredina = 2;
                            //sluzi da promeni sredinu svima
                            msgsnd(msqid, &poruka, sizeof(poruka), 0);
                            msgsnd(msqid, &poruka, sizeof(poruka), 0);
                        }
                        else{

                            printf("\n\n\t\tSADA JE RODITELJ U SREDINI.\n\n");
                            poruka.sredina = 1;
                            //sluzi da promeni sredinu svima
                            msgsnd(msqid, &poruka, sizeof(poruka), 0);
                            msgsnd(msqid, &poruka, sizeof(poruka), 0);
                        }
                    }

                }
            }
        }
        else{
            //RODITELJ;
            
            int sredina = 1;
            int poslato = 0;
            rbr = 1;
            while(1){
                if(poruka.sredina != rbr){//AKO JA NISAM U SREDINI
                    if(poslato == 0){
                        if(poruka.sredina == 2){//ako je RODITELJ u sredini salji na tip 1
                            poruka.tip = 2;
                            strcpy(poruka.tekst, "RODITELJ");
                        }
                        else if(poruka.sredina == 3){// ako je dete3 u sredini
                            poruka.tip = 3;
                            strcpy(poruka.tekst, "RODITELJ");
                        }
                        printf("rbr %d: Saljem poruku tip:%ld, tekst: %s\n", rbr, poruka.tip, poruka.tekst);
                        msgsnd(msqid, &poruka, sizeof(poruka), 0);
                        poslato = 1;
                    }
                    else{
                        sleep(1);
                        if(poruka.sredina == 2){
                            poruka.tip = 2;
                        }
                        else if(poruka.sredina == 3){
                            poruka.tip = 3;
                        }
                        printf("rbr %d: Cekam poruku tipa: %ld\n", rbr, poruka.tip);
                        msgrcv(msqid, &poruka, sizeof(poruka), poruka.tip, 0);
                        printf("rbr %d: Primio sam poruku tip:%ld, tekst(od): %s\n", rbr, poruka.tip, poruka.tekst);
                        poslato = 0;
                    }
                }
                else if(poruka.sredina == rbr){//AKO SAM JA U sredini
                    int tip = poruka.sredina;
                    int pom;
                    while(tip == poruka.sredina)
                        tip = rand()%5;
                    printf("\t%d : Pokusavam da uhvatim na tipu %d\n",rbr, tip);
                    pom = msgrcv(msqid, &poruka, sizeof(poruka), tip, IPC_NOWAIT);
                    if(pom != -1){
                        printf("rbr %d: UHVATIO sam poruku tip:%ld, tekst(od): %s\n", rbr, poruka.tip, poruka.tekst);
                        if(strcmp(poruka.tekst,"DETE 1") == 0){
                            printf("\n\n\t\tSADA JE DETE 1 U SREDINI.\n\n");
                            poruka.sredina = 2;
                            //sluzi da promeni sredinu svima
                            msgsnd(msqid, &poruka, sizeof(poruka), 0);
                            msgsnd(msqid, &poruka, sizeof(poruka), 0);
                        }
                        else{
                            printf("\n\n\t\tSADA JE DETE 2 U SREDINI.\n\n");
                            poruka.sredina = 3;
                            //sluzi da promeni sredinu svima
                            msgsnd(msqid, &poruka, sizeof(poruka), 0);
                            msgsnd(msqid, &poruka, sizeof(poruka), 0);
                        }
                    }
                    sleep(2);
                }
            }    
        }
    }
}    
