#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct pomocna{
	char poruka[100];
	int pid;
	int rbr;
	int ukupno;
}pomocna;

struct poruka_red {
	long tip;
	pomocna pomocni[1];
};

int main()
{
	srand(time(NULL));
	key_t kljuc;
	int id_reda;
	int mojrbr;
	int r;
	int nasumicni;
	kljuc=ftok("./kljient.c",67);
	id_reda = msgget(kljuc,IPC_CREAT|0666);
	struct poruka_red moja_poruka;
	moja_poruka.tip = 25;
	moja_poruka.pomocni[0].pid = getpid();
	
	msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.pomocni),0);
	printf("POSLAO\n");
	msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka.pomocni),getpid(),0);
	
	mojrbr = moja_poruka.pomocni[0].rbr;
	printf("MOJ REDNI BROJ %d\n",mojrbr);
	msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka.pomocni),mojrbr,0);
	printf("%s",moja_poruka.pomocni[0].poruka);
	//primio poruku koliko klijenata
	nasumicni = moja_poruka.pomocni[0].ukupno;
	while(1)
	{
		r=rand()%nasumicni;
		moja_poruka.tip = r;
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.pomocni),0);
		printf("SALJEM PORUKU tip %d tekst: %s",r,moja_poruka.pomocni[0].poruka);
	}
}
