#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<signal.h>
#include<time.h>

void signal_handler_dete(int brSig)
{
    printf("Prekinuo me je proces roditelj.\n");
    exit(0);
}

void signal_handler_roditelj(int brSig)
{
    printf("Prekinuo me je proces dete.\n");
    exit(0);
}

int main()
{
    srand(time(NULL));
    pid_t pid;
    int i, n;

    n = rand() % 20;
    printf("%d\n", n);
    printf("R: Moj pid je:%d\n", getpid());
    pid = fork();

    if(pid == 0) 
    {
        printf("D: Moj pid je: %d\n", getpid());
        signal(SIGINT, signal_handler_dete);

        for(i=1; i<=n; i++)
        {
            printf("DETE: %d\n", i);
            sleep(2);
        }

        kill(getppid(), SIGINT);
    }
    else 
    {
        signal(SIGINT, signal_handler_roditelj);
        for(i=1; i<=n; i++)
        {
            printf("RODITELJ: %d\n", i);
            sleep(2);
        }

        kill(pid, SIGINT);
    }

    return 0;
}