#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka
{
    long tip;
    int pid;
    int rbr;
    int brPrijavljenih;
    char tekst[100];
}poruka;

int main()
{
    srand(time(NULL));
    int n, i, id_reda, odabrani;
    poruka porukaPrijem, porukaSlanje;
    key_t kljuc;
    int redniBroj;

    kljuc = ftok("./server.c", 45);
    id_reda = msgget(kljuc, IPC_CREAT | 0666);
    printf("Id reda je: %d\n", id_reda);

    porukaSlanje.tip = 17;
    porukaSlanje.pid = getpid();
    msgsnd(id_reda, &porukaSlanje, sizeof(porukaSlanje), 0);
    msgrcv(id_reda, &porukaPrijem, sizeof(poruka), getpid(), 0);
    redniBroj = porukaPrijem.rbr;
    //printf("moj redni broj je: %d\n", redniBroj);

    msgrcv(id_reda, &porukaPrijem, sizeof(porukaPrijem), redniBroj, 0);
    n = porukaPrijem.brPrijavljenih;
    //printf("br prijavljenih: %d\n", n);

    while(1)
    {
        printf("Cekam poruku...\n");
        msgrcv(id_reda, &porukaPrijem, sizeof(porukaPrijem), redniBroj, 0);
        printf("tip: %ld, tekst poruke: %s\n",porukaPrijem.tip, porukaPrijem.tekst);

        odabrani = rand() % (n+1);
        while(odabrani == redniBroj || odabrani == 0)
        {
        odabrani = rand() % (n+1);     
        }

        porukaSlanje.tip = odabrani;
        porukaSlanje.rbr = odabrani;
        printf("Unesi poruku:\n");
        fgets(porukaSlanje.tekst, sizeof(porukaSlanje.tekst), stdin);
        printf("Saljem poruku tip: %ld, tekst: %s\n", porukaSlanje.tip, porukaSlanje.tekst);
        msgsnd(id_reda, &porukaSlanje, sizeof(porukaSlanje), 0);
    }

    

    return 0;
}