#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka
{
    long tip;
    int pid;
    int rbr;
    int brPrijavljenih;
    char tekst[100];
}poruka;

int main()
{
    srand(time(NULL));
    int n, i, id_reda, odabrani;
    poruka porukaPrijem, porukaSlanje;
    key_t kljuc;

    printf("Unesite N:\n");
    scanf("%d", &n);

    kljuc = ftok("./server.c", 45);
    id_reda = msgget(kljuc, IPC_CREAT | 0666);
    printf("Id reda je: %d\n", id_reda);
    
    for(i=1; i<=n; i++)
    {
        msgrcv(id_reda, &porukaPrijem, sizeof(porukaPrijem), 17, 0);
        //printf("primio sam prijavu ..\n");
        porukaSlanje.tip = porukaPrijem.pid;
        porukaSlanje.rbr = i;
        msgsnd(id_reda, &porukaSlanje, sizeof(porukaSlanje), 0);
        //printf("poslao sam redni broj ..\n");
    }

     for(i=1; i<=n; i++)
     {
         porukaSlanje.tip = i;
         porukaSlanje.brPrijavljenih = n;
         msgsnd(id_reda, &porukaSlanje, sizeof(porukaSlanje), 0);
         //printf("obavestio sam: %d\n", i);
     }

     getchar();
     printf("Unesi poruku:\n");
     fgets(porukaSlanje.tekst, sizeof(porukaSlanje.tekst), stdin);
     odabrani = rand() % (n+1);
     while(odabrani == 0)
     {
        odabrani = rand() % (n+1);
     }
     porukaSlanje.tip = odabrani;
     porukaSlanje.rbr = odabrani;
     printf("Saljem poruku tip: %ld,tekst: %s\n", porukaSlanje.tip, porukaSlanje.tekst);
     msgsnd(id_reda, &porukaSlanje, sizeof(porukaSlanje), 0);

    return 0;
}