#include<stdio.h>
#include<time.h>
#include<stdlib.h>
#include<sys/wait.h>
#include<sys/msg.h>
#include<sys/types.h>
#include<sys/ipc.h>
#include<unistd.h>

int msgId;

void hendler(int sig){
		printf("Brisem red za poruku i zavrsavam\n");
		msgctl(msgId, IPC_RMID, 0);
		exit(0);
}

typedef struct poruka{
	long tip;
	char tekst[50];
	int rbr;
	int u;
}poruka;

int main(){
	key_t kljuc;
	kljuc = ftok("./server.c", 65);
	msgId = msgget(kljuc, 0666|IPC_CREAT);
	signal(SIGINT, hendler);
	poruka mojaPoruka;
	int mojRbr;
	mojaPoruka.tip = 21;
	mojaPoruka.rbr = getpid();
	msgsnd(msgId, &mojaPoruka, sizeof(mojaPoruka), 0);
	msgrcv(msgId, &mojaPoruka, sizeof(mojaPoruka), getpid(), 0);
	printf("Prijavljen je klijent broj: %d\n", mojaPoruka.rbr);
	printf("Ukupan broj klijenata je: %d\n", mojaPoruka.u);
	int ukupno = mojaPoruka.u;
	mojRbr = mojaPoruka.rbr;
	while(1){
		printf("Cekam poruku: tip %d\n", mojRbr);
		msgrcv(msgId, &mojaPoruka, sizeof(mojaPoruka), mojRbr, 0);
		printf("Primljena je poruka: tip %ld, tekst_poruke %s\n", mojaPoruka.tip, mojaPoruka.tekst);
		
		fgets(mojaPoruka.tekst, 50, stdin);
		int slucajni;
		//na ovaj nacin klijent nece poslati poruku sam sebi.
		while(1){
			slucajni = rand()%ukupno+1;
			if(slucajni != mojRbr) break;
		}
		
		mojaPoruka.tip = slucajni;
		printf("Saljem poruku: tip %ld, tekst_poruke %s\n", mojaPoruka.tip, mojaPoruka.tekst);
		msgsnd(msgId, &mojaPoruka, sizeof(mojaPoruka), 0);
	}
	return 0;
}















