#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka {
	long tip;
	int pid;
	int redni_broj;
	char tekst[50];
}poruka;

int main() {
	key_t kljuc;
	int id_reda;
	int i, n;
	int klijent;
	//int redni_broj;
	poruka pk;

	kljuc = ftok("./server.c", 65);
	id_reda = msgget(kljuc, IPC_CREAT | 0666);

	scanf("%d", &n);
	
	msgrcv(id_reda, &pk, sizeof(pk), 1, 0);
	//printf("Primio sam poruku : tip - %ld, tekst - %s\n", pk.tip, pk.tekst);	
	pk.tip = pk.pid;
	msgsnd(id_reda, &pk, sizeof(pk), 0);
	//printf("Saljem poruku : tip - %ld, tekst - %s\n", pk.tip, pk.tekst);
	
	for(i = 0; i < n; i++) {
		printf("Cekam poruku : tip - %ld\n", pk.tip);
		msgrcv(id_reda, &pk, sizeof(pk), 1, 0);
		printf("Primio sam poruku : tip - %ld, tekst - %s\n", pk.tip, pk.tekst);
		pk.tip = pk.pid + 1;
		pk.redni_broj = i + 1;
		fgets(pk.tekst, sizeof(pk.tekst), stdin);
		printf("Saljem poruku : tip - %ld, tekst - %s\n", pk.tip, pk.tekst);
		msgsnd(id_reda, &pk, sizeof(pk), 0);
	}
}
