#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define MEM 1024

typedef union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
}semun;

int semid, shmid, *br, BrLopti, temp1;
struct sembuf Uzak = {2,-1,0}, Uotk = {2,1,0};

void handler(int sig)
{
	printf("Smanjujem semafor 2 iz %d za vrednost 1\n", semid);
	semop(semid, &Uzak, 1);
	br = shmat(BrLopti, NULL, 0);
			
	temp1 = *br;
			
	shmdt(br);
	printf("Povecavam semafor 2 iz %d za vrednost 1\n", semid);
	semop(semid, &Uotk, 1);

	printf("Ubacio %d lopti\n", temp1);
	exit(0);
}

int main()
{
	signal(SIGINT, handler);
	srand(time(0));
	key_t shmkey = ftok("igrac.c", 71);
	shmid = shmget(shmkey, MEM, 0644 | IPC_CREAT);
	key_t keyL = ftok("igrac.c", 72);
	BrLopti = shmget(keyL, MEM, 0644 | IPC_CREAT);
	
	key_t key = ftok("igrac.c", 70);
	semid = semget(key, 3, 0666 | IPC_CREAT | IPC_EXCL);
	semun op;
	int *data;
	int temp, kos;
	
	if(semid != -1)
	{
		op.val = 0;
		semctl(semid, 0, SETVAL, op);
		semctl(semid, 1, SETVAL, op);
		op.val = 1;
		semctl(semid, 2, SETVAL, op);
	}
	else if(errno == EEXIST)
		semid = semget(key, 3, 0);
	else
		exit(0);
	
	struct sembuf Szak = {0,-1,0}, Sotk = {0,1,0}, used = {1, 1, 0};
	
	
	while(1)
	{
		printf("Smanjujem semafor 0 iz %d za vrednost 1\n", semid);
		semop(semid, &Szak, 1);
		data = shmat(shmid, NULL, 0);
		
		temp = *data;
		temp -= 1;
		*data = temp;
		sleep(1);
		
		shmdt(data);
		printf("Povecavam semafor 0 iz %d za vrednost 1\n", semid);
		semop(semid, &Sotk, 1);
		printf("Povecavam semafor 1 iz %d za vrednost 1\n", semid);
		semop(semid, &used, 1);
		
		sleep(3);
		kos = rand() % 2;
		
		if(kos)
		{
			printf("Smanjujem semafor 2 iz %d za vrednost 1\n", semid);
			semop(semid, &Uzak, 1);
			br = shmat(BrLopti, NULL, 0);
			
			temp = *br;
			temp += 1;
			*br = temp;
			
			shmdt(br);
			printf("Povecavam semafor 2 iz %d za vrednost 1\n", semid);
			semop(semid, &Uotk, 1);
		}
	}
	
	
	
	
	
	
	
	return 0;
}
