
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/msg.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>

typedef struct {
	long mtype;
} CollectBallMessage;

union semun {
	int val;
	struct semid_ds *buf;
	unsigned short *array;
};

int main() {

	key_t key = ftok("./igrac.c", 'a');
	int msgflg = IPC_CREAT | 0666;
	int msqid = msgget(key, msgflg);
	int semid = semget(key, 2, IPC_CREAT | IPC_EXCL | 0666);

	if (semid == -1) {
		if (errno == EEXIST) {
			semid = semget(key, 2, 0);
		} else {
			perror("unable to obtain semaphore id");
			exit(1);
		}
	} else {
		union semun sem_init;

		sem_init.array = (unsigned short*)malloc(2 * sizeof(unsigned short));
		
		int N;
		printf("Unesite limit lopti na stalku:\n");
		scanf("%d", &N);

		sem_init.array[0] = N;
		sem_init.array[1] = 1; // MUTEX

		semctl(semid, 0, SETALL, sem_init);
	}

	struct sembuf op_increase_balls;

	op_increase_balls.sem_num = 0;
	op_increase_balls.sem_op = 1;
	op_increase_balls.sem_flg = 0;

	CollectBallMessage collectBallMessage;
	while (1) {
		printf("Cekam poruku : tip %d.\n", 5);

		if ((msgrcv(msqid, &collectBallMessage, sizeof(collectBallMessage) - sizeof(long), 5, 0)) == -1) {
			perror("unable to receive message");
			exit(1);
		}

		sleep(2);

		printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", 0, semid, 1);
		sleep(3);
		semop(semid, &op_increase_balls, 1);
	}
}