#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct STALAK
{
	int ukupanbrojlopti;
	int naraspolaganju;
};

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main()
{
	key_t key=ftok("./igrac.c",'A');
	int shmid=shmget(key,1024,0666|IPC_CREAT);
	
	key=ftok("./igrac",'B');
	int semid=semget(key,2,0666|IPC_CREAT|IPC_EXCL); //broj semafora?
	
	struct STALAK *stalak;
	union semun arg;
	struct sembuf semaforP,semaforV, redarP;
	
	
	stalak=shmat(shmid,NULL,0);
	
	if(semid!=-1)
	{
		//stalak
		arg.val=stalak->ukupanbrojlopti;//toliko imam lopti koje mogu da se koriste
		semctl(semid,0,SETVAL,arg);
		
		arg.val=0;
		semctl(semid,1,SETVAL,arg);//redar, cim se sutira redar vraca loptu

	}
	else if(errno==EEXIST)
	{
		semid=semget(key,2,0); //broj semafora?
	}
	else
	{
		printf("Doslo je do greske\n");
		exit(1);
	}
	
	redarP.sem_num=1;
	redarP.sem_op=-1;
	redarP.sem_flg=0;
	
	semaforP.sem_num=0;
	semaforP.sem_op=-1;
	semaforP.sem_flg=0;
	
	semaforV.sem_num=0;
	semaforV.sem_op=+1;
	semaforV.sem_flg=0;
	
	while(1)
	{
		semop(semid,&redarP,1);
			semop(semid,&semaforP,1);
			
			stalak->naraspolaganju=stalak->ukupanbrojlopti;
			sleep(2);
			
			semop(semid,&semaforV,1);
	}
	
	shmdt(stalak);
	
}
