#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>

union semun{
	
	int val;
	struct semid_ds *buf;
	ushort *array;
	
};
typedef struct kos{
		
	int kos1;
	int kos2;
	int kos3;
	int kos4;
	int stalak;
	
}kos;

int main(){
	
	key_t kljuc;
	kljuc=ftok("./redar.c",65);
	
	int shmid=shmget(kljuc,sizeof(kos),0666|IPC_CREAT);
	kos *data;
	data=shmat(shmid,NULL,0);
	
	int semid=semget(kljuc,2,0644|IPC_CREAT|IPC_EXCL);
	union semun arg;
	struct sembuf povecaj,smanji;
	
	data->kos1=0;
	data->kos2=0;
	data->kos3=0;						//redar ucitava pocetne vrednosti
	data->kos4=0;
	int n;
	printf("koliko stalak ima lopti: ");
	scanf("%d",&n);
	data->stalak=n;
	
	if(semid!=-1){
		
		arg.val=0;
		semctl(semid,0,SETVAL,arg);
		arg.val=0;
		semctl(semid,1,SETVAL,arg);

		
	}
	else if (errno==EEXIST){
		
		semid=semget(kljuc,2,0);
		
	}
	else{
		printf("greska\n");
		exit(0);
	}
	
	
	smanji.sem_num=1;
	smanji.sem_op=-1;
	smanji.sem_flg=0;
	
	povecaj.sem_num=0;
	povecaj.sem_op=1;
	povecaj.sem_flg=0;
	
	int sluc;
	int sluc2;
	
	if(data->stalak>0){
		
		printf("povecavam semafor 0 iz skupa %d za vrednost 1\n",semid);
		sleep(3);
		semop(semid,&povecaj,1);
	}
	else{ 
		printf("ne postoji lopta za igru..\n");
		exit(0);
	}
	while (1){
		
		printf("smanjujem semafor 1 iz skupa %d za vrednost -1\n",semid);
		sleep(3);
		semop(semid,&smanji,1);
		printf("vracam loptu na stalak\n");
		sleep(2);
		data->stalak++;
		printf("povecavam semafor 0 iz skupa %d za vrednost 1\n",semid);
		sleep(3);
		semop(semid,&povecaj,1);
		
	}
	
	
		
	
	
	
	return 0;
	
}
