#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define N 3 //broj lopti
int semid, shmid, idReda;
//int *data;
pid_t pidD;
int rbrKosa;
struct Kosevi *kosevi;

struct poruka
{
	long tip;
	int rbrKosa;
	int rbrIgraca;
};

struct poruka pomoc;

void handler(int sig)
{
	printf("PRIMIO SIGINT, brisem!\n");
	//brise sem
	semctl(semid, 0, IPC_RMID);
	
	//brise red za por
	msgctl(idReda, IPC_RMID, NULL);
	
	//brise mem
	//shmdt(data);
	shmdt(kosevi);
	shmctl(shmid,IPC_RMID, NULL);
}

void sighandler(int sig)
{
	pomoc.tip=rand()%4+1; //brojevi od 1 do 4 (rbrIgraca)
	pomoc.rbrKosa=rbrKosa;
	printf("Saljem poruku : tip %ld , rbrKosa %d\n", pomoc.tip, pomoc.rbrKosa);
	msgsnd(idReda, &pomoc,sizeof(pomoc), 0);
}

struct Kosevi
{
	int lopte;
	int kos[5];
};

union semun {

int val;
/* used for SETVAL only */

struct semid_ds *buf; /* used for IPC_STAT and IPC_SET */

ushort *array;
};




int main(int args,char *argv[]) //kako vec
{
	key_t kljuc,kljuc1,kljuc2;
	pid_t pid_forka;
	kljuc1=ftok("./zadatak33.c",11);
	shmid=shmget(kljuc1, 1024, 0644|IPC_CREAT);
	kosevi=shmat(shmid,NULL,0);
	kosevi->lopte=N;
	//kosevi->kos[rbrKosa]; //na koji gadja
	//int rbrKosa; (u handleru imam pa je glob.)		//argv[1][1] ;//LUPIO SAM NEMAM POJMA ....TODO
	printf("UNESI REDNI BROJ KOSA !\n");
	scanf("%d", &rbrKosa);
	kosevi->kos[rbrKosa]=0; //pogodaka
	int rbrIgraca=rbrKosa;
	int ind, kos=0, promasaj=0;
	
	struct sembuf P,S;
	union semun op_nad_sem;
	int pom;
	//signal(SIGINT, handler);
		
	kljuc=ftok("./zadatak3.c",1);
	kljuc2=ftok("./zadatak333.c",111);
	semid=semget(kljuc, 1,0644|IPC_CREAT|IPC_EXCL);
	idReda=msgget(kljuc2,IPC_CREAT|0666);
	
	//attaching memory segment
	//data=shmat(shmid, NULL,0);
	//*data=N;
	
	//semafori
	if(semid!=-1)
	{
		//inicijalizacija
		op_nad_sem.val=1;
		semctl(semid, 0, SETVAL, op_nad_sem); //STALAK
		//TODO: dodaj
	}
	else if(errno==EEXIST)
	{
		//povezi se na postojeci
		semid=semget(kljuc, 1, 0);
	}
	else
	{
		printf("ERROR SEMAFORI!\n");
	}	
	
	//opSEMAFORI
	P.sem_num= 0; //TODO
	P.sem_op=1;
	P.sem_flg=0;
	
	S.sem_num=0; //TODO
	S.sem_op=-1;
	S.sem_flg=0;
	
	//igra
	pid_forka=fork();
	
		switch(pid_forka)
		{
			case -1:
				printf("Nema deteta!\n");
				
			case 0:	//dete za svakih 10 sekundi ispise koliko je roditeljski semafor primio koseva
				pidD=getpid();
				signal(SIGINT, sighandler);
				while(1)
				{
					printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", S.sem_num, semid,S.sem_op);
					sleep(3);	//napomena
					
					ind=semop(semid, &S, 1);
					if(ind==-1) break;
					sleep(10); //ispis pogodaka na kos roditelja
					printf("Kroz kos %d je proslo %d lopti\n", rbrKosa,kosevi->kos[rbrKosa]); 
				
					printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", P.sem_num,semid, P.sem_op);
					sleep(3);	//napomena
					
					ind=semop(semid, &P, 1);
					if(ind==-1) break;		 
				}
				
			default://roditelj igra igru
				while(1)
				{
					//prilazi stalku i uzima loptu  1sec
					printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", S.sem_num, semid,S.sem_op);
					sleep(3);	//napomena
					
					//	//uzimanje lopte POCETAK// //   LOPTE
					
					ind=semop(semid, &S, 1);
					if(ind==-1) break;
					
					/*if(data!=0)
						(*data)--;	*/
					if(kosevi->lopte!=0)//
						kosevi->lopte--;//
					printf("SLOBODNIH LOPTI PREOSTALO %d\n", kosevi->lopte);
						
					sleep(1);
					
					printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", P.sem_num,semid, P.sem_op);
					sleep(3);	//napomena
					
					ind=semop(semid, &P, 1);
					if(ind==-1) break;		      
					
					//	//bacanje// //  
					//ako je primio poziv u pomoc
					ind=msgrcv(idReda, &pomoc, sizeof(pomoc),rbrIgraca, IPC_NOWAIT);
					if(ind!=-1) //znaci da je primio poziv u pomoc
					{//menjamo id kosa
						pom=rbrKosa;
						rbrKosa=pomoc.rbrKosa;
					}
					sleep(3); 	//bacanje traje 3 sek
					if(rand()%2==0) //ako je paran br onda je pogodak!
					{
						printf("KOOOS!\n");
						printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", S.sem_num, semid,S.sem_op);
						sleep(3);	//napomena
						
						ind=semop(semid, &S, 1);
						if(ind==-1) break;
						promasaj=0;
						
						//
						kosevi->kos[rbrKosa]+=1;
						//
						printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", P.sem_num,semid, P.sem_op);
						sleep(3);	//napomena
					
						ind=semop(semid, &P, 1);
						if(ind==-1) break;	
					}
					else //promasaj
					{
						printf("PROMAASAJ!\n");
						promasaj++;
						if(promasaj==2) //znaci da je dva puta promasio za redom 
							kill(pidD, SIGINT);
					}
					
									
					//e sad lopta je pala na pod i redar je kupi	 LOPTE
					printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", S.sem_num,semid, S.sem_op);
					sleep(3);	//napomena
					
					ind=semop(semid, &S, 1);
					if(ind==-1) break;	
					
					//(*data)++;
					(kosevi->lopte)++; //
					
					sleep(2);
					
					printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", P.sem_num,semid, P.sem_op);
					sleep(3);	//napomena
					
					ind=semop(semid, &P, 1);
					if(ind==-1) break;		   
					

					rbrKosa=pom; //vracamo igraca da igra na svom kosu
				}
		}
	return 0;
}
