#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define maxN 20

int idReda;
	
void signalHandler(int sig){
	msgctl(idReda, IPC_RMID, NULL);
	exit(0);
}

struct prijava
{
	long mtype; // tip poruke
	pid_t pid; // tekst poruke
};

int main()
{
	int n, brPrijavljenih;
	key_t kljuc;
	int idReda;
	
	signal(SIGINT, signalHandler);
	
	kljuc = ftok("./server.c", 0666);
	idReda = msgget(kljuc, IPC_CREAT|0666);
	
	scanf("%d", &n);
	printf("Cekam %d klijenta\n", n);
	
	struct prijava prijavaPoruka;
	struct prijava posaljiRedniBroj;
	
	brPrijavljenih = 0;
	
	while(brPrijavljenih < n){
		msgrcv(idReda, &prijavaPoruka, sizeof(prijavaPoruka), 5, 0);
		brPrijavljenih++;
		printf("Primljena prijava: pid je %d\n", prijavaPoruka.pid);
		
		posaljiRedniBroj.mtype = prijavaPoruka.pid;
		posaljiRedniBroj.pid = brPrijavljenih;
		msgsnd(idReda, &posaljiRedniBroj, sizeof(posaljiRedniBroj), prijavaPoruka.pid);	
	}
	
	
	//sleep(5);
	printf("Brisem red!\n");
	msgctl(idReda, IPC_RMID, NULL);
}
