#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int id_reda;

struct msg
{
	long tip;
	char text[50];
	int klijent_broj;
};

void signalHandler()
{
	msgctl(id_reda, IPC_RMID, NULL);
	exit(0);
}

int main()
{
	key_t kljuc=ftok("server.c",1);
	id_reda=msgget(kljuc,0666|IPC_CREAT);
	struct msg poruka;

	signal(SIGINT,signalHandler);

	int i=1;
	
	int n;
	printf("Ucitaj broj klijenata\n");
	scanf("%d",&n);

	while(i<=n)
	{
		char prijava[50];
		strcpy(prijava,"Hocu da se prijavim");
		printf("Cekam poruku : tip 100, tekst_poruke %s, klijent_broj nepoznat\n",prijava);
		msgrcv(id_reda,&poruka,sizeof(poruka),100,0);
		sleep(1);

		strcpy(poruka.text,"Prijavljen si");
		poruka.tip=100;
		poruka.klijent_broj=i;

		printf("Saljem poruku : tip %ld, tekst_poruke %s, klijent_broj %d\n",poruka.tip,poruka.text,poruka.klijent_broj);
		msgsnd(id_reda,&poruka,sizeof(poruka),0);
		sleep(1);
		i++;
	}

	for(i=1;i<=n;i++)
	{
		key_t kljuc1=ftok("klijent.c",i);
		int id_reda=msgget(kljuc1,0666|IPC_CREAT);

		

		strcpy(poruka.text,"Broj klijenata");
		poruka.tip=i;
		poruka.klijent_broj=n;
		printf("Saljem poruku : tip %ld, tekst_poruke %s, klijent_broj %d\n",poruka.tip,poruka.text,poruka.klijent_broj);
	}

	while(1);


}









