#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int pid;

void signalHandlerR()
{
	printf("Roditelj: Prekinuo me je proces dete.\n");
	exit(0);
}

void signalHandlerD()
{
	printf("Dete: Prekinuo me je proces roditelj.\n");
	exit(0);
}


int main()
{
	int n;
	srand(time(NULL));
	
	
	pid=fork();
	if(pid==0)
	{
		signal(SIGINT,signalHandlerD);
		n=rand()%21+1;
		printf("Proces dete je generisao broj %d\n",n);
		sleep(1);
		for(int i=1;i<=n;i++)
		{
			printf("%d\n",i);
			sleep(2);
		}
		kill(getppid(),SIGINT);
	}
	else
	{
		signal(SIGINT,signalHandlerR);
		n=rand()%20+1;
		printf("Proces roditelj je generisao broj %d\n",n);
		sleep(1);
		for(int i=1;i<=n;i++)
		{
			printf("%d\n",i);
			sleep(2);
		}
		kill(pid,SIGINT);
	}
	
}
