#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>

void signal_handler_chld(int);
void signal_handler_prnt(int);

int main(void)
{	
	pid_t pid = fork();
	
	if(pid < 0) {
		printf("Fork greska.\n");
		return EXIT_FAILURE;
	}
	
	/* DIJETE: */
	if(pid == 0) {
		srand(getppid());
		signal(SIGINT, signal_handler_chld);
		int i, n = rand() % 20;
		/* dodati printf n */
		for(i = 1; i <= n; i++) {
			printf("\tDIJETE: %d\n", i);
			sleep(2);
		}
		kill(getppid(), SIGINT);
		return EXIT_SUCCESS;
	/* RODITELJ: */	
	} else {
		srand(pid);
		signal(SIGINT, signal_handler_prnt);
		int i, n = rand() % 20;
		for(i = 1; i <= n; i++) {
			printf("RODITELJ: %d\n", i);
			sleep(2);
		}
		kill(pid, SIGINT);
	}
	
	return EXIT_SUCCESS;
}

void signal_handler_chld(int signal)
{
	printf("\tDIJETE: prekinuo me proces roditelj.\n");
	exit(EXIT_SUCCESS);
}

void signal_handler_prnt(int signal)
{
	printf("RODITELJ: prekinuo me proces dijete.\n");
	exit(EXIT_SUCCESS);
}
