#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <ctype.h>
#include <errno.h>
#include <time.h>
#include <sys/ipc.h>
#include <sys/wait.h>
#include <sys/msg.h>
#include <sys/types.h>

void ChildSignal(int sig)
{
	printf("DETE: Prekinuo me proces roditelj\n");
	exit(0);
}

void ParentSignal(int sig)
{
	printf("RODITELJ: Prekinuo me proces dete\n");
	exit(0);
}

int main()
{
	int ppid, cpid, i, n;
	
	//srand(time(NULL));
	
	ppid = getpid();	

	if(cpid = fork())
	{
		srand(getpid());
		n = rand() % 10 + 1;
		//n = 4;
		signal(SIGINT, ParentSignal);		
		printf("RODITELJ: MOJ PID: %d\tPID DETETA: %d\tN = %d\n", ppid,cpid,n);	
		for(i = 1; i <= n; i++)
		{
			printf("RODITELJ: %d\n", i);
			sleep(2);
		}
		
		kill(cpid, SIGINT);		
	}
	else
	{
		srand(getpid());
		n = rand() % 10 + 1;
		//n = 5;
		signal(SIGINT, ChildSignal);
		printf("DETE: MOJ PID: %d\tPID RODITELJA: %d\tN = %d\n", getpid(),ppid,n);	
		for(i = 1; i <= n; i++)
		{
			printf("DETE: %d\n", i);
			sleep(2);
		}
		
		kill(ppid, SIGINT);		
	}
}
