#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <ctype.h>
#include <errno.h>
#include <time.h>
#include <sys/ipc.h>
#include <sys/wait.h>
#include <sys/msg.h>
#include <sys/types.h>

long myNum;
long clients;

struct message
{
	long type;
	long number;
	char text[100];
};

int main()
{
	key_t key;
	int id,n;
	long pid;
	struct message msg;
	long i;
	
	key = ftok("./server.c", 1);
	id = msgget(key, IPC_CREAT|0666);
	pid = getpid();
	
	printf("KLIJENT %ld: saljem prijavu\n", pid);
	msg.type = 999;
	msg.number = pid;
	strcpy(msg.text, "Zelim da se prijavim");	
	msgsnd(id, &msg, sizeof(msg), 0);

	msgrcv(id, &msg, sizeof(msg), pid, 0);
	myNum = msg.number;
	printf("Prijavljen sam pod rednim brojem %ld\n", myNum);

	msgrcv(id, &msg, sizeof(msg), myNum, 0);
	clients = msg.number;
	printf("Ukupno prijavljeno klijenata: %ld\n", clients);

	while(1)
	{
		printf("\nCekam poruku za %ld\n", myNum);
		sleep(3);
		msgrcv(id, &msg, sizeof(msg), myNum, 0);
		printf("Primljena poruka: %s", msg.text);
		//sleep(2);
		i = rand() % clients + 1;
		while(i == myNum)
			i = rand() % clients + 1;
		msg.type = i;
		printf("Saljem poruku tip %ld, tekst poruke: %s", i, msg.text);
		sleep(3);
		msgsnd(id, &msg, sizeof(msg), 0);
	}


	msgctl(id, IPC_RMID, NULL);
}
