#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct msg
{
	long tip;
	char text[100];
	int pid;
	int broj_prijavljenih;
};

int main()
{
	srand(time(NULL));
	
	key_t key=ftok("./server.c",'A');
	int id_reda=msgget(key,0);
	
	struct msg poruka;
	
	poruka.tip=25;
	poruka.pid=getpid();
	
	msgsnd(id_reda,&poruka,sizeof(poruka),0);
	msgrcv(id_reda,&poruka,sizeof(poruka),getpid(),0);
	
	poruka.tip=poruka.pid; //redni broj
	
	int rbr=poruka.pid;
	int n=poruka.broj_prijavljenih;
	
	//printf("Prijavio sam se, rbr: %d\n",rbr);
	
	while(1)
	{
		printf("Cekam poruku: tip %d\n",rbr);
		msgrcv(id_reda,&poruka,sizeof(poruka),rbr,0);
		printf("\ttext poruke: %s, broj klijenata %d\n",poruka.text,poruka.broj_prijavljenih);
		
		//sleep(1);
		
		printf("Unesi poruku: ");
		fgets(poruka.text,sizeof(poruka.text),stdin);
		//poruka.text[strlen(poruka.text)]='\0';
	
		do
		{
			poruka.tip=rand()%n+1;
		}while(poruka.tip==rbr);
		
		msgsnd(id_reda,&poruka,sizeof(poruka),0);
		printf("Saljem poruku klijentu %ld, poruka: %s, broj klijenata %d\n",poruka.tip,poruka.text,poruka.broj_prijavljenih);
		
		//sleep(2);
	}
}
