#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int idReda;

struct prijava
{
	long tip;
	int rbr;
	pid_t pid_klijenta;
};

struct obavestenjeP
{
	long tip;
	int brPrijavljenih;
};

struct poruka
{
	long tip;
	char tekst[15];
};

void handler(int sig)
{
	printf("UHVACEN SIGINT!\n");
	msgctl(idReda, IPC_RMID,NULL);
	exit(0);
}

int main()
{
	int N,i;
	int klijent;
	key_t kljuc;
	char rec[15];
	
	signal(SIGINT, handler);
	
	printf("UNESI BR KLIJENATA N: ");
	scanf("%d",&N);
	
	struct prijava prijavaK;
	struct obavestenjeP obavestenje;
	struct poruka por;
	
	kljuc=ftok("./server.c",1);
	idReda=msgget(kljuc, IPC_CREAT|0666);
	
	for(i=1;i<=N;i++)
	{
		msgrcv(idReda, &prijavaK, sizeof(prijavaK), 5,0); //5 tip prijave
		printf("Prijavio se klijent %d! \n", prijavaK.pid_klijenta);
		prijavaK.tip=prijavaK.pid_klijenta;
		prijavaK.rbr=i;
		msgsnd(idReda, &prijavaK, sizeof(prijavaK),0); //vracamo rbr klijentu
		printf("Klijentu %ld poslat rbr: %d\n",prijavaK.tip, i);
	}
	
	obavestenje.brPrijavljenih=N;
	for(i=1;i<=N;i++)
	{
		obavestenje.tip=i;
		msgsnd(idReda, &obavestenje, sizeof(obavestenje),0); //ovabestavamo klijente o ukupnom broju prijaveljnih klijenata
		printf("Klijent sa rbr %d, obavesten.\n",i);
	}
	printf("Obavesteni su svi klijenti!\n");
	
	printf("Unesite poruku : ");
	fgetc(stdin);
	fgets(rec, sizeof(rec), stdin);
	
	klijent=rand()%N+1;
	
	por.tip=klijent;
	strcpy(por.tekst, rec);
	por.tekst[strlen(por.tekst)-1]='\0';
	printf("Saljem poruku :tip %ld, tekst_poruke %s \n",  por.tip, por.tekst);

	msgsnd(idReda, &por, sizeof(por), 0);
	return 0;
}
