#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct Poruka{
	long tip;
	int br;
};

int main(){
	
	srand(time(NULL));
	key_t key = ftok("./sredinica.c", 1);
	printf("kljuc1: %d\n", key);
	int msgid = msgget(key, 0666|IPC_CREAT);
	printf("msgid: %d\n", msgid);
	
	key = ftok("./sredinica.c", 2);
	printf("kljuc2: %d\n", key);
	int msgid2 = msgget(key, 0666|IPC_CREAT);
	printf("msgid2: %d\n", msgid2);
	
	
	int brp, br, uSredini;
	struct Poruka poruka;
	
	pid_t pid = fork();
	
	if (pid == 0){ 
		pid = fork();
		
		if (pid == 0){ 	//roditelj 1
			br = 1;
			uSredini = 1;
			//sleep(1);
			while(1){
				if (br == uSredini){ //ako sam u sredini
					
					brp = rand() % 2 + 2;
					printf("brb %d: Pokusavam da presretnem poruku tipa %d\n", br, brp);
					printf("rbr %d: Cekam poruku tipa %d\n", br, brp);
					if (msgrcv(msgid, &poruka, sizeof(poruka), brp, IPC_NOWAIT) != -1){
						printf("rbr %d: Dobio sam poruku: tip %ld ova poruka je uhvacena od %d\n", br, poruka.tip, poruka.br);
						//printf("Uhvatio sam rbr %d\n", poruka.br);
						
						if (brp == 2) poruka.tip = 3; //ako je presreo poruku tipa 2 nju je poslao 3 kojeg moram da obavestim da je u sredini
						if (brp == 3) poruka.tip = 2; //ovde obrnuto
						uSredini = poruka.br; // azuriranje informacije o onome ko je u sredini
						poruka.br = uSredini;
						printf("rbr %d: Saljem poruku tip %ld info ko je sad u sredini %d\n", br, poruka.tip, poruka.br);
						msgsnd(msgid2, &poruka, sizeof(poruka), 0);
						//sleep(3);
					}
					
					sleep(2);
				}
				else { //ako razmenjujem
					printf("rbr %d: Cekam poruku tipa %d\n", br, br);
					if (msgrcv(msgid2, &poruka, sizeof(poruka), br, IPC_NOWAIT) != -1){ //neko je uhvatio moju poruku
						printf("rbr %d: Dobio sam poruku: tip %ld br %d\n", br, poruka.tip, poruka.br);
						printf("rbr %d: %d je presreo moju poruku, sad sam ja u sredini\n", br, poruka.br);
						uSredini = br;
					}
					else{ //regularno razmenjivanje
						if (uSredini == 2) brp = 3;
						if (uSredini == 3) brp = 2;
						
						poruka.tip = brp;
						poruka.br = br;
						printf("rbr %d: Saljem poruku tipa %ld moj br %d\n", br, poruka.tip, poruka.br);
						msgsnd(msgid, &poruka, sizeof(poruka), 0);
						sleep(3);
						printf("rbr %d: Cekam poruku tipa %d\n", br, br);
						msgrcv(msgid, &poruka, sizeof(poruka), br, 0);
						printf("rbr %d: Dobio sam poruku: tip %ld br %d\n", br, poruka.tip, poruka.br);
						
					}
					
				}
			}
		}
		
		
		else{ // dete 2
			br = 2;
			uSredini = 1;
			//sleep(1);
			while(1){
				if (br == uSredini){ //ja sam u sredini
					
					if (rand() % 2 == 0) brp = 1;
					else brp = 3;
					printf("brb %d: Pokusavam da presretnem poruku tipa %d\n", br, brp);
					printf("rbr %d: Cekam poruku tipa %d\n", br, brp);
					if (msgrcv(msgid, &poruka, sizeof(poruka), brp, IPC_NOWAIT) != -1){
						printf("rbr %d: Dobio sam poruku: tip %ld ova poruka je uhvacena od %d\n", br, poruka.tip, poruka.br);
						//printf("Uhvatio sam rbr %d\n", poruka.br);
						
						if (brp == 1) poruka.tip = 3;
						if (brp == 3) poruka.tip = 1; 
						uSredini = poruka.br; // azuriranje informacije o onome ko je u sredini
						poruka.br = uSredini;
						printf("rbr %d: Saljem poruku tip %ld info ko je sad u sredini %d\n", br, poruka.tip, poruka.br);
						msgsnd(msgid2, &poruka, sizeof(poruka), 0);
						//sleep(3);
					}
					
					sleep(2);
				}
				else { //ja razmenjujem
					printf("rbr %d: Cekam poruku tipa %d\n", br, br);
					if (msgrcv(msgid2, &poruka, sizeof(poruka), br, IPC_NOWAIT) != -1){ //neko je uhvatio moju poruku
						printf("rbr %d: Dobio sam poruku: tip %ld br %d\n", br, poruka.tip, poruka.br);
						printf("rbr %d: %d je presreo moju poruku, sad sam ja u sredini\n", br, poruka.br);
						uSredini = br;
					}
					else{ //regularno razmenjivanje
						if (uSredini == 1) brp = 3;
						if (uSredini == 3) brp = 1;
						
						poruka.tip = brp;
						poruka.br = br;
						printf("rbr %d: Saljem poruku tipa %ld moj br %d\n", br, poruka.tip, poruka.br);
						msgsnd(msgid, &poruka, sizeof(poruka), 0);
						sleep(3);
						printf("rbr %d: Cekam poruku tipa %d\n", br, br);
						msgrcv(msgid, &poruka, sizeof(poruka), br, 0);
						printf("rbr %d: Dobio sam poruku: tip %ld br %d\n", br, poruka.tip, poruka.br);
						
					}
					
				}
			}
		}
	}
	
	
	else{ // dete 3
		br = 3;
		uSredini = 1;
		//sleep(1);
			while(1){
				if (br == uSredini){ //ja sam u sredini
					
					brp = rand() % 2 + 1;
					printf("brb %d: Pokusavam da presretnem poruku tipa %d\n", br, brp);
					printf("rbr %d: Cekam poruku %d\n", br, brp);
					if (msgrcv(msgid, &poruka, sizeof(poruka), brp, IPC_NOWAIT) != -1){
						printf("rbr %d: Dobio sam poruku: tip %ld ova poruka je uhvacena od %d\n", br, poruka.tip, poruka.br);
						//printf("Uhvatio sam rbr %d\n", poruka.br);
						
						if (brp == 2) poruka.tip = 1;
						if (brp == 1) poruka.tip = 2;
						uSredini = poruka.br; // azuriranje informacije o onome ko je u sredini
						poruka.br = uSredini;
						printf("rbr %d: Saljem poruku tip %ld info ko je sad u sredini %d\n", br, poruka.tip, poruka.br);
						msgsnd(msgid2, &poruka, sizeof(poruka), 0);
						//sleep(3);
					}
					
					sleep(2);
				}
				else { //ako razmenjujem
					printf("rbr %d: Cekam poruku tipa %d\n", br, br);
					if (msgrcv(msgid2, &poruka, sizeof(poruka), br, IPC_NOWAIT) != -1){ //neko je uhvatio moju poruku
						printf("rbr %d: Dobio sam poruku: tip %ld br %d\n", br, poruka.tip, poruka.br);
						printf("rbr %d: %d je presreo moju poruku, sad sam ja u sredini\n", br, poruka.br);
						uSredini = br;
					}
					else{ //regularno razmenjivanje
						if (uSredini == 2) brp = 1;
						if (uSredini == 1) brp = 2;
						
						poruka.tip = brp;
						poruka.br = br;
						printf("rbr %d: Saljem poruku tipa %ld moj br %d\n", br, poruka.tip, poruka.br);
						msgsnd(msgid, &poruka, sizeof(poruka), 0);
						sleep(3);
						printf("rbr %d: Cekam poruku tipa %d\n", br, br);
						msgrcv(msgid, &poruka, sizeof(poruka), br, 0);
						printf("rbr %d: Dobio sam poruku: tip %ld br %d\n", br, poruka.tip, poruka.br);
						
					}
					
				}
			}
	}
	
	
	
	return 0;
}
