#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t p;
pid_t t;
int pom1,pom2;

void signal_handler_roditelj(int sig)
{
	printf("Roditelj: Prekinuo me je proces dete\n");
	kill(p,SIGKILL);
	exit(0);
}

void signal_handler_dete(int sig)
{
	printf("Dete: Prekinuo me je proces roditelj\n");
	kill(t,SIGKILL);
	exit(0);
}

int main()
{
	int i;
	pid_t pom;
	pom = getpid();
	p = fork();
	
	if(p > 0)
	{
		//roditelj
		pom1 = rand()%20;
		printf("Roditelj: idem do %d\n",pom1);
		signal(SIGINT,signal_handler_roditelj);
		for(i=1;i<=pom1;i++)
		{
			printf("Roditelj: %d\n",i);
			sleep(2);
		}
		kill(p,SIGINT);
	}
	else
	{
		//dete
		pom2 = rand()%20;
		printf("Dete: idem do %d\n",pom2);
		t = getpid();
		signal(SIGINT,signal_handler_dete);
		for(i=1;i<=pom2;i++)
		{
			printf("Dete: %d\n",i);
			sleep(2);
		}
		kill(pom,SIGINT);
	}
}
