#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct poruka
{
	long tip_poruke;
	char tekst_poruke[5];
	pid_t pid;
	int redni_br;
	int br_klijenata;
};

int main()
{
	int n,i,id_reda,pom;
	key_t kljuc;
	struct poruka moja_poruka;
	printf("Unesi broj klijenata: ");
	scanf("%d",&n);
	
	//kreiraj red za poruke
	kljuc = ftok("./server.c",1);
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
	//ucitavanje klijenata
	for(i=1;i<=n;i++)
	{
		printf("Cekam poruku: tip %d",moja_poruka.tip_poruke);
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka),1,0);
		printf("Primio poruku!\n");
		moja_poruka.tip_poruka = moja_poruka.pid;
		moja_poruka.br_klijenata = n;
		fgets(moja_poruka.tekst_poruke,sizeof(moja_poruka.tekst_poruke),stdin);
		moja_poruka.tekst_poruke[strlen(moja_poruka.tekst_poruke) - 1] = "\0";
		moja_poruka.redni_br = i;
		printf("Saljem poruku: tip %d, tekst_poruke %s\n",moja_poruka.tip_poruke,moja_poruka.tekst_poruke);
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
	}
	printf("Server: Klijenti ucitani i obavesteni o ukupnom broju klijenata!\n");
	
	//priprema za slucajno slanje
	pom = rand() % n;
	moja_poruka.tip_poruke = pom;
	fgets(moja_poruka.tekst_poruke,sizeof(moja_poruka.tekst_poruke),stdin);
	moja_poruka.tekst_poruke[strlen(moja_poruka.tekst_poruke) - 1] = "\0";
	
	//slanje
	printf("Saljem poruku: tip %d, tekst_poruke %s\n",moja_poruka.tip_poruke,moja_poruka.tekst_poruke);
	msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka),0);
}
