#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pid;

void signalHandlerChild()
{
	printf("Dete: Prekinuo me je proces roditelj.\n");
	kill(getppid(), SIGKILL);
	exit(0);
}

void signalHandlerParent()
{
	printf("Roditelj: Prekinuo me je proces dete.\n");
	kill(pid, SIGKILL);
	exit(0);
}

int main()
{
	int i,j,n;
	srand(time(NULL));
	pid = fork();
	
	switch(pid)
	{
		case -1:
			perror("Greska pri forkovanju.\n");
			exit(0);
		case 0:
			signal(SIGINT, signalHandlerChild);
			
			n = rand()%20;
			printf("Dete ide do broja: %d\n",n);
			
			for(i=1; i<=n; i++)
			{
				printf("Dete %d\n",i);
				sleep(2);
			}	
			kill(getppid(), SIGINT);
		default:
			signal(SIGINT, signalHandlerParent);
	
			n = rand()%20;
			printf("Roditelj ide do broja: %d\n",n);
			
			for(j=1; j<=n; j++)
			{
				printf("Roditelj %d\n",j);
				sleep(2);
			}
			kill(pid, SIGINT);
	}
	
	
	
	
	
	
	
	
	
	
	return 0;
}
