#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

void handler1 (int sig) {
	printf("DETE: Prekinuo me je process roditelj\n");
	exit(1);
}

void handler2 (int sig) {
	printf("RODITELJ: Prekinuo me je process dete\n");
	exit(1);
}

int main () {
	srand(time(NULL));
	pid_t pid;
	int i, n;
	
	pid = fork();
	
	if (pid == -1) {
		printf("Greska\n");
		exit(1);
	}
	
	else if (pid == 0) {
		signal(SIGINT, handler1);
		n = rand()%21;
		while(n == 0)
			n = rand()%21;
		printf("DETE: n je %d\n", n);
		for (i = 1; i <= n; i++) {
			printf("DETE: %d\n", i);
			sleep(2);
		}
		kill(getppid(), SIGINT);
	}
	
	else {
		signal(SIGINT, handler2);
		n = rand()%21;
		while(n == 0)
			n = rand()%21;
		printf("RODITELJ: n je %d\n", n);
		for (i = 1; i <= n; i++) {
			printf("RODITELJ: %d\n", i);
			sleep(2);
		}
		kill(pid, SIGINT);
	}

	return 0;
}
