#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct moja_poruka {
	long tip;
	int pid;
	int id;
	int ukupno;
	char tekst[100];
};

int id_reda;

void handler (int sig) {
	printf("Brisanje reda za poruke\n");
	msgctl(id_reda, IPC_RMID, NULL);
	exit(1);
}

int main() {
	srand(time(NULL));
	key_t kljuc;
	int i, n;
	struct moja_poruka poruka;
	
	signal(SIGINT, handler);
	
	kljuc = ftok("server.c", 'c');
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
	printf("Unesite n: ");
	scanf("%d", &n);
	
	for (i = 1; i <= n; i++) {
		msgrcv(id_reda, &poruka, sizeof(poruka), 123, 0);
		printf("Primio sam prijavu od %d-tog klijenta\n", i);
		poruka.tip = poruka.pid;
		poruka.id = i;
		poruka.ukupno = n;
		msgsnd(id_reda, &poruka, sizeof(poruka), 0);
	}
	
	printf("Unesite poruku: ");
	fgets(poruka.tekst, sizeof(poruka.tekst), stdin);
	
	poruka.id = rand()%n;
	while(poruka.id == 0)
		poruka.id = rand()%n;
	poruka.tip = poruka.id;
	printf("Saljem poruku: tip %ld, tekst_poruke %s\n", poruka.tip, poruka.tekst);
	msgsnd(id_reda, &poruka, sizeof(poruka), 0);
	exit(1);
	
	return 0;
}
