#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pid, pidR;

void signalhandlerD(int sig)
{
	printf("Roditelj: Prekinuo me je process dete.\n");
	kill(pid, SIGKILL);
	kill(pidR, SIGKILL);
}

void signalhandlerR(int sig)
{
	kill(pid, SIGKILL);
	printf("Dete : Prekinuo me je process roditelj.\n");
	kill(pidR, SIGKILL);
}

int main()
{	
	
	pid = fork();
	
	pidR = getpid();
	
	if(pid)
	{
		signal(SIGINT, signalhandlerR);
		int p, k;
		
		srand(time(NULL));
		p = rand() % 20 + 1;
		printf("Roditelj ide do broja %d\n", p);
		
		for(k = 1; k<=p; k++)
		{
				printf("Roditelj: %d\n", k);
				sleep(2);
		}
		signalhandlerR(SIGINT);
	}
	else
	{
		signal(SIGINT, signalhandlerD);
		int i, n;
		
		srand(time(NULL));
		n = rand() % 20 + 1;
		
		printf("Dete ide do broja %d\n", n);
		
		for(i = 1; i<=n; i++)
		{
			
				printf("Dete: %d\n", i);
				sleep(2);
		}
		
		signalhandlerD(SIGINT);
	}
	
	return 0;
}
