#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct poruka
{
	long mtype;
	char sadrzaj[20];
	int rb;
	int ukupanBrPrijavljenih;
};

int main()
{
	
	int n,i;
	struct poruka mporuka;
	
	printf("Unesite broj N: \n");
	scanf("%d", &n);
	
	key_t kljuc = ftok("./server", 'A');
	
	int id_reda = msgget(kljuc, IPC_CREAT | 0666 );
	
	
	for( i = 1; i <= n; i++ )
	{
		//mporuka.rb = i;
		mporuka.mtype = i;
		mporuka.sadrzaj = '';
		mporuka.ukupanBrPrijavljenih = n;
		
		printf("Prijavljuje se klijent broj %d\n", i);
		msgsnd(id_reda, &mporuka, sizeof(mporuka), 0);
		
		
	}
	
	int k;
	
	srand(time(NULL));
	k = rand() % 20 + 1;
	
	printf("Prijava je zavrsena, saljem poruku klijentu br: %d\n", k);
	
	mporuka.ukupanBrPrijavljenih = n;
	mporuka.mtype = k;
	scanf("%s", mporuka.sadrzaj);
	printf("Saljem poruku: tip %d, tekst_poruke %s\n", mporuka.mtype, mporuka.sadrzaj);
	
	msgsnd(id_reda, &mporuka, sizeof(mporuka), 0);
	
	
	while(1)
	{
		printf("Cekam poruku %s\n", mporuka.sadrzaj);
		msgrcv(id_reda, &mporuka, sizeof(mporuka), 0, 0);
		
	}
	
	return 0;
}





//msgsnd(id_reda, &mporuka, sizeof(mporuka), 0);

//int msgrcv(id_reda, &mporuka, sizeof(mporuka), long mtype, int msgflg);
