#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct moja_poruka
{
        long tip;
        int redniBroj;
        int ukupanBroj;
        char tekst[100];
};

int main(){
        key_t kljuc;
        int id_reda, n;
        struct moja_poruka poruka;
        
        kljuc=ftok("./server.c", 1);
        id_reda=msgget(kljuc, IPC_CREAT|0666);
        
        poruka.tip=99;
        msgsnd(id_reda, &poruka, sizeof(poruka), 0);
        
        msgrcv(id_reda, &poruka, sizeof(poruka), 99, 0);
        
        
        printf("Cekam poruku  tipa %ld\n", poruka.tip);
        msgrcv(id_reda, &poruka, sizeof(poruka), poruka.redniBroj, 0);
        printf("Primio sam poruku %s\n", poruka.tekst);
        
        srand(time(NULL));
        n=(rand()%19)+1;
        
        while(poruka.redniBroj==n && n<=poruka.ukupanBroj){
                srand(time(NULL));
                n=(rand()%19)+1;        
        }
        
        while(1){
                poruka.tip=n;
                fgets(poruka.tekst, sizeof(poruka.tekst), stdin);
                printf("Saljem poruku %s\n", poruka.tekst);
                msgsnd(id_reda, &poruka, sizeof(poruka), 0);
                printf("Cekam poruku tipa %d\n", poruka.redniBroj);
                msgrcv(id_reda, &poruka, sizeof(poruka), poruka.redniBroj, 0);
        }
}
