#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

void roditelj(int signal, int sigint)
{
	printf("RODITELJ: Ubio me je proces dete\n");
	exit(0);
}
void dete(int signal, int sigint)
{
	printf("DETE: Ubio me je proces roditelj\n");
	exit(0);
}
int main()
{
	int n;
	int pid = fork();
	if(pid)	//RODITELJ
	{
		srand(time(NULL));
		n = (rand() % 20) +1;
		printf("%d\n",n);
		signal(SIGINT,roditelj);
		int i;
		for(i = 1; i <= n;i++)
		{
			printf("RODITELJ: %d\n",i);
			sleep(2);
		}
		kill(pid,SIGINT);
	}
	else //DETE
	{
		srand(time(NULL));
		n = (rand() % 20) +1;
		printf("%d\n",n);
		signal(SIGINT,dete);
		int i;
		for(i = 1; i <= n;i++)
		{
			printf("DETE: %d\n",i);
			sleep(2);
		}
		kill(getppid(),SIGINT);
	}
}
