#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct poruka
{
	long tip;
	char tekst[100];
	long rbr;
	long pid;
	int brojPrijava;
};

int main()
{
	int N,id;
	//pid_t pid;
	long br,pid;
	key_t kljuc;
	kljuc=ftok("./Server.c",15);
	id=msgget(kljuc,0666|IPC_CREAT);
	printf("ID reda za poruke je %d\n",id);
	struct poruka moja_poruka,poruka;
	moja_poruka.tip=21;
	moja_poruka.pid=getpid();
	pid=getpid();
	
	printf("Saljem zahtev serveru za redni broj, tip: %ld, pid: %ld\n",moja_poruka.tip, moja_poruka.pid);
	msgsnd(id,&moja_poruka,sizeof(moja_poruka),0);
	
	printf("Primam poruku od servera o rednom broju, tipa: %ld\n",moja_poruka.pid);
	msgrcv(id,&moja_poruka,sizeof(moja_poruka),pid,0);
	printf("Redni broj klijenta je %ld\n", moja_poruka.rbr);
	
	printf("Primam poruku od servera o ukupnom broju klijenata\n");
	msgrcv(id,&poruka,sizeof(poruka),moja_poruka.rbr,0);
	printf("Tip: %ld, redni broj %ld, ukupno klijenata %d\n", poruka.tip, poruka.rbr,poruka.brojPrijava);
	
	printf("Primam poruku tipa %ld \n", moja_poruka.rbr);
	msgrcv(id,&poruka,sizeof(poruka),moja_poruka.rbr,0);
	
	
	printf("Primio sam poruku tipa %ld, moj redni broj je %ld, tekst poruke je %s\n", poruka.tip, poruka.rbr, poruka.tekst);
	
	
	br=rand()%N;
	while(br==moja_poruka.rbr)
	{
		printf("Ne mogu sam sebi poslati poruku. Biram ponovo\n");
		br=rand()%N;
	}
	
	printf("Unesi poruku za slanje \n");
	scanf("%s", poruka.tekst);
	//fgets(poruka.tekst,sizeof(poruka.tekst),stdin);
	printf("Uneta poruka za slanje je %s\n", poruka.tekst);
	
	poruka.tip=br;
	poruka.rbr=br;
	printf("Saljem poruku klijentu sa rednim brojem %ld, tipa %ld\n", poruka.rbr, poruka.tip);
	msgsnd(id,&poruka,sizeof(poruka),0);
	
	msgctl(id,IPC_RMID,NULL);
	return 0;
}
