#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct poruka
{
	long tip;
	char tekst[100];
	long rbr;
	long pid;
	int brojPrijava;
};

int main()
{
	int N,i,id;
	long br;
	key_t kljuc;
	kljuc=ftok("./Server.c",15);
	id=msgget(kljuc,0666|IPC_CREAT);
	printf("ID reda za poruke je %d\n",id);
	struct poruka moja_poruka,poruka;
	
	printf("Unesi N:\n");
	scanf("%d",&N);
	printf("Broj klijenata je %d\n",N);
	
	for(i=1;i<=N;i++)
	{
		printf("Tip klijenta od kog se prima zahtev za redni broj je %ld\n",moja_poruka.tip);
		msgrcv(id,&moja_poruka,sizeof(moja_poruka),21,0);
		moja_poruka.rbr=i;
		moja_poruka.tip=moja_poruka.pid;
		
		//Ispisuje poruku posle slanja iz razloga da bi ispisao i redni broj
		
		msgsnd(id,&moja_poruka,sizeof(moja_poruka),0);
		printf("Saljem poruku: tip: %ld, redni broj: %ld, pid: %ld\n",moja_poruka.tip,moja_poruka.rbr,moja_poruka.pid);
		
	}
	
	for(i=1;i<=N;i++)
	{
		printf("Saljem obavestenje o broju prijavljenih klijenata\n");
		printf("Saljem klijentu: tip: %d, redni broj %d, brojPrijavljenih %d\n",i,i, N );
		//poruka.tip=moja_poruka.rbr;
		poruka.tip=i;
		poruka.rbr=i;
		poruka.brojPrijava=N;
		msgsnd(id,&poruka,sizeof(poruka),0);
		
	}
	
	br=rand()%N;
	poruka.tip=br;
	poruka.rbr=br;
	printf("Unesi poruku za slanje\n");
		scanf("%s", poruka.tekst);
	//fgets(poruka.tekst,sizeof(poruka.tekst),stdin);
	printf("Saljem poruku slucajno odabranom klijentu.Poruka za slanje je  %s, klijent je sa rednim brojem %ld, tipa %ld \n", poruka.tekst, br,poruka.tip);
	
	msgsnd(id,&poruka,sizeof(poruka),0);	
	msgctl(id,IPC_RMID,NULL);
	return 0;
}
