#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


struct poruke
{
	long tip;
	char tekst[30];
	int rbr;
};


int main()
{
	key_t kljuc;
	int id_reda, shmid;
	struct poruke poruka;
	int* data;
	
	kljuc = ftok("./sredinica.c",'A');
	id_reda = msgget(kljuc, IPC_CREAT|0666);
	
	kljuc = ftok("./sredina.c",'S');
	shmid = shmget(kljuc, sizeof(data), 0666|IPC_CREAT);
	
	data = shmat(shmid, NULL, 0);
	*data = 1;
	
	switch( fork() )
	{
		case 0:
		{
			int rbr, tip, pom;
			rbr = 2;
			poruka.tip = poruka.rbr = 2;
			
			while( 1 )
			{
				if( rbr == *data )
				{
					tip = random()%3 + 1;
					pom = msgrcv(id_reda,&poruka,sizeof(poruka),tip,IPC_NOWAIT);
					if( pom != -1 )
					{
						printf("Uhvatio sam poruku, sada je rbr %d u sredini\n",poruka.rbr);
						*data = poruka.rbr;
						poruka.tip = 2;
						msgsnd(id_reda,&poruka,sizeof(poruka),0);
					}
					else
						sleep(2);
				}
				else
				{
					sleep(3);
					printf("rbr %d: Saljem poruku\n",rbr);
					msgsnd(id_reda,&poruka,sizeof(poruka),0);
					printf("rbr %d: Cekam poruku\n",rbr);
					if( *data == 1 )
						msgrcv(id_reda,&poruka,sizeof(poruka),3,0);
					else
						msgrcv(id_reda,&poruka,sizeof(poruka),1,0);
					poruka.tip = poruka.rbr = 2;
				}
		
			}
			
			
		};break;
		
		default:
		{
			
			switch( fork() )
			{
				case 0:
				{
					int rbr, tip, pom;
					rbr = 3;
					poruka.tip = poruka.rbr = 3;
					
					while( 1 )
					{
						if( rbr == *data )
						{
							tip = random()%3 + 1;
							pom = msgrcv(id_reda,&poruka,sizeof(poruka),tip,IPC_NOWAIT);
							if( pom != -1 )
							{
								*data = poruka.rbr;
								printf("Uhvatio sam poruku, sada je rbr %d u sredini\n",poruka.rbr);
								poruka.tip = 3;
								msgsnd(id_reda,&poruka,sizeof(poruka),0);
							}
							else
								sleep(2);
						}
						else
						{
							printf("rbr %d: Cekam poruku\n",rbr);
							sleep(3);
							if( *data == 1 )
								msgrcv(id_reda,&poruka,sizeof(poruka),2,0);
							else
								msgrcv(id_reda,&poruka,sizeof(poruka),1,0);
							poruka.tip = poruka.rbr = 3;
							sleep(3);
							printf("rbr %d: Saljem poruku\n",rbr);
							msgsnd(id_reda,&poruka,sizeof(poruka),0);

						}
					}
					
				};break;
				
				default:
				{
					int rbr, tip, pom;
					rbr = 1;
					poruka.tip = poruka.rbr = 1;
					while( 1 )
					{
						if( rbr == *data )
						{
							tip = 2;
							pom = msgrcv(id_reda,&poruka,sizeof(poruka),tip,IPC_NOWAIT);
							if( pom != -1 )
							{
								printf("Uhvatio sam poruku, sada je rbr %d u sredini\n",poruka.rbr);
								*data = poruka.rbr;
								poruka.tip = 1;
								msgsnd(id_reda,&poruka,sizeof(poruka),0);
								
							}
							else
								sleep(2);
						}
						else
						{
							sleep(3);
							printf("rbr %d: Saljem poruku\n",rbr);
							msgsnd(id_reda,&poruka,sizeof(poruka),0);
							if( *data != rbr )
							{
								printf("rbr %d: Cekam poruku\n",rbr);
								if( *data== 2 )
									msgrcv(id_reda,&poruka,sizeof(poruka),3,0);
								else
									msgrcv(id_reda,&poruka,sizeof(poruka),2,0);
							}
							poruka.tip = poruka.rbr = 1;
						}
						
					}
				};break;
			}
			
		};break;
	}
}
