#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<errno.h>
#include<unistd.h>
#include<sys/types.h>
#include<signal.h>
#include<sys/ipc.h>
#include<sys/msg.h>
#include<time.h>

struct sadrzaj_poruke
{
	pid_t pid;
	char tekst[100];
	int broj;
	int ukupno;
};

struct poruka
{
	long tip_poruke;
	struct sadrzaj_poruke sadrzaj;
};

int main()
{
	srand(time(NULL));
	key_t key = ftok("./klijent.c",'A');
	int id_reda=msgget(key,0666|IPC_CREAT);
	struct poruka moja_poruka;
	pid_t pidd;
	char s[100];
	int br,nasumicno;
	
	int n,i;
	printf("Unesi broj klijenata:");
	scanf("%d",&n);
	
	for(i=1;i<=n;i++)
	{
		msgrcv(id_reda,&moja_poruka,sizeof(moja_poruka.sadrzaj),25,0);
		
		pidd=moja_poruka.sadrzaj.pid;
		strcpy(s,moja_poruka.sadrzaj.tekst);
		br=moja_poruka.sadrzaj.broj;
		
		moja_poruka.sadrzaj.pid=pidd;
		moja_poruka.tip_poruke=pidd;
		moja_poruka.sadrzaj.broj=i;
		moja_poruka.sadrzaj.ukupno=0;
		strcpy(moja_poruka.sadrzaj.tekst,"");
		
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.sadrzaj),0);
	}
	
	for(i=1;i<=n;i++)
	{
		moja_poruka.sadrzaj.broj=i;
		moja_poruka.tip_poruke=i;
		moja_poruka.sadrzaj.pid=0;
		strcpy(moja_poruka.sadrzaj.tekst,"");
		moja_poruka.sadrzaj.ukupno=n;
		
		msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.sadrzaj),0);
	}
	
	getchar();
	printf("Unesi poruku:");
	fgets(s,sizeof(s),stdin);
	nasumicno=(rand()%n)+1;
	
	strcpy(moja_poruka.sadrzaj.tekst,s);
	moja_poruka.sadrzaj.pid=0;
	moja_poruka.sadrzaj.broj=nasumicno;
	moja_poruka.tip_poruke=nasumicno;
	moja_poruka.sadrzaj.ukupno=n;
	
	printf("Saljem poruku: tip:%ld, tekst_poruke: %s\n",moja_poruka.tip_poruke,moja_poruka.sadrzaj.tekst);
	msgsnd(id_reda,&moja_poruka,sizeof(moja_poruka.sadrzaj),0);
}

