#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<signal.h>
#include<unistd.h>
#include<errno.h>
#include<sys/shm.h>
#include<sys/sem.h>
#include<sys/types.h>
#include<sys/ipc.h>
#include<time.h>
union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};
int semid;
int *kosevi;
int *stalak;
int *brojLopti;

void signal_handler(int sig)
{
	printf("kos1 = %d\n",kosevi[0]);
	printf("kos2 = %d\n",kosevi[1]);
	printf("kos3 = %d\n",kosevi[2]);
	printf("kos4 = %d\n",kosevi[3]);
	exit(0);
}

int main()
{
	
	srand(time(NULL));
	key_t key=ftok("./igrac.c",'A');
	semid=semget(key,2,0666|IPC_CREAT|IPC_EXCL);
	union semun operacija_nad_sem;
	struct sembuf P,V,V2;
	int n;
	
	key_t kljuc=ftok("./redar.c",'Z');
	int shmid1=shmget(kljuc,sizeof(int),0666|IPC_CREAT);
	stalak=(int*)shmat(shmid1,(void*)0,0);
	*stalak=n;
	
	key_t klj=ftok("./redar.c",'B');
	int shmid2=shmget(klj,4*sizeof(int),0666|IPC_CREAT);
	kosevi=(int*)shmat(shmid2,(void*)0,0);
	
	if(semid!=-1)
	{
		printf("Ja kreiram semafor, ostali se samo kace\n");
		operacija_nad_sem.val=1;
		semctl(semid,0,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,1,SETVAL,operacija_nad_sem);
		
		kosevi[0]=0;
		kosevi[1]=0;
		kosevi[2]=0;
		kosevi[3]=0;
	}
	else if(errno==EEXIST)
	{
		printf("Ja se samo kacim\n");
		semid=semget(key,2,0);
	}
	else
	{
		printf("Neka druga greska\n");
		exit(1);
	}
	
	P.sem_num=0;
	P.sem_op=-1;
	P.sem_flg=0;
	
	V.sem_num=0;
	V.sem_op=1;
	V.sem_flg=0;
	
	int brojKosa;
	int daLiJePogodio;
	
	while(1)
	{
		semop(semid,&P,1);
		if(*stalak!=0)
		{
			printf("Igrac uzima loptu sa stalka\n");
			sleep(1);
		}
		else
		{
			printf("Na stalku nema vise lopti\n");
			semop(semid,&V2,1);
			semop(semid,&P,1);
			printf("Redar je dodao lopte\n");
		}	
		brojKosa=rand()%4;
		printf("Igrac baca loptu na kos broj:%d\n",brojKosa+1);
		*stalak--;
		
		daLiJePogodio=rand()%2;
		sleep(3);
		
		if(daLiJePogodio==1)
		{
			printf("Igrac je pogodio\n");
			kosevi[brojKosa]++;
		}
		else
		{
			printf("Igrac nije pogodio\n");
		}
		semop(semid,&V,1);		
	}
	
}
