#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid;
int shmid;
struct sembuf P_prvi,V_drugi;

#define P1 semop(semid,&P_prvi,1)
#define V2 semop(semid,&V_drugi,1)

union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void kraj(int sig)
{
	semctl(semid,0,IPC_RMID);	
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	
	shmctl(shmid,IPC_RMID,0);
}

int main()
{
	key_t key;	
	union semun poc;
	int *broj;
	srand(time(NULL));
	signal(SIGINT,kraj);
	
	key=ftok("./prvi.c",'A');
	shmid=shmget(key,sizeof(int),0666 | IPC_CREAT);
	
	key=ftok("./prvi.c",'B');
	semid=semget(key,3,0666 | IPC_CREAT | IPC_EXCL);
	
	
	if(semid!=-1)
	{
		poc.val=1;
		semctl(semid,0,SETVAL,poc);
		poc.val=0;	
		semctl(semid,1,SETVAL,poc);
		semctl(semid,2,SETVAL,poc);
	}else if(errno== EEXIST)
	{
		semid=semget(key,3,0);	
	}else
	{
		printf("Greska\n");
		exit(0);
	}
	
	broj=shmat(shmid,(void *)0,0);
	*broj=1;
	P_prvi.sem_num=0;
	P_prvi.sem_op=-1;
	P_prvi.sem_flg=0;
	
	V_drugi.sem_num=1;
	V_drugi.sem_op=2;
	V_drugi.sem_flg=0;
	
	int ind,i,j;
	i=1;
	j=0;
	while(1)
	{
		printf("Smanjujem semafor %d iz skupa %d za vrednos %d\n",P_prvi.sem_num+1,semid,P_prvi.sem_op);
		sleep(3);
		ind=P1;
		if(ind==-1) break;	
		while(1){
			if(i%3==0){
				printf("Ispisano je %d brojeva do sada\n",j);
				printf("%d\n",i);
				i++;
				j++;
				break;
			}
			i++;
		}
		printf("Povecavam semafor %d iz skupa %d za vrednos %d\n",V_drugi.sem_num+1,semid,V_drugi.sem_op);
		sleep(3);
		ind=V2;
		if(ind==-1) break;
	}
}
