#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};



int main()
{
	key_t kljuc=ftok("./prvi.c",'A');
	union semun arg;
	struct sembuf sem0,sem1,sem2;
	int i=4;
	int semid;
	
	semid=semget(kljuc,3,0644|IPC_CREAT);
	if(semid!=-1)
	{
		arg.val = 0;
		semctl(semid, 0, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 1, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 2, SETVAL, arg);
	}
	else if(errno==EEXIST)
		{
			semid=semget(kljuc,3,0);
		}
	else
		{
			printf("Greska/n");
			exit(0);
		}
	
	
	sem0.sem_num = 0;
	sem0.sem_op = 0;
	sem0.sem_flg = 0;
	
	sem1.sem_num = 1;
	sem1.sem_op = -2;
	sem1.sem_flg = 0;
	
	sem2.sem_num = 2;
	sem2.sem_op = 3;
	sem2.sem_flg = 0;
	
	while(1)
	{
		printf("Smanjujem semafor 1 za vrednost 2\n");
		sleep(3);
		semop(semid,&sem1,1);
		if(i%3==1) printf("%d\n",i);
		i+=3;
		if(i%3==1) printf("%d\n",i);
		i+=3;
		printf("Povecavam semafor 2 za vrednost 3\n");
		sleep(3);
		semop(semid,&sem2,1);
		
	}
	return 0;
}

