#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid;
int shmid;
union semun {
    int val;
    struct semid_ds *buf;
    ushort *array;
};

int main() {
    srand(time(NULL));
    // 0 - stala, 1 - stalak zauzet, 2 - pod
    key_t key = ftok("redar.c", 1);
    semid = semget(key, 7, 0);
    shmid = shmget(key,4*sizeof(int), 0);
    int[] kosevi = shmat(shmid, NULL, 0);

    if(shmid == -1) {
        printf("Error: Error getting shared memory! Trying to create queue!\n");
        exit(1);
    }

    if(semid == -1) {
        printf("Error: Error getting queue! Trying to create queue!\n");
    }
    
    struct sembuf P-stalak;
    P-stalak.sem_num = 0;
    P-stalak.sem_op = -1;
    P-stalak.sem_flg = 0;
    struct sembuf P-zauzet;
    P-zauzet.sem_num = 1;
    P-zauzet.sem_op = -1;
    P-zauzet.sem_flg = 0;
    struct sembuf P-pod;
    P-pod.sem_num = 2;
    P-pod.sem_op = -1;
    P-pod.sem_flg = 0;
    struct sembufint[] kosevi = shmat(shmid, NULL, 0); V-stalak;
    V-stalak.sem_num = 0;
    V-stalak.sem_op = 1;
    V-stalak.sem_flg = 0;
    struct sembuf V-zauzet;
    V-zauzet.sem_num = 1;
    V-zauzet.sem_op = 1;
    V-zauzet.sem_flg = 0;
    struct sembuf P-kos;
    P-kos.sem_num = 3;
    P-kos.sem_op = -1;
    P-kos.sem_flg = 0;
    struct sembuf V-kos;
    V-kos.sem_num = 3;
    V-kos.sem_op = 1;pod
    V-kos.sem_flg = 0;


    while(1) {
        printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", P-pod.sem_num, semid, P-pod.sem_op);
        sleep(3);
        semop(semid, &P-zauzet, 1);
        printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", P-zauzet.sem_num, semid, P-zauzet.sem_op);
        sleep(3);
        semop(semid, &P-stalak, 1);
        printf("Uzimam loptu\n");
        sleep(1);
        printf("Povecavam semafor %d iz skupa %d za vrednost %d\n", V-zauzet.sem_num, semid, V-zauzet.sem_op);
        sleep(3);
        semop(semid, &V-zauzet, 1);
        int kojikos = rand() % 4 + 1;
        sleep(3);
        int pogodak = rand() % 1 + 1;
        if(pogodak == 1) {
            if(kojikos == 1) {
                P-kos.sem_num = 3;
                V-kos.sem_num = 3;
                printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", P-kos.sem_num, semid, P-kos.sem_op);      
                semop(semid, &P-kos, 1);
                kosevi[0]++;
                printf("Kos br.%d = %d", 1, kosevi[0]);
                printf("Uvecavam semafor %d iz skupa %d za vrednost %d\n", V-kos.sem_num, semid, V-kos.sem_op);      
                semop(semid, &V-kos, 1);
            }
            else if(kojikos == 2) {
                P-kos.sem_num = 4;
                V-kos.sem_num = 4;
                printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", P-kos.sem_num, semid, P-kos.sem_op);        
                semop(semid, &P-kos, 1);
                kosevi[1]++;
                printf("Kos br.%d = %d", 2, kosevi[1]);
                printf("Uvecavam semafor %d iz skupa %d za vrednost %d\n", V-kos.sem_num, semid, V-kos.sem_op);      
                semop(semid, &V-kos, 1);
            }
            else if(kojikos == 3) {
                P-kos.sem_num = 5;
                V-kos.sem_num = 5;
                printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", P-kos.sem_num, semid, P-kos.sem_op);        
                semop(semid, &P-kos, 1);
                kosevi[2]++;
                printf("Kos br.%d = %d", 3, kosevi[2]);
                printf("Uvecavam semafor %d iz skupa %d za vrednost %d\n", V-kos.sem_num, semid, V-kos.sem_op);      
                semop(semid, &V-kos, 1);
            }
            else if(kojikos == 4) {
                P-kos.sem_num = 6;
                V-kos.sem_num = 6;
                printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n", P-kos.sem_num, semid, P-kos.sem_op);        
                semop(semid, &P-kos, 1);
                kosevi[3]++;
                printf("Kos br.%d = %d", 4, kosevi[3]);
                printf("Uvecavam semafor %d iz skupa %d za vrednost %d\n", V-kos.sem_num, semid, V-kos.sem_op);      
                semop(semid, &V-kos, 1);
            }
        }
    }
}