#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


int semid;

union semun {
    int val;
    struct semid_ds *buf;
    ushort *array;
};

void myhandler(int param) {
    printf("Brisem semafore!\n");
    semctl(semid, 0, IPC_RMID);
    semctl(semid, 1, IPC_RMID);
    semctl(semid, 2, IPC_RMID);
    exit(0);
}

int main() {
    signal(SIGINT, myhandler);
    key_t key = ftok("prvi.c", 1);
    semid = semget(key, 3, 0);

    if(semid == -1) {
        printf("Error semafor creation failed!\n");
        exit(0);
    }

    union semun arg;
    struct sembuf P;
    P.sem_num = 1;
    P.sem_op = -1;
    P.sem_flg = 0;
    struct sembuf V;
    V.sem_num = 0;
    V.sem_op = 1;
    V.sem_flg = 0;

    int i = 1;
    int brojIspisa = 0;
    int ind = 0;
    while(1) {
        if(i % 3 == 1) {
            printf("Drugi: Smanjujem semafor %d iz skupa %d za vrednost %d\n", 1, semid, -1);
            sleep(3);
            semop(semid, &P, 1);
            ind++;
            printf("Drugi: %d\n", i);
            brojIspisa++;
            printf("Drugi: Broj ispisa do sada: %d\n", brojIspisa);
            V.sem_num = 2;
            if(ind == 2) {
                printf("Drugi: Povecavam semafor %d iz skupa %d za vrednost %d\n", 2, semid, 1);
                sleep(3);
                semop(semid, &V, 1);
                ind = 0;
            }
        }
        i++;
    }
}