#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int shmid, semid, *data;

void signalHandler(int sig){
    printf("BRISEM SVE\n");
    shmdt(data);
    shmctl(shmid, IPC_RMID, NULL);
    semctl(semid, 0, IPC_RMID);
    semctl(semid, 1, IPC_RMID);
    semctl(semid, 2, IPC_RMID);
}

union semun{
    int val;
    struct semid_ds *baf;
    ushort *array;
};

int main(){
    signal(SIGINT, signalHandler);
    key_t kljuc;
    union semun sem_prom;
    struct sembuf P, V;
    int semafor, brojac = 0;
    int br, vrti;
    
    kljuc = ftok("./prvi.c", 45);
    shmid = shmget(kljuc, sizeof(int) * 2, IPC_CREAT| IPC_EXCL | 0644 );

    if(shmid != -1){
        printf("Ne postoji deljena memorija..Ja je pravim\n");
        data = shmat(shmid, NULL, 0);
        data[0] = 1;
        data[1] = 1;
        data[2] = 1; 
    }
    else if(errno == EEXIST){
        printf("Postoji memorija..Nadovezujem se\n");
        shmid = shmget(kljuc, sizeof(int) * 2, 0);
        data = shmat(shmid, NULL, 0);
    }
    else{
        printf("ERROR\n");
        exit(0);
    }

    kljuc = ftok("./prvi.c", 49);
    semid = semget(kljuc, 3, IPC_CREAT| IPC_EXCL | 0644);

    if(semid != -1){
        printf("Ne postoji semafor..Ja je pravim\n");
        sem_prom.val = 1;
        semctl(semid, 0, SETVAL, sem_prom);
        sem_prom.val = 0;
        semctl(semid, 1, SETVAL, sem_prom);
        semctl(semid, 2, SETVAL, sem_prom);
    }
    else if(errno == EEXIST){
        printf("Postoji semafori..Nadovezujem se\n");
        semid = semget(kljuc, 3, 0);
    }

    P.sem_num = 2;
    P.sem_op = -1;
    P.sem_flg = 0;
    //printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n",P.sem_num,semid, P.sem_op);

    V.sem_num = 0;
    V.sem_op = 1;
    V.sem_flg = 0;
    //printf("Povecavam semafor %d iz skupa %d za vrednost %d\n",V.sem_num,semid, V.sem_op);

    while(1){

        
        printf("Smanjujem semafor %d iz skupa %d za vrednost %d\n",P.sem_num, semid,P.sem_op);
        sleep(3);
        semafor = semop(semid,&P,1);
        if(semafor == -1) break;
        vrti = 0;
        printf("Bilo je %d ispisa\n",brojac);
        while(vrti == 0){
            if(data[2] % 3 == 2){
                printf("%d\n",data[2]);
                brojac++;
                data[2]++;
                vrti = 1;
            }
            else
                data[2]++;
        }
        printf("Povecavam semafor %d iz skupa %d za vrednost %d\n",V.sem_num, semid,V.sem_op);
        sleep(3);
        semafor = semop(semid,&V,1);
        if(semafor == -1) break;
        //sleep(5);
    }

    shmdt(data);
}