#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main()
{
	int semid;
	key_t kljuc;
	struct sembuf prvi,treci;
	union semun oper;
	
	kljuc = ftok("./stalak.c",'A');
	semid = semget(kljuc,3,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid != -1)
	{
		oper.val = 1;
		semctl(semid,0,SETVAL,oper);
		oper.val = 0;
		semctl(semid,1,SETVAL,oper);
		oper.val = 0;
		semctl(semid,2,SETVAL,oper);
	}
	else if(errno == EEXIST)
	{
		semid = semget(kljuc,3,0);
	}
	else
	{
		printf("Greska\n");
		exit(0);
	}
	
	prvi.sem_num = 0;
	prvi.sem_op = 1;
	prvi.sem_flg = 0;
	
	treci.sem_num = 2;
	treci.sem_op = -2;
	treci.sem_flg = 0;
	
	int i = 2;
	int brojac = 0;
	
	while(1)
	{
		printf("Smanjujem semafor tri iz grupe %d za vrednost 2\n",semid);
		sleep(3);
		semop(semid,&treci,1);
		if(i % 3 == 2)
		{
			printf("%d\n",i);
			brojac++;
		}
		printf("Brojac:%d\n",brojac);
		sleep(3);
		i += 3;
		printf("Povecavam semafor jedan iz grupe %d za vrednost 1\n",semid);
		semop(semid,&prvi,1);
	}
}
