#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/msg.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/shm.h>

union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

typedef struct pomoc{
	long tip;
	int odkojeg;
}pomoc;

int msgid;
int semid;
pid_t ppid=-1; //parent pid
pid_t dete=-1;

void sighandler(int sig){
	pomoc pom;
	if(getpid()==ppid){
		//roditelj
		kill(dete, SIGKILL);
		semctl(semid, 0, IPC_RMID);
		semctl(semid, 1, IPC_RMID);
		semctl(semid, 2, IPC_RMID);
		semctl(semid, 3, IPC_RMID);
		semctl(semid, 4, IPC_RMID);
		semctl(semid, 5, IPC_RMID);
		semctl(semid, 6, IPC_RMID);
		semctl(semid, 7, IPC_RMID);
		semctl(semid, 8, IPC_RMID);
		exit(0);
	}
	else{
		//dete
		printf("Roditelj 1 trazi pomoc ...\n");
		int igracid=rand()%4;
		pom.tip=igracid;
		pom.odkojeg=1;
		printf("Saljem poruku, tip %d\n", igracid);
		msgsnd(msgid, &pom, sizeof(pom), 0);
	}
}

int main(){
	int *data;
	ppid=getpid();
	key_t kljuc= ftok("./inic.c", 'a');
	semid=semget(kljuc, 9, IPC_CREAT|IPC_EXCL|0666);
	int shmid=shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	key_t kljucmsg=ftok("./igrac1.c", 'x');
	msgid=msgget(kljucmsg, 0);
	union semun arg;
	struct sembuf ig2S, kosP, stalakS, ig3P;
	if(semid != -1){
		//semafor nije postojao
		arg.val=0;
		semctl(semid, 0, SETVAL, arg); //igrac1
		semctl(semid, 1, SETVAL, arg); //igrac2
		semctl(semid, 2, SETVAL, arg); //igrac3
		semctl(semid, 3, SETVAL, arg); //igrac4
		semctl(semid, 4, SETVAL, arg); //kos1
		semctl(semid, 5, SETVAL, arg); //kos2
		semctl(semid, 6, SETVAL, arg); //kos3
		semctl(semid, 7, SETVAL, arg); //kos4 
		semctl(semid, 8, SETVAL, arg); //stalak
	}
	else if(errno == EEXIST) 
		semid=semget(kljuc, 9, 0);
	else { printf("Neka druga greska\n"); exit(0); }
	printf("Kljuc: %d, Semid %d\n", kljuc, semid);
	data=shmat(shmid, NULL, 0);
	//
	signal(SIGINT, sighandler);
	//
	int kos;
	printf("Unesi ID kosa na koji igrac suta(0,1,2,3): \n");
	scanf("%d", &kos); getchar(); //posle kao argument
	//
	ig2S.sem_num=1;
	ig2S.sem_op=-1;
	ig2S.sem_flg=0;
	
	stalakS.sem_num=8;
	stalakS.sem_op=-1;
	stalakS.sem_flg=0;
	
	kosP.sem_num=kos;
	kosP.sem_op=1;
	kosP.sem_flg=0;
	
	ig3P.sem_num=2;
	ig3P.sem_op=1;
	ig3P.sem_flg=0;
	//
	dete=fork();
	int brojkoseva, sansa, promasaji=0;
	switch(dete){
		case -1: 
			printf("Neka druga greska\n");
			exit(0);
		case 0:
			//dete u while-u svakih 10 ispisuje statistiku
			while(1){
				sleep(10);
				brojkoseva = semctl(semid, kos, GETVAL);
				printf("Igrac 2, ubacenih koseva: %d\n", brojkoseva);
			}
			break;
		default:
			while(1){
				semop(semid, &ig2S, 1);
				semop(semid, &stalakS, 1); // dal ima slobodnih lopti , ako da uzima jednu
				sleep(1); //uzima loptu sa stalka
				//TODO: ako je neko drugi zatrazio pomoc suta na njegov kos .
				sleep(3);
				sansa=rand()%2;
				if(sansa==1){ // pogodak
					semop(semid, &kosP, 1);
					promasaji=0;
				}
				else
					promasaji++;
				if(promasaji==2)
					kill(dete, SIGINT);
				sleep(5);
				printf("[IGRAC 2]: Pustam igraca 3\n");
				semop(semid, &ig3P, 1);
			}
			//roditelj
	}
}








