#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <sys/msg.h>
#include <unistd.h>
#include <errno.h>

union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int main(){
	int *data;
	key_t kljuc= ftok("./inic.c", 'a');
	int semid=semget(kljuc, 9, IPC_CREAT|IPC_EXCL|0666);
	int shmid=shmget(kljuc, sizeof(int), IPC_CREAT|0666);
	union semun arg;
	struct sembuf ig1P, ig2P, ig3P, ig4P, stalakP;
	if(semid!=-1){
		//semafor nije postojao
		arg.val=0;
		semctl(semid, 0, SETVAL, arg); //igrac1
		semctl(semid, 1, SETVAL, arg); //igrac2
		semctl(semid, 2, SETVAL, arg); //igrac3
		semctl(semid, 3, SETVAL, arg); //igrac4
		semctl(semid, 4, SETVAL, arg); //kos1
		semctl(semid, 5, SETVAL, arg); //kos2
		semctl(semid, 6, SETVAL, arg); //kos3
		semctl(semid, 7, SETVAL, arg); //kos4 
		semctl(semid, 8, SETVAL, arg); //stalak -- ISKORISTI KAO SEMAFOR ZA DELJENU
	}
	else if(errno == EEXIST) { semid=semget(kljuc, 9, 0); }
	else { printf("Neka druga greska\n"); exit(0); }
	printf("Kljuc: %d, Semid %d\n", kljuc, semid);
	
	data=shmat(shmid, NULL, 0);

	int n,stalakstat=0;
	printf("UNESI broj lopti:\n");
	scanf("%d", &n); getchar(); 
	*data=n;
	//
	stalakP.sem_num=8;
	stalakP.sem_op=1;
	stalakP.sem_flg=0;
	
	ig1P.sem_num=0;
	ig1P.sem_op=1;
	ig1P.sem_flg=0;
	//
	semop(semid, &stalakP, n); // n puta uvecaj stalak za 1
	sleep(10);
	printf("Pustam igraca 1!!\n");
	semop(semid, &ig1P, 1);
	while(1){ //redar vraca lopte
		stalakstat=semctl(semid, 8, GETVAL);
		if(stalakstat<n){
			sleep(2);
			semop(semid, &stalakP, 1);
			printf("Redar vraca loptu\n");
		}
		sleep(10); // da ne baguje mnogo , neka proverava svakih 10
	}
}








