#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct{
    long tip;
    int rbr, uk;
    char text[100];
    pid_t pid;
}PORUKA;

int main(){
    srand(time(NULL));

    int n, rbr=1, i;
    key_t key;
    int red;
    PORUKA primljena, poslata;
    char uneta_poruka[100];

    n = rand()%20;

    key = ftok("./server.c", 65);
    red = msgget(key, IPC_CREAT | 0666);

    for(i=0; i<n; i++){
        //sacekaj da se klijent javi
        msgrcv(red, &primljena, sizeof(primljena), 0, 0);
        poslata.tip = primljena.tip;
        rbr++; 
        //posalji klijentu njegov redni broj - to postaje njegov tip poruke
        poslata.rbr = rbr;
        msgsnd(red, &poslata, sizeof(poslata), 0);
    }

    poslata.uk = n;
    for(i=0; i<n; i++){
        poslata.tip = i+1;
        //obavestava klijente da su se svi prijavili
        msgsnd(red, &poslata, sizeof(poslata), 0);
    }

    poslata.tip = (rand()%n)+1;
    //posalji nekom klijentu poruku da on moze dalje da salje
    printf("Uneti poruku: ");
    scanf("%s", uneta_poruka);
    strcpy(poslata.text, uneta_poruka);
    printf("Saljem poruku %ld '%s'.\n", poslata.tip, poslata.text);
    msgsnd(red, &poslata, sizeof(poslata), 0);

    
    msgctl(red, IPC_RMID, NULL);
}