#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


pid_t dete;

void sigDete(int sig){
	printf("Dete: Prekinuo me je process roditelj.\n");
	kill(SIGKILL, getppid());
	exit(0);
}
void sigRoditelj(int sig){
	printf("Roditelj: prekinuo me je process dete\n");
	kill(SIGKILL, dete);
	exit(0);
}

int main(){
	int i, n;
	srand(time(0));
	dete = fork();
	srand(time(0));
	if( dete == 0) //dete
	{
		signal(SIGINT, sigDete);
		n = rand()%20;
		printf("dete ispisuje do %d\n", n);
		for(i = 1; i < n; i++)
		{
			printf("Dete: %d\n", i);
			sleep(2);
		}
		kill(getppid(), SIGINT);
	}
	else
	{
		signal(SIGINT, sigRoditelj);
		n = rand()%20;
		printf("roditelj ispisuje do %d\n", n);
		for(i = 1; i < n; i++)
		{
			printf("Roditelj: %d\n", i);
			sleep(2);
		}
		kill(dete, SIGINT);		
	}
	// komentar: %20 stavljen da bi se program zavrsio za manje vremen
	return 0;
}
