#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define PRIJAVA 21

int idReda;

struct poruka{
	long tip;
	int pid;
	char str[50];
};

void sighandler(int sig){
	printf("uhvacen signal\n");
	msgctl(idReda, IPC_RMID, NULL);
	exit(0);
}

int main(){
	srand(time(NULL));
	key_t kljuc;
	struct poruka p;
	int brKl, rb, ind;
	
	signal(SIGINT, sighandler);	

	kljuc = ftok("server.c", 24);
	idReda = msgget(kljuc, IPC_CREAT|0666);
	
	p.tip = PRIJAVA;
	p.pid = getpid();
	ind = msgsnd(idReda, &p, sizeof(p), 0);
	if(ind == -1)
		exit(0);
	ind = msgrcv(idReda, &p, sizeof(p), getpid(), 0);
	if(ind == -1)
		exit(0);
	rb = p.pid;
	ind = msgrcv(idReda, &p, sizeof(p), rb, 0);
	if(ind == -1)
		exit(0);
	brKl = p.pid;
	
	while(1)
	{
		printf("Cekam poruku: tip %d\n", rb);
		ind = msgrcv(idReda, &p, sizeof(p), rb, 0);
		if(ind == -1)
			exit(0);
		p.tip = rand()% brKl + 1;
		while( p.tip == rb)
			p.tip = rand()% brKl + 1;
		printf("Primljena poruka: %s\n", p.str);
		printf("unesi poruku: ");
		scanf("%s", p.str);
		printf("Saljem poruku: tip: %ld, tekst: %s\n", p.tip, p.str);
		ind = msgsnd(idReda, &p, sizeof(p), 0);
		if(ind == -1)
			exit(0);	
	}
	return 0;
}
