#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define MAX 4 // max je N (do 20), ako se definise, a ako se unosi, onda u scanfu na pocetku programa
#define PRIJAVA 21 // prijava moze i MAX + 1

int idReda;

struct poruka{
	long tip;
	int pid;
	char str[50];
};

void sighandler(int sig){
	//printf("uhvacen signal\n");
	msgctl(idReda, IPC_RMID, NULL);
	exit(0);
}

int main(){
	srand(time(NULL));
	key_t kljuc;
	int brKlijenata = 1, i, ind;
	struct poruka p;
	kljuc = ftok("server.c", 24);
		
	signal(SIGINT, sighandler);
	
	idReda = msgget(kljuc, IPC_CREAT|0666);
	
	while(brKlijenata < MAX + 1){
		ind = msgrcv(idReda, &p, sizeof(p), PRIJAVA, 0);
		if(ind == -1)
			exit(0);
		p.tip = p.pid;
		p.pid = brKlijenata;
		ind = msgsnd(idReda, &p, sizeof(p), 0);
		if(ind == -1)
			exit(0);
		brKlijenata++;
	}
	p.pid = brKlijenata - 1;
	for(i = 1; i <= brKlijenata; i++)
	{
		p.tip = i;
		ind = msgsnd(idReda, &p, sizeof(p), 0);
		if(ind == -1)
			exit(0);
	}
	
	p.tip = rand()%(brKlijenata - 1) + 1;
	printf("unesi poruku: ");
	scanf("%s", p.str);
	printf("Saljem poruku: tip: %ld, tekst: %s\n", p.tip, p.str);
	ind = msgsnd(idReda, &p, sizeof(p), 0);	
	if(ind == -1)
			exit(0);		
	return 0;
}
