#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define n 3

struct poruka
{
	long tip;
	char sadrzaj[20];
	int rbr;
	int ukupno;
};

int idreda;

void hend(int sig)
{
	printf("\nSignal\n");
	msgctl(idreda, IPC_RMID, NULL);
	exit(0);
}

int main()
{ 
	signal(SIGINT, hend);
	key_t kljuc=ftok("./server.c", 63);
	idreda=msgget(kljuc, IPC_CREAT|0666);
	long ind,i;
	struct poruka por;
	
	for(i=0; i<n; i++)
	{
		printf("Cekam poruku za prijavu tip= 21\n");
		msgrcv(idreda, &por, sizeof(por), 21, 0);
		printf("Primio poruku za prijavu tip= 21\n\n");
		
		por.tip=22;
		por.rbr=i+1;
		
		printf("Saljem poruku o rednom broju tipu: %ld\n", por.tip);
		msgsnd(idreda, &por, sizeof(por), 0);
		printf("Poslao poruku tipa: %ld\n\n", por.tip);
		
	}
	
	printf("SVI SU PRIJAVLJENI\n\n");
	
	por.ukupno=n;
	
	for(i=0; i<n; i++)
	{
		por.tip=i+1;
		printf("Saljem poruku o ukupnom broju broju tip: %ld\n\n", por.tip);
		msgsnd(idreda, &por, sizeof(por), 0);
		printf("Poslao poruku tipu: %ld\n\n", por.tip);
	}
	
	
	printf("Unesi poruku: \n");
	fgets(por.sadrzaj, 1024, stdin);
	
	ind=rand()%n+1;
	por.tip=ind;
	
	printf("Saljem sadrzaj %s tipu: %ld\n", por.sadrzaj, por.tip);
	msgsnd(idreda, &por, sizeof(por), 0);
	printf("Poslao poruku tipa: %ld\n\n", por.tip);

}
