#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int idD = -2;
int idR = -2;

void pom(int sig) {
	int pom = getpid();
	if(pom == idD) {
		printf("Prekinuo me je proces roditelj. \n");
		exit(0);
	} else if (pom == idR) {
		printf("Prekinuo me je proces dete. \n");
		exit(0);
	}
}

int main() {
	long int n;
	int i;
	pid_t p;
	p = fork();
	signal(SIGINT, pom);

	if (p == 0) {
		idD = p;
		// n = rand()%20;
		// n = srand(time(NULL));
		n = 7;
		printf("%ld \n", n);
		for(i = 0; i<n; i++) {
			printf("Proces dete, broj = %d \n", i);
			if( i == n-1) {
				kill(getppid(), SIGINT);
			}
			sleep(2);
		}
	} else if( p == -1 ) {
		printf("Greska!");
	} else {
		idR = getpid();
		// n = rand()%20;
		// n = srand(time(NULL));
		n = 5;
		printf("%ld \n", n);
		for(i = 0; i<n; i++) {
			printf("Proces roditelj, broj = %d \n", i);
			if( i == n-1) {
				kill(p, SIGINT);
			}
			sleep(2);
		}
	}
	
	return 0;
}
