#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct mojaPoruka
{
	long tip;
	int pid;
	int redniBroj;
	int ukupanBroj;
	char text[50];
};

int main()
{
	int i,rb,N;
	key_t kljuc;
	int red;
	struct mojaPoruka poruka;
	
	kljuc=ftok("server.c",65);
	
	red=msgget(kljuc,IPC_CREAT|0666);
	
	poruka.tip=99;
	poruka.pid=getpid();
	printf("Saljem poruku: tip %ld,pid %d\n",poruka.tip,poruka.pid);
	msgsnd(red,&poruka,sizeof(poruka),0);
	printf("Primam poruku: tip %d\n",getpid());
	msgrcv(red,&poruka,sizeof(poruka),getpid(),0);
	printf("Primio sam: tip %ld,pid %d,rednibroj %d,ukupan broj %d\n",poruka.tip,poruka.pid,poruka.redniBroj,poruka.ukupanBroj);
	
	rb=poruka.redniBroj;
	N=poruka.ukupanBroj;
	
	while(1)
	{
		printf("Primam poruku: tip %d\n",rb);
		msgrcv(red,&poruka,sizeof(poruka),rb,0);
		printf("Primio sam: tip %ld,pid %d,rednibroj %d,ukupan broj %d,tesktporuke %s\n",poruka.tip,poruka.pid,poruka.redniBroj,poruka.ukupanBroj,poruka.text);
		i=(rand()%N)+1;
		while(i==rb)
		{
			i=(rand()%N)+1;
		}
		printf("Unesi tekst poruke:\n");
		scanf("%s",poruka.text);
		poruka.tip=i;
		printf("Saljem poruku: tip %ld,tekst poruke %s\n",poruka.tip,poruka.text);
		msgsnd(red,&poruka,sizeof(poruka),0);
	}
}
