#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>


/*
Napisati programe server.c i klijent.c. Server čeka da mu se prijavi N klijenata (N je broj
manji od 20). Svakom klijentu, u zavisnosti od redosleda prijavljivanja, prosleđuje se redni broj (od
1 do N). Nakon završene prijave, server sve klijente obaveštava o ukupnom broju prijavljenih
klijenata, unosi poruku sa standardnog ulaza i šalje je slučajno odabranom klijentu. Klijent koji primi
poruku ponovo na slučajan način određuje drugog klijenta kome šalje poruku. Klijent sam sebi ne
sme poslati poruku. Sve poruke koje razmenjuju klijenti se unose sa standardnog ulaza.
Važna napomena: Pre svakog slanja poruke staviti printf(“Saljem poruku X”). Pre svakog primanja poruke
staviti printf(“Cekam poruku X”), gde X celokupan sadržaj poruke razdvojen po poljima.
Primer poruke pre slanja : “Saljem poruku : tip 1, tekst_poruke Zdravo.
*/

struct mojaPoruka
{
	long tip;
	int pid;
	int redniBroj;
	int ukupanBroj;
	char text[50];
};
int main()
{
	int N,i;
	int red;
	key_t kljuc;
	struct mojaPoruka poruka;
	
	kljuc=ftok("server.c",65);
	
	red=msgget(kljuc,IPC_CREAT|0666);
	
	N=(rand()%20)+1;
	//N=4;
	for(i=0;i<N;i++)
	{
		printf("Primam poruku: tip 99\n");
		msgrcv(red,&poruka,sizeof(poruka),99,0);
		printf("Primio sam: tip %ld",poruka.tip);
		poruka.tip=poruka.pid;
		poruka.redniBroj=i+1;
		poruka.ukupanBroj=N;
		printf("Saljem poruku: tip %ld,redni broj %d,ukupan broj klijenta %d\n",poruka.tip,i+1,N);
		msgsnd(red,&poruka,sizeof(poruka),0);
	}
	printf("Unesi tekst poruke:\n");
	scanf("%s",poruka.text);
	poruka.tip=(rand()%N)+1;
	printf("Saljem poruku: tip %ld,redni broj %d,tekst %s\n",poruka.tip,poruka.redniBroj,poruka.text);
	msgsnd(red,&poruka,sizeof(poruka),0);
	
	exit(0);
}
