#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

struct msgbuf
{
    long mtype; // tip poruke
    pid_t pid;
    int numberOfClients;
    int rednibroj;
    char mtext[100];
};

void my_handler(int sig) {
    
}


int main() {
    srand(time(NULL));
    struct msgbuf my_message;
    my_message.mtype = 0;
    my_message.pid = getpid();
    my_message.numberOfClients = 0;
    char mtext[100];
    
    key_t key = ftok("server.c", 1);
    int queueID = msgget(key, 0);

    if(queueID == -1) {
        printf("CLient: Error with queue! Exit!\n");
    }

    msgsnd(queueID, &my_message, sizeof(my_message), 0);
    printf("Poslao poruku: mtype = %ld, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", my_message.mtype, my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
    printf("Cekam poruku: mtype = %d, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", getpid(), my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
    msgrcv(queueID, &my_message, sizeof(my_message), getpid(), 0);
    printf("Primio poruku: mtype = %ld, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", my_message.mtype, my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
    int rednibroj = my_message.rednibroj;
    while(1) {
        printf("Cekam poruku: mtype = %d, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", rednibroj, my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
        msgrcv(queueID, &my_message, sizeof(my_message), rednibroj, 0);
        printf("Primio poruku: mtype = %ld, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", my_message.mtype, my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
        int sendTo = 0;
        do {
            sendTo = rand() % my_message.numberOfClients + 1;
        }while(sendTo == rednibroj);

        scanf("%s", my_message.mtext);
        my_message.mtype = sendTo;
        msgsnd(queueID, &my_message, sizeof(my_message), 0);
        printf("Poslao poruku: mtype = %ld, pid = %d, numberOfClients = %d, rednibroj = %d, mtext = %s", my_message.mtype, my_message.pid, my_message.numberOfClients, my_message.rednibroj, my_message.mtext);
    }

    msgctl(queueID, IPC_RMID, NULL);
}

