#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka{
    long tip;
    long pid;
    char tekst[100];
    int rbr;
    int ukupno;
}poruka;

int main(){
    srand(time(NULL));
    key_t kljuc;
    int redid;
    int i, broj, ukupno;

    kljuc = ftok("./server.c",45);
    redid = msgget(kljuc,IPC_CREAT | 0666);

    struct poruka p;
    p.pid = getpid();
    p.tip = 22;
    
    printf("Prijavljujem se na server \n");
    msgsnd(redid, &p, sizeof(p), 0);

    msgrcv(redid, &p, sizeof(p), getpid(), 0);
    broj = p.rbr;
    ukupno = p.ukupno;
    printf("Moj redni broj je %d\n",broj);
    printf("Ukupno ima %d klijenata \nCekam poruku tip: %d, \n", ukupno, broj);
    while(1){
        msgrcv(redid, &p, sizeof(p), broj, 0);
        printf("tekst poruke %s\n", p.tekst);

        p.tip = rand() % ukupno + 1;
        if(p.tip == broj)
            p.tip = rand() % ukupno + 1;
        if(p.tip == broj)
            p.tip = rand() % ukupno + 1;
        
        printf("Unesi poruku: ");
        scanf("%s", p.tekst);
        
        printf("Saljem poruku tip: %ld, tekst poruke  %s\n",p.tip, p.tekst);
        msgsnd(redid, &p, sizeof(p), 0);
        printf("\nCekam poruku tip: %d, \n",broj);
    }

    return 0;
}