#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

pid_t pompid;

void signalPrvi(int sig){
    printf("Dete: Prekinuo me proces roditelj \n");
    exit(0);
}

void signalDrugi(int sig){
    printf("Roditelj: Prekinuo me proces dete \n");
    exit(0);
}

int main(){
    
    pid_t pid;
    int nd, nr, i;
    pid = fork();
    switch(pid){
        case -1:
            printf("Exit\n");
            exit(0);
        case 0:
            pompid = getpid();
            signal(SIGINT, signalPrvi);
            srand(time(NULL));
            nd = rand() % 20;
            printf("Dete ide do %d\n",nd);
            for(i = 0; i < nd; i++){
                printf("Dete %d\n",i);
                sleep(2);
            }
            kill(getpid(), SIGINT);
            exit(0);
        default:
            signal(SIGINT, signalDrugi);
            srand(time(NULL));
            nr = rand() % 20;
            printf("Roditelj ide do %d\n",nr);
            for(i = 0; i < nr; i++){
                printf("Roditelj: %d\n",i);
                sleep(2);
            }
            kill(pid, SIGINT);
            exit(0);
    }

}
