#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef struct poruka{
    long tip;
    long pid;
    char tekst[100];
    int rbr;
    int ukupno;
}poruka;

int main(){
    srand(time(NULL));
    key_t kljuc;
    int redid;
    int n, i, br = 0;
    printf("Broj klijenata: ");
    scanf("%d",&n);

    kljuc = ftok("./server.c",45);
    redid = msgget(kljuc,IPC_CREAT | 0666);

    struct poruka p;
    
    //LOGOVANJE i UKUPAN BROJ
    for(i = 0; i < n; i++){
        msgrcv(redid, &p, sizeof(p), 22, 0);
        p.tip = p.pid;
        p.rbr = i + 1;
        p.ukupno = n;
        printf("Logovan klijent %d\nSaljem redni broj klijentu %d\n",i + 1, i + 1);
        msgsnd(redid, &p, sizeof(p), 0);
    }

    //SLUCAJNO SLANJE PORUKE
    p.tip = rand() % n + 1;
    printf("Unesi poruku: ");
    scanf("%s", p.tekst);
    printf("Saljem poruku tip: %ld, tekst poruke  %s\n",p.tip, p.tekst);
    msgsnd(redid, &p, sizeof(p), 0);

    return 0;
}