#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
#include <time.h>

pid_t pRoditelja;
pid_t pDeteta;

void Dsighand(int sig){
	printf("Dete: Prekinuo me je proces roditelj.\n");
	exit(0);
}

void Rsighand(int sig){
	printf("Roditelj: Prekinuo me je proces dete.\n");
	exit(0);
}

int main(){
	
	int i,n;
	pDeteta= fork();
	if (pDeteta==0){
		pRoditelja= getppid();
		signal(SIGINT, Dsighand);
		srand(time(0));
		n= rand()%20;
		printf("Dete ispisuje do: %d\n",n);
		sleep(2);		
		for(i=1;i<=n;i++){
			printf("Dete: %d\n", i);
			if(i!=n)
				sleep(2);
		}
		kill(pRoditelja,SIGINT);
	}
	else{
		pRoditelja= getpid();
		signal(SIGINT, Rsighand);
		n= rand()%20;
		printf("Roditelj ispisuje do: %d\n",n);
		sleep(2);
		for(i=1;i<=n;i++){
			printf("Roditelj: %d\n", i);
			if(i!=n)
				sleep(2);
		}
		kill(pDeteta, SIGINT);
	}

return 0;
}
