#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
#include <time.h>

struct poruka{
	long tip;
	int rb;
	int ukupanBr;
	char str[50];
};

int idReda;

void sighandler(int sig){
	printf("uhvacen sigint.\n");
	msgctl(idReda, IPC_RMID, NULL);
	exit(0);
}

int main(){
	key_t kljuc;
	int i,n,trenTip,redniBroj;
	struct poruka p;
	srand(time(0));
		
	signal(SIGINT, sighandler);
	kljuc=ftok("./server.c",42);
	idReda= msgget(kljuc, IPC_CREAT|0666);
	
	p.tip= 21;
	p.rb= getpid();
	msgsnd(idReda, &p, sizeof(p), 0);
	printf("Poslao prijavu.\n");
	msgrcv(idReda, &p, sizeof(p), getpid(), 0);
	printf("Uspesno prijavljen.\n");
	redniBroj= p.rb;

	while(1){
	printf("\nProces %d ceka poruku: tip %d.\n", getpid(), redniBroj);	
	msgrcv(idReda, &p, sizeof(p), redniBroj, 0);
	printf("Primio sam poruku: tip %ld, tekst_poruke %s.\nunesite poruku za slanje: " , p.tip, p.str);
	scanf("%s", p.str);
	trenTip= p.tip;
	p.tip= rand()%p.ukupanBr+1;
	while(p.tip == trenTip)
		p.tip= rand()%p.ukupanBr+1; 	
	printf("Saljem poruku: tip %ld, tekst_poruke %s.\n", p.tip, p.str);	
	msgsnd(idReda, &p, sizeof(p), 0);
	}

return 0;
}
