#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
#include <time.h>

struct poruka{
	long tip;
	int rb;
	int ukupanBr;
	char str[50];
};

int idReda;

void sighandler(int sig){
	printf("uhvacen sigint.\n");
	msgctl(idReda, IPC_RMID, NULL);
	exit(0);
}

int main(){
	key_t kljuc;
	int i,n;
	struct poruka p;

	signal(SIGINT, sighandler);
	kljuc=ftok("./server.c",42);
	idReda= msgget(kljuc, IPC_CREAT|0666);
	srand(time(0));	

	n= rand()%20+1;
	printf("Pocinjem sa unosom %d klijenata.\n", n);
	for(i=1;i<=n;i++){
		msgrcv(idReda, &p, sizeof(p), 21, 0);	
		p.tip= p.rb;
		p.rb= i;
		p.ukupanBr= n;
		msgsnd(idReda, &p, sizeof(p), 0);
		sleep(2);
		printf("Prijavljen %d. klijent.\n", i);
	}

	printf("\nServer: Unesite poruku za slanje: ");
	p.tip= rand()%n+1;
	scanf("%s", p.str);
	printf("Server: Saljem poruku: tip %ld, tekst_poruke %s\n", p.tip, p.str);
	msgsnd(idReda, &p, sizeof(p), 0);
	printf("Server: Zavrsavam sa radom.\n");

return 0;
}
