#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <time.h>

typedef struct poruka{
	long tip;
	char tekst[100];
}Poruka;

int main(){
	key_t kljuc;
	int msgid;
	int prijava;
	int t, n;
	Poruka p;
	
	srand(time(NULL));
	
	kljuc = ftok("./server.c", 'A');
	msgid = msgget(kljuc, 0666|IPC_CREAT);
	
	
	p.tip = 1;
	p.tekst[0] = '\0';
	msgsnd(msgid, &p, sizeof(p), 0);
	printf("Saljem poruku: tip %ld, tekst %s\n", p.tip, p.tekst);
	
	
	msgrcv(msgid, &p, sizeof(p), 0, 0);
	prijava = p.tip;
	printf("Primljena poruka: tip %d, tekst %s\n", prijava, p.tekst);
	
	msgrcv(msgid, &p, sizeof(p), prijava, 0);
	n = p.tekst[0];
	printf("Primljena poruka: tip %ld, tekst %d\n", p.tip, p.tekst[0]);
	printf("Ukupno prijavljenih %d\n", n);
	
	t = rand() % n;
	while(t == prijava){
		t = rand() % n;
	}
	
	printf("Unesi poruku\n");
	fgets(p.tekst, sizeof(p.tekst), stdin);
	
	p.tip = t;
	msgsnd(msgid, &p, sizeof(p), 0);
	printf("Saljem poruku: tip %ld, tekst %s\n", p.tip, p.tekst);
	
	
	msgrcv(msgid, &p, sizeof(p), 0, 0);
	printf("Primljena poruka: tip %ld, tekst %s\n", p.tip, p.tekst);
	
	return 0;
}
